package de.uniwue.mk.kall.athen.annotationbrowserwidget;

import org.eclipse.jface.viewers.TreeViewer;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;

import de.uniwue.mk.kall.athen.widget.editor.AnnotationEditorWidget;

public class AnnotationBrowserWidget extends Composite {

	private AnnotationEditorWidget editor;

	private TreeViewer viewer;

	private Label labelSearchTypes;
	private Label labelSearchAnnotations;

	private Text textSearchTypes;
	private Text textSearchAnnotations;

	public AnnotationBrowserWidget(Composite parent, AnnotationEditorWidget editor) {
		super(parent, SWT.BORDER);
		this.editor = editor;
		createControls();
	}

	public void createControls() {
		setLayout(new GridLayout(2, false));
		setLayoutData(new GridData(GridData.FILL_BOTH));

		// search panel

		labelSearchTypes = new Label(this, SWT.NONE);
		labelSearchTypes.setText("Only Types with: ");

		// TODO add keylisteners to perform the search
		textSearchTypes = new Text(this, SWT.NONE);
		textSearchTypes.setLayoutData(new GridData(GridData.FILL_HORIZONTAL | GridData.GRAB_HORIZONTAL));

		labelSearchAnnotations = new Label(this, SWT.NONE);
		labelSearchAnnotations.setText("Only Annotations with: ");

		textSearchAnnotations = new Text(this, SWT.NONE);
		textSearchAnnotations.setLayoutData(new GridData(GridData.FILL_HORIZONTAL | GridData.GRAB_HORIZONTAL));

		createTreeViewer();
	}

	private void createTreeViewer() {

		System.out.println("Create treeeviewer");
		viewer = new TreeViewer(this, SWT.MULTI | SWT.H_SCROLL | SWT.V_SCROLL | SWT.CHECK);
		GridData data = new GridData(GridData.FILL_BOTH | GridData.GRAB_HORIZONTAL | GridData.GRAB_VERTICAL);
		data.horizontalSpan = 2;
		viewer.getControl().setLayoutData(data);

		viewer.addFilter(new AnnotationBrowserNoAnnoFilter());

		viewer.setContentProvider(new AnnotationContentProvider(editor.getCas()));

		viewer.setLabelProvider(new AnnotationLabelContentProvider(this.editor, this));

		viewer.setInput(editor);

		viewer.refresh();
	}

	public void renewPage() {

		if (viewer == null)
			return;

		Object[] expandedElements = viewer.getExpandedElements();
		viewer.refresh();

		viewer.setExpandedElements(expandedElements);

	}

	public TreeViewer getViewer() {
		return viewer;
	}

	public void setViewer(TreeViewer viewer) {
		this.viewer = viewer;
	}

	public AnnotationEditorWidget getEditor() {
		return editor;
	}

	public void setEditor(AnnotationEditorWidget editor) {
		this.editor = editor;
	}
}
