package de.uniwue.mk.kall.athen.appDelegation.ui;

import java.util.HashSet;
import java.util.List;

import javax.annotation.PostConstruct;
import javax.inject.Inject;

import org.eclipse.e4.core.services.events.IEventBroker;
import org.eclipse.e4.ui.model.application.MApplication;
import org.eclipse.e4.ui.model.application.ui.basic.MPart;
import org.eclipse.e4.ui.workbench.modeling.EModelService;
import org.eclipse.e4.ui.workbench.modeling.EPartService;
import org.eclipse.e4.ui.workbench.modeling.IPartListener;
import org.eclipse.swt.widgets.Composite;
import org.osgi.service.event.EventHandler;

import de.uniwue.mk.kall.athen.appDelegation.hierarchie.IPerspectiveDecoupledPart;
import de.uniwue.mk.kall.athen.appDelegation.structs.ClassEventPair;
import de.uniwue.mk.kall.athen.appDelegation.util.ApplicationUtil;

public class MasterPart {

	/*
	 * One part to control them all this part exists always and is always
	 * insivisble
	 */

	@Inject
	IEventBroker broker;

	@Inject
	MApplication app;

	@Inject
	EPartService partService;

	@Inject
	EModelService modelService;

	static ApplicationManager manager;

	@Inject
	public MasterPart() {

	}

	public static void setManager(ApplicationManager manager2) {
		manager = manager2;
	}

	@PostConstruct
	public void postConstruct(Composite parent) {

		// this important little line sets the brokermanager ready
		if (manager == null) {
			manager = new ApplicationManager(broker, modelService, app, partService);
		}

		else {
			manager.setApp(app);
			manager.setModelService(modelService);
			manager.setPartService(partService);
			manager.updatePartMapping();
		}

		// invoke postconstrcut method of all Parts;

		List<MPart> parts = modelService.findElements(app, null, MPart.class, null);

		// set parts invisible when set in the preferences
		for (MPart p : parts) {
			String contributorURI = p.getElementId();

			String fromPreferences = ApplicationUtil.getFromPreferences(contributorURI, "null");

			if (!fromPreferences.equals("null") && fromPreferences.equals("false")) {
				p.setVisible(false);
				partService.hidePart(p);
			}
		}

		IPartListener listener = new IPartListener() {

			@Override
			public void partVisible(MPart part) {
				// have AEditorSubordinateViewParts unsubscribe from events
				if (part != null && part.getObject() != null && part.getObject() instanceof IPerspectiveDecoupledPart) {
					((IPerspectiveDecoupledPart) part.getObject()).coupleToPerspective();
				}
			}

			@Override
			public void partHidden(MPart part) {
				// have AEditorSubordinateViewParts subscribe to events
				if (part != null && part.getObject() != null && part.getObject() instanceof IPerspectiveDecoupledPart) {
					((IPerspectiveDecoupledPart) part.getObject()).decoupleFromPerspective();
				}
			}

			@Override
			public void partDeactivated(MPart part) {
			}

			@Override
			public void partBroughtToTop(MPart part) {
			}

			@Override
			public void partActivated(MPart part) {
			}

		};
		partService.addPartListener(listener);

	}

	public static HashSet<ClassEventPair> dosth() {
		return ApplicationManager.getSubscribingSet();
	}

	// ======METHODS FOR THE BROKER MANAGER======

	public static void subscribeForEvent(Class<?> subscribingClass, String event, EventHandler handler) {

		manager.registerForEvent(subscribingClass, event, handler);
	}

	public static void unsubscribeFromEvent(Class<?> subscribingClass, String event, EventHandler handler) {

		manager.unsubscribeFromEvent(subscribingClass, event, handler);
	}

}