package de.uniwue.mk.kall.athen.attributeAcceptingView.ui;

import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;

import javax.annotation.PostConstruct;
import javax.annotation.PreDestroy;
import javax.inject.Inject;

import org.apache.uima.cas.CAS;
import org.apache.uima.cas.FSIterator;
import org.apache.uima.cas.Feature;
import org.apache.uima.cas.FeatureStructure;
import org.apache.uima.cas.Type;
import org.apache.uima.cas.text.AnnotationFS;
import org.apache.uima.cas.text.AnnotationIndex;
import org.apache.uima.ruta.rule.AnnotationComparator;
import org.eclipse.e4.core.services.events.IEventBroker;
import org.eclipse.e4.ui.di.Focus;
import org.eclipse.e4.ui.di.Persist;
import org.eclipse.e4.ui.model.application.ui.basic.MPart;
import org.eclipse.e4.ui.workbench.modeling.EPartService;
import org.eclipse.jface.viewers.ArrayContentProvider;
import org.eclipse.jface.viewers.ColumnLabelProvider;
import org.eclipse.jface.viewers.ColumnViewerToolTipSupport;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.jface.viewers.TableViewerColumn;
import org.eclipse.jface.window.ToolTip;
import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.StyleRange;
import org.eclipse.swt.events.KeyAdapter;
import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.MenuItem;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.Text;

import de.uniwue.kalimachos.coref.editor.drawingstructure.AnnoStyle;
import de.uniwue.kalimachos.coref.paintingStrategies.BackgroundDrawingStrategy;
import de.uniwue.kalimachos.coref.paintingStrategies.OvalDrawingStrategy;
import de.uniwue.mk.kall.athen.appDelegation.hierarchie.IPerspectiveDecoupledPart;
import de.uniwue.mk.kall.athen.appDelegation.util.ApplicationPreferences;
import de.uniwue.mk.kall.athen.appDelegation.util.ApplicationUtil;
import de.uniwue.mk.kall.athen.attributeAcceptingView.widgets.ColViewerComparatorAttributeView;
import de.uniwue.mk.kall.athen.attributeAcceptingView.widgets.ColViewerComparatorAttributeViewPersonTable;
import de.uniwue.mk.kall.athen.attributeAcceptingView.widgets.FrameFilterAttViewPersonTable;
import de.uniwue.mk.kall.athen.attributeAcceptingView.widgets.IDFilterAttViewPersonTable;
import de.uniwue.mk.kall.athen.events.IAnnotationEditorEvents;
import de.uniwue.mk.kall.athen.part.editor.NameFilter;
import de.uniwue.mk.kall.athen.part.editor.UnderlyingAnnotationFilter;
import de.uniwue.mk.kall.athen.part.editor.subordinate.AEditorSubordinateViewPart;
import de.uniwue.mk.kall.athen.widget.editor.AnnotationEditorWidget;
import de.uniwue.mk.kall.editorPainting.paintingstrategies.specialized.AttributeDrawingStrategy;
import de.uniwue.mk.kall.editorPainting.paintingstrategies.specialized.NamedEntityDrawingStrategy;

public class AttributeAcceptingView extends AEditorSubordinateViewPart {

	private static String viewId = "de.uniwue.mkrug.kallimachos.annotation.editor.part.13";

	private static Class<?> CLASS_THIS = AttributeAcceptingView.class;

	@Inject
	private static EPartService partService;

	// the personmodus changes the behaviour of the whole view drastically
	private boolean isPersonModusActive = false;
	private AnnotationFS activePersonMode = null;
	private boolean mouseDown = false;
	private long lastTimeDoubleClicked;

	private boolean subscribed = false;

	private Button togglePersonTable;
	private Button toggleAttributeTable;

	// WIDGETS
	private Type neDummyHighlightType;
	private Type dummyPersonColorfulOverrideType;

	// this table displays all persons
	private TableViewer viewer;
	// this table displays all attributes those are togglebale
	private TableViewer attributeTableViewer;

	private NameFilter filter;
	private IDFilterAttViewPersonTable idFilter;
	private FrameFilterAttViewPersonTable frameFilter;
	private UnderlyingAnnotationFilter ovFilter;

	// DATA CONTAINER
	private List<AnnotationFS> annoListAttributes;
	private List<AnnotationFS> annoListPersons;

	// displays the frequency of the persons
	public HashMap<String, Integer> freqMapPersons;
	public HashMap<String, Integer> freqMapAttributes;

	// last selected Attribute
	private AnnotationFS lastSelected;
	private AnnotationFS actualSelected;

	private String type;

	// E4 DI OBJECTS
	@Inject
	static IEventBroker broker;

	public Button getJumpButton() {
		return jumpButton;
	}

	public void setJumpButton(Button jumpButton) {
		this.jumpButton = jumpButton;
	}

	private Type typOverride;
	private Type neType;
	private Type typ;

	private Feature attNEFeature;
	private Feature neId;
	private Feature attId;
	private Feature attPriority;
	private Feature atttemporary;
	private Feature featIsUncertain;

	private String typeOverride;

	// compounds

	private Text neuEnt;

	// needed to sort the tables
	private ColViewerComparatorAttributeViewPersonTable colViewerComp;
	private ColViewerComparatorAttributeView colViewerAttView;

	private Text oldEnt;

	private Button box;

	private MPart part;

	Button jumpButton;

	Button buttonLowPriority;
	Button buttonMidPriority;
	Button highPriority;

	private String selectedTemp = "medium";

	private Label frameFilterLabel;
	private Button frameFilterButton;

	// initial it is selected
	private boolean isPersonTableSelected = false;

	// Images for buttons
	private Image personImage;
	private Image atributeImage;

	private Button buttonUncertain;

	private Button buttonFixAtt;

	private Button buttonMaybeTemporaryAtt;

	private Button buttonTemporaryAtt;

	public AttributeAcceptingView() {
		super();
		super.viewId = viewId;
		super.class_this = CLASS_THIS;
	}

	@PostConstruct
	public void postConstruct(Composite parent) {

		System.out.println("Construct Attribute Accepting View");

		super.overlay = parent;
		super.part = partService.findPart(viewId);
		super.partService = partService;

		// this is important since in the struct the broker is not injected
		// yet!!
		super.setBroker(broker);

	}

	@Override
	public void initModel() {
		// init AnnoLists

		AnnotationIndex<AnnotationFS> annotationIndex = editor.getCas().getAnnotationIndex(
				editor.getCas().getTypeSystem().getType(type));

		FSIterator<AnnotationFS> iterator = annotationIndex.iterator();
		annoListAttributes = new ArrayList<AnnotationFS>();
		annoListPersons = new ArrayList<AnnotationFS>();

		// init Data model
		while (iterator.hasNext()) {
			annoListAttributes.add((AnnotationFS) iterator.next());
		}

		for (AnnotationFS a : editor.getCas().getAnnotationIndex(neType)) {
			annoListPersons.add(a);
		}

		// ====FREQUENCIES=======
		freqMapAttributes = new HashMap<String, Integer>();
		for (AnnotationFS anno : annoListAttributes) {
			if (freqMapAttributes.containsKey(anno.getCoveredText())) {
				int freq = freqMapAttributes.get(anno.getCoveredText());
				freqMapAttributes.put(anno.getCoveredText(), freq + 1);
			}

			else {
				freqMapAttributes.put(anno.getCoveredText(), 1);
			}
		}

		freqMapPersons = new HashMap<String, Integer>();
		for (AnnotationFS anno : annoListPersons) {
			if (freqMapPersons.containsKey(anno.getCoveredText())) {
				int freq = freqMapPersons.get(anno.getCoveredText());
				freqMapPersons.put(anno.getCoveredText(), freq + 1);
			}

			else {
				freqMapPersons.put(anno.getCoveredText(), 1);
			}
		}
	}

	@Override
	public boolean initTypes() {

		// gettypes

		type = ApplicationUtil.getFromPreferences(ApplicationPreferences.ATTRIBUTEAGREEMENTVIEW_ATTTYPE, "null");

		typeOverride = ApplicationUtil.getFromPreferences(
				ApplicationPreferences.ATTRIBUTEAGREEMENTVIEW_ATT_TYPE_OVERRIDE, "null");
		String neTypeS = ApplicationUtil.getFromPreferences(ApplicationPreferences.ATTRIBUTEAGREEMENTVIEW_NETYPE,
				"null");

		if (type.equals("null") || typeOverride.equals("null") || neTypeS.equals("null")) {
			return false;
		}

		this.typ = editor.getCas().getTypeSystem().getType(type);
		this.neType = editor.getCas().getTypeSystem().getType(neTypeS);
		this.typOverride = editor.getCas().getTypeSystem().getType(typeOverride);

		if (this.typ == null || neType == null || typOverride == null) {
			return false;
		}

		// init dummy helper

		this.neDummyHighlightType = editor.getCas().getTypeSystem()
				.getType("de.uniwue.kalimachos.coref.type.NEDummyHighlightType");

		this.dummyPersonColorfulOverrideType = editor.getCas().getTypeSystem()
				.getType("de.uniwue.kalimachos.coref.type.DummyPersonColorOverride");

		// set everything unnneded invisible

		this.editor.allStylesInvisible();

		// get Features of NE Type

		String idPref = ApplicationUtil.getFromPreferences(ApplicationPreferences.ATTRIBUTEAGREEMENTVIEW_NE_FEATURE_ID,
				"null");
		String fsArrayS = ApplicationUtil.getFromPreferences(
				ApplicationPreferences.ATTRIBUTEAGREEMENTVIEW_ATT_NEFEATURE, "null");

		if (idPref.equals("null") || fsArrayS == null) {
			return false;
		}
		neId = neType.getFeatureByBaseName(idPref);
		attNEFeature = typ.getFeatureByBaseName(fsArrayS);

		// Attribute features
		String priorityS = ApplicationUtil.getFromPreferences(
				ApplicationPreferences.ATTRIBUTEAGREEMENTVIEW_ATTPRIORITY, "null");
		String temporaryS = ApplicationUtil.getFromPreferences(
				ApplicationPreferences.ATTRIBUTEAGREEMENTVIEW_ATTTEMPORARY, "null");
		String uncertainS = ApplicationUtil.getFromPreferences(
				ApplicationPreferences.ATTRIBUTEAGREEMENTVIEW_ISUNCERTAIN, "null");
		String attIdS = ApplicationUtil.getFromPreferences(ApplicationPreferences.ATTRIBUTEAGREEMENTVIEW_ATTID, "null");

		attPriority = typ.getFeatureByBaseName(priorityS);
		atttemporary = typ.getFeatureByBaseName(temporaryS);
		featIsUncertain = typ.getFeatureByBaseName(uncertainS);

		attId = typ.getFeatureByBaseName(attIdS);

		editor.changeVisibility(typ, true);
		editor.changeVisibility(neType, true);
		editor.changeVisibility(typOverride, true);
		editor.changeVisibility(neDummyHighlightType, true);
		editor.changeVisibility(dummyPersonColorfulOverrideType, true);

		// layer

		editor.changeLayer(typ, 1);
		editor.changeLayer(neType, 1);
		editor.changeLayer(typOverride, 0);
		editor.changeLayer(neDummyHighlightType, 1);
		editor.changeLayer(dummyPersonColorfulOverrideType, 2);

		// yellow - will be overwritten anyway in the Painting strategy - using
		// this would not be flexible enough
		StyleRange rangeOv = new StyleRange();
		rangeOv.background = new Color(overlay.getDisplay(), 238, 245, 174);
		// rangeOv.background = new Color(overlay.getDisplay(), 238, 129, 114);

		//
		AnnoStyle style2 = new AnnoStyle(new BackgroundDrawingStrategy(rangeOv), rangeOv);

		// style - the new style
		StyleRange rangeTyp = new StyleRange();
		rangeTyp.background = new Color(overlay.getDisplay(), 255, 0, 0);
		AnnoStyle style = new AnnoStyle(new AttributeDrawingStrategy(rangeTyp, attId.getShortName(),
				attPriority.getShortName(), atttemporary.getShortName(), featIsUncertain.getShortName()), rangeTyp);

		// style of neType
		StyleRange rangeTypNE = new StyleRange();
		rangeTypNE.background = new Color(overlay.getDisplay(), 25, 25, 255);
		AnnoStyle styleNE = new AnnoStyle(new NamedEntityDrawingStrategy(rangeTypNE, neId.getShortName(), null, null,
				null, null, null), rangeTypNE);

		// dummy highlight type
		StyleRange rangeDummy = new StyleRange();
		rangeDummy.background = new Color(overlay.getDisplay(), 255, 0, 0);

		//
		AnnoStyle styleDummy = new AnnoStyle(new OvalDrawingStrategy(rangeDummy), rangeDummy);

		// dummy colorful override highlight type
		StyleRange rangeDummyOv = new StyleRange();
		rangeDummyOv.background = new Color(overlay.getDisplay(), 250, 156, 32);

		//
		AnnoStyle styleDummyOv = new AnnoStyle(new BackgroundDrawingStrategy(rangeDummyOv), rangeDummyOv);

		// apply
		editor.changeStyle(typ, style);
		editor.changeStyle(neType, styleNE);
		editor.changeStyle(typOverride, style2);
		editor.changeStyle(neDummyHighlightType, styleDummy);
		editor.changeStyle(dummyPersonColorfulOverrideType, styleDummyOv);

		// also change the modus
		editor.setActiveMode(typ);

		return true;

	}

	@Override
	protected void initLayout(Composite parent) {
		// this.overlay = new Composite(parent, SWT.NONE);

		GridLayout layout = new GridLayout();
		layout.horizontalSpacing = 5;
		layout.numColumns = 2;
		layout.verticalSpacing = 5;
		layout.marginWidth = 5;
		layout.marginHeight = 5;
		overlay.setLayout(layout);

		// / ==== Buttons + Fields

		Composite comp2 = new Composite(overlay, SWT.BORDER);
		comp2.setVisible(true);
		GridLayout gdd = new GridLayout();
		GridData gridData2 = new GridData();
		gridData2.horizontalSpan = 2;
		gridData2.grabExcessHorizontalSpace = true;
		// gridData2.grabExcessVerticalSpace = true;
		gridData2.horizontalAlignment = GridData.FILL;

		comp2.setLayout(gdd);
		comp2.setLayoutData(gridData2);

		// Label actions = new Label(comp2, SWT.NULL);
		// actions.setText("Actions");
		// Composite comp = new Composite(overlay, SWT.BORDER);
		// comp.setVisible(true);

		GridLayout gridBelow = new GridLayout(2, false);
		comp2.setLayout(gridBelow);
		Button newEntity = new Button(comp2, SWT.NONE);
		newEntity.setText("New Attribute:");
		newEntity.addSelectionListener(new SelectionListener() {

			// adds an attribute with null NE feature

			@Override
			public void widgetSelected(SelectionEvent e) {

				AnnotationFS selected = null;
				if (editor.getSelectionOfVisibleAnnotations().size() > 0) {
					for (AnnotationFS anno : editor.getSelectionOfVisibleAnnotations()) {
						if (anno.getType().equals(typ)) {
							selected = anno;

						}
					}
				}

				// remove vorschlag ???
				CAS cas = editor.getCas();
				Type t = cas.getTypeSystem().getType(type);
				// get the selection

				if (selected == null) {

					Point selection = editor.getActualSelectedText();
					AnnotationFS anno = cas.createAnnotation(t, selection.x, selection.y);

					anno.setFeatureValueFromString(attPriority, selectedTemp);
					addAnnotation(anno);

				}

			}

			@Override
			public void widgetDefaultSelected(SelectionEvent e) {

				widgetSelected(e);

			}
		});
		// listener

		this.neuEnt = new Text(comp2, SWT.BORDER);
		neuEnt.setText("Mark some Text and press \"new\"");
		neuEnt.setLayoutData(new GridData(GridData.GRAB_HORIZONTAL | GridData.HORIZONTAL_ALIGN_FILL));
		Button oldEntity = new Button(comp2, SWT.NONE);
		oldEntity.setText("Is Attribute");

		oldEntity.addSelectionListener(new SelectionListener() {

			@Override
			public void widgetSelected(SelectionEvent e) {

				AnnotationFS selected = null;
				if (editor.getSelectionOfVisibleAnnotations().size() > 0) {
					for (AnnotationFS anno : editor.getSelectionOfVisibleAnnotations()) {
						if (anno.getType().equals(typ)) {
							selected = anno;

						}
					}
				}

				// old means we create an annotation AND set the id to the
				// selected old
				if (selected != null) {

					// to ensure we continue with our jumps
					updateAnnotation(selected, attPriority, selectedTemp, true);
				}

			}

			@Override
			public void widgetDefaultSelected(SelectionEvent e) {
				widgetSelected(e);

			}
		});

		this.oldEnt = new Text(comp2, SWT.BORDER);
		oldEnt.setText("Click to accept!");
		this.oldEnt.setEditable(false);
		oldEnt.setLayoutData(new GridData(GridData.GRAB_HORIZONTAL | GridData.HORIZONTAL_ALIGN_FILL));

		Button noEntity = new Button(comp2, SWT.NONE);
		noEntity.setText("No Attribute");
		noEntity.addSelectionListener(new SelectionListener() {

			@Override
			public void widgetSelected(SelectionEvent e) {

				AnnotationFS selected = null;
				if (editor.getSelectionOfVisibleAnnotations().size() > 0) {
					for (AnnotationFS anno : editor.getSelectionOfVisibleAnnotations()) {
						if (anno.getType().equals(typ)) {
							selected = anno;

						}
					}
				}

				// get boolean of box
				if (box.getSelection()) {

					// we delete all

				}

				else {
					// we delete only the one
					if (selected != null) {

						deleteAnnotation(selected);

					}
				}

			}

			@Override
			public void widgetDefaultSelected(SelectionEvent e) {

				widgetSelected(e);

			}
		});
		box = new Button(comp2, SWT.CHECK);
		box.setText("Delete All");

		// Priority radiobuttons
		Composite composite = new Composite(overlay, SWT.NULL);
		gdd = new GridLayout();
		gdd.numColumns = 1;
		gdd.marginBottom = gdd.marginTop = gdd.marginLeft = gdd.marginRight = 0;
		composite.setLayout(gdd);

		GridData gridDataRadio1 = new GridData();
		gridDataRadio1.horizontalSpan = 2;
		composite.setLayoutData(gridDataRadio1);

		Group groupPriority = new Group(composite, SWT.SHADOW_IN);

		groupPriority.setLayout(new RowLayout());

		Label label = new Label(groupPriority, SWT.NULL);
		label.setText("Priority: ");
		label.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_CYAN));

		buttonLowPriority = new Button(groupPriority, SWT.RADIO);
		buttonLowPriority.setText("Low");

		buttonLowPriority.addSelectionListener(new SelectionListener() {

			@Override
			public void widgetSelected(SelectionEvent e) {
				selectedTemp = "low";

				if (editor.getSelectionOfVisibleAnnotations().size() == 1) {

					AnnotationFS attAnno = editor.getSelectionOfVisibleAnnotations().get(0);

					if (buttonLowPriority.getSelection()) {
						updateAnnotation(attAnno, attPriority, selectedTemp, true);
					}
				}

			}

			@Override
			public void widgetDefaultSelected(SelectionEvent e) {
				widgetSelected(e);

			}
		});

		buttonMidPriority = new Button(groupPriority, SWT.RADIO);
		buttonMidPriority.setText("Medium");

		// initial is set to medium

		buttonMidPriority.setSelection(true);

		buttonMidPriority.addSelectionListener(new SelectionListener() {

			@Override
			public void widgetSelected(SelectionEvent e) {
				selectedTemp = "medium";

				// if the selection of the text is != null also update the
				// feature of that anno

				if (editor.getSelectionOfVisibleAnnotations().size() == 1) {

					AnnotationFS attAnno = editor.getSelectionOfVisibleAnnotations().get(0);

					if (buttonMidPriority.getSelection()) {
						updateAnnotation(attAnno, attPriority, selectedTemp, true);
					}

				}

			}

			@Override
			public void widgetDefaultSelected(SelectionEvent e) {
				widgetSelected(e);

			}
		});

		highPriority = new Button(groupPriority, SWT.RADIO);
		highPriority.setText("High");

		highPriority.addSelectionListener(new SelectionListener() {

			@Override
			public void widgetSelected(SelectionEvent e) {
				selectedTemp = "high";

				if (editor.getSelectionOfVisibleAnnotations().size() == 1) {

					AnnotationFS attAnno = editor.getSelectionOfVisibleAnnotations().get(0);
					if (highPriority.getSelection()) {
						updateAnnotation(attAnno, attPriority, selectedTemp, true);
					}

				}

			}

			@Override
			public void widgetDefaultSelected(SelectionEvent e) {
				widgetSelected(e);

			}
		});

		Group groupTemp = new Group(composite, SWT.SHADOW_IN);
		groupTemp.setLayout(new RowLayout());
		Label label2 = new Label(groupTemp, SWT.NULL);
		label2.setText("Temporary: ");
		label2.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_CYAN));
		buttonTemporaryAtt = new Button(groupTemp, SWT.RADIO);

		buttonTemporaryAtt.setText("temporary");

		buttonTemporaryAtt.addSelectionListener(new SelectionListener() {

			@Override
			public void widgetSelected(SelectionEvent e) {
				String selectedTemporary = "temporary";

				if (editor.getSelectionOfVisibleAnnotations().size() == 1) {

					AnnotationFS attAnno = editor.getSelectionOfVisibleAnnotations().get(0);
					if (buttonTemporaryAtt.getSelection()) {
						updateAnnotation(attAnno, atttemporary, selectedTemporary, true);
					}

				}

			}

			@Override
			public void widgetDefaultSelected(SelectionEvent e) {
				widgetSelected(e);

			}
		});
		buttonMaybeTemporaryAtt = new Button(groupTemp, SWT.RADIO);
		buttonMaybeTemporaryAtt.setText("maybe");

		buttonMaybeTemporaryAtt.addSelectionListener(new SelectionListener() {

			@Override
			public void widgetSelected(SelectionEvent e) {
				String selectedTemporary = "maybeTemporary";

				if (editor.getSelectionOfVisibleAnnotations().size() == 1) {

					AnnotationFS attAnno = editor.getSelectionOfVisibleAnnotations().get(0);
					if (buttonMaybeTemporaryAtt.getSelection()) {
						updateAnnotation(attAnno, atttemporary, selectedTemporary, true);
					}

				}

			}

			@Override
			public void widgetDefaultSelected(SelectionEvent e) {
				widgetSelected(e);

			}
		});
		buttonFixAtt = new Button(groupTemp, SWT.RADIO);
		buttonFixAtt.setText("fix Att.");

		buttonFixAtt.addSelectionListener(new SelectionListener() {

			@Override
			public void widgetSelected(SelectionEvent e) {
				String selectedTemporary = "Fix Attribute";

				if (editor.getSelectionOfVisibleAnnotations().size() == 1) {

					AnnotationFS attAnno = editor.getSelectionOfVisibleAnnotations().get(0);
					if (buttonFixAtt.getSelection()) {
						updateAnnotation(attAnno, atttemporary, selectedTemporary, true);
					}

				}

			}

			@Override
			public void widgetDefaultSelected(SelectionEvent e) {
				widgetSelected(e);

			}
		});
		// // ==== Table
		comp2.setSize(overlay.getSize());

		Composite compp = new Composite(overlay, SWT.NULL);

		compp.setVisible(true);

		GridLayout lay = new GridLayout(2, false);
		compp.setLayout(lay);

		// uncertain
		Label labelUncertain = new Label(compp, SWT.NONE);
		labelUncertain.setText("Uncertain?");
		buttonUncertain = new Button(compp, SWT.CHECK);

		buttonUncertain.addSelectionListener(new SelectionListener() {

			@Override
			public void widgetSelected(SelectionEvent e) {
				if (editor.getSelectionOfVisibleAnnotations().size() == 1) {

					AnnotationFS attAnno = editor.getSelectionOfVisibleAnnotations().get(0);

					updateAnnotation(attAnno, featIsUncertain, String.valueOf(buttonUncertain.getSelection()), true);

				}

			}

			@Override
			public void widgetDefaultSelected(SelectionEvent e) {

				widgetSelected(e);
			}
		});
		// jumplabel is always visible and only affects the attribute jump
		Label noJumpLabel = new Label(compp, SWT.NONE);
		noJumpLabel.setText("Jump to next?: ");
		jumpButton = new Button(compp, SWT.CHECK);
		jumpButton.setLayoutData(new GridData(GridData.GRAB_HORIZONTAL | GridData.HORIZONTAL_ALIGN_FILL));
		jumpButton.setSelection(true);

		// add togglebuttons

		Composite compp2 = new Composite(compp, SWT.NULL);

		GridData toggleData = new GridData();
		toggleData.horizontalSpan = 2;
		toggleData.horizontalIndent = 0;
		compp2.setLayoutData(toggleData);

		compp2.setVisible(true);

		compp2.setLayout(lay);

		toggleAttributeTable = new Button(compp2, SWT.NONE);
		toggleAttributeTable.setImage(getAttributeImage());
		togglePersonTable = new Button(compp2, SWT.NONE);
		togglePersonTable.setImage(getPersonImage());

		toggleAttributeTable.addSelectionListener(new SelectionListener() {

			@Override
			public void widgetSelected(SelectionEvent e) {
				isPersonTableSelected = false;
				// fake a reload
				onEditorInputChanged(editor);

			}

			@Override
			public void widgetDefaultSelected(SelectionEvent e) {
				widgetSelected(e);
			}
		});

		togglePersonTable.addSelectionListener(new SelectionListener() {

			@Override
			public void widgetSelected(SelectionEvent e) {
				isPersonTableSelected = true;

				// fake a reload
				onEditorInputChanged(editor);

			}

			@Override
			public void widgetDefaultSelected(SelectionEvent e) {
				widgetSelected(e);
			}
		});

		// from here everything is exchangeable

		if (isPersonTableSelected) {
			initPersonTable(compp);
		}

		else {
			// draw Attribute Table

			initAttributeTable(compp);
		}

	}

	private Image getPersonImage() {

		if (personImage != null) {
			return personImage;
		}

		else {
			personImage = ApplicationUtil.createImage(ApplicationUtil.WSD_CAT_MENSCH);
		}
		return personImage;
	}

	private Image getAttributeImage() {

		if (atributeImage != null) {
			return atributeImage;
		}

		else {
			atributeImage = ApplicationUtil.createImage(ApplicationUtil.WSD_CAT_ATTRIBUT);
		}
		return atributeImage;
	}

	private void initAttributeTable(Composite compp) {

		Label searchLabel = new Label(compp, SWT.NONE);
		searchLabel.setText("Search: ");
		final Text searchText = new Text(compp, SWT.BORDER | SWT.SEARCH);
		searchText.setLayoutData(new GridData(GridData.GRAB_HORIZONTAL | GridData.HORIZONTAL_ALIGN_FILL));

		attributeTableViewer = new TableViewer(compp, SWT.MULTI | SWT.H_SCROLL | SWT.V_SCROLL | SWT.FULL_SELECTION
				| SWT.BORDER | SWT.FILL);

		createAttributeTableColumns(attributeTableViewer);

		// add Menu
		// MenuListener
		final Menu menu = new Menu(attributeTableViewer.getControl());
		attributeTableViewer.getControl().setMenu(menu);

		// Delete
		MenuItem del = new MenuItem(menu, SWT.None);

		del.setText("Delete Selected Annotation");

		del.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent event) {

				IStructuredSelection sel = (IStructuredSelection) attributeTableViewer.getSelection();

				AnnotationFS firstElement = (AnnotationFS) sel.getFirstElement();

				deleteAnnotation(firstElement);

			}

		});

		// GoTo

		MenuItem goTo = new MenuItem(menu, SWT.None);

		goTo.setText("GoTo Selected Annotation");

		goTo.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent event) {

				IStructuredSelection sel = (IStructuredSelection) attributeTableViewer.getSelection();

				AnnotationFS firstElement = (AnnotationFS) sel.getFirstElement();

				int beg = firstElement.getBegin();

				changeHighlighting(beg, firstElement.getEnd(), true);

			}

		});

		// MOUSE DOUBLE CLICK LISTENER
		attributeTableViewer.getTable().addListener(SWT.MouseDoubleClick, new Listener() {

			@Override
			public void handleEvent(Event e) {
				// get the selected item
				String id = null;
				IStructuredSelection sel = (IStructuredSelection) attributeTableViewer.getSelection();

				AnnotationFS selected = (AnnotationFS) sel.getFirstElement();
				if (selected == null) {
					return;
				}

				id = selected.getFeatureValueAsString(attId);

				// get the selection in the cas editor

				Point pSelect = editor.getActualSelectedText();

				if (pSelect.y - pSelect.x == 0) {
					// here we update the Features of the annotation

					AnnotationFS anno = editor.getSelectionOfVisibleAnnotations().get(0);

					FeatureStructure featureValue = anno.getFeatureValue(attNEFeature);

					if (featureValue != null) {

						anno.setFeatureValue(attNEFeature, featureValue);

					}

					updateAnnotation(anno, attPriority, selectedTemp, false);
					updateAnnotation(anno, attId, id, true);
				}

				else {

					if (editor.getSelectionOfVisibleAnnotations().size() == 1) {
						// update the Annotation
						AnnotationFS ano = editor.getSelectionOfVisibleAnnotations().get(0);

						if (ano.getType().getName().equals(typ.getName())) {

							updateAnnotation(ano, attPriority, selectedTemp, false);
							updateAnnotation(ano, attId, id, true);
							// also update the priority

						}

						else {

							// create An Annotation with the correct span
							// and
							// ids
							AnnotationFS anno = editor.getCas().createAnnotation(typ, editor.getActualSelectedText().x,
									editor.getActualSelectedText().y);

							updateAnnotation(anno, attPriority, selectedTemp, false);
							// String name =
							// anno.getFeatureValueAsString(nameFeat);
							// if (name == "" || name == null) {
							// // anno.setFeatureValueFromString(nameFeat,
							// // anno.getCoveredText());
							// }

							// anno.setFeatureValueFromString(idFeat, id);
							// anno.setFeatureValueFromString(coreFeat, new
							// Boolean(coreButton.getSelection()).toString());
							// anno.setFeatureValueFromString(nameFeat,
							// names);

							FeatureStructure featureValue = anno.getFeatureValue(attNEFeature);

							if (featureValue != null) {

								anno.setFeatureValue(attNEFeature, featureValue);

							}

							addAnnotation(anno);

						}
					}

					else {

						// create An Annotation with the correct span and
						// ids
						AnnotationFS anno = editor.getCas().createAnnotation(typ, editor.getActualSelectedText().x,
								editor.getActualSelectedText().y);

						// String name =
						// anno.getFeatureValueAsString(nameFeat);
						// if (name == "" || name == null) {
						// //anno.setFeatureValueFromString(nameFeat,
						// anno.getCoveredText());
						// }
						FeatureStructure featureValue = anno.getFeatureValue(attNEFeature);

						if (featureValue != null) {

							anno.setFeatureValue(attNEFeature, featureValue);

						}

						anno.setFeatureValueFromString(attId, id);
						// anno.setFeatureValueFromString(coreFeat, new
						// Boolean(coreButton.getSelection()).toString());
						// anno.setFeatureValueFromString(nameFeat, names);

						addAnnotation(anno);
					}
				}

			}

		});

		// make lines and header visible
		final Table table = attributeTableViewer.getTable();
		table.setHeaderVisible(true);
		table.setLinesVisible(true);

		// content
		attributeTableViewer.setContentProvider(ArrayContentProvider.getInstance());
		GridData gridData = new GridData(GridData.FILL_VERTICAL);
		gridData.horizontalSpan = 2;
		gridData.grabExcessHorizontalSpace = true;
		gridData.grabExcessVerticalSpace = true;
		gridData.horizontalAlignment = GridData.FILL;
		attributeTableViewer.getControl().setLayoutData(gridData);
		compp.setLayoutData(gridData);
		// New to support the search

		searchText.addKeyListener(new KeyAdapter() {
			public void keyReleased(KeyEvent ke) {
				filter.setSearchText(searchText.getText());
				attributeTableViewer.refresh();
			}

		});

		// TODO adjust the filter for both tables !!
		// filter
		filter = new NameFilter();
		attributeTableViewer.addFilter(filter);

		// id filter

		ovFilter = new UnderlyingAnnotationFilter();
		attributeTableViewer.addFilter(ovFilter);

		createTableViewer();

		this.colViewerAttView = new ColViewerComparatorAttributeView(attId, attPriority, this);
		attributeTableViewer.setComparator(colViewerAttView);

		ColumnViewerToolTipSupport.enableFor(attributeTableViewer, ToolTip.NO_RECREATE);
	}

	private void createAttributeTableColumns(TableViewer attributeTableViewer) {
		TableViewerColumn colAttName = createTableViewerColumn(attributeTableViewer, "Name", 100, 0);
		colAttName.setLabelProvider(new ColumnLabelProvider() {
			@Override
			public String getText(Object element) {
				AnnotationFS p = (AnnotationFS) element;
				return p.getCoveredText();

			}

		});

		TableViewerColumn colAttFreq = createTableViewerColumn(attributeTableViewer, "Freq.", 50, 1);
		colAttFreq.setLabelProvider(new ColumnLabelProvider() {
			@Override
			public String getText(Object element) {
				AnnotationFS p = (AnnotationFS) element;
				String id = p.getFeatureValueAsString(neId);
				if (freqMapAttributes.containsKey(id)) {
					return freqMapAttributes.get(id).toString();

				}

				else {
					return "1";
				}
			}
		});

		TableViewerColumn colAttID = createTableViewerColumn(attributeTableViewer, "ID", 30, 2);
		colAttID.setLabelProvider(new ColumnLabelProvider() {
			@Override
			public String getText(Object element) {
				AnnotationFS p = (AnnotationFS) element;

				String featureValueAsString = p.getFeatureValueAsString(attId);

				if (featureValueAsString == null) {
					return "";
				}
				return featureValueAsString;
			}
		});

		TableViewerColumn colAttPriority = createTableViewerColumn(attributeTableViewer, "Priority", 40, 3);
		colAttPriority.setLabelProvider(new ColumnLabelProvider() {
			@Override
			public String getText(Object element) {
				AnnotationFS p = (AnnotationFS) element;

				return p.getFeatureValueAsString(attPriority);
			}
		});

		TableViewerColumn colAttTemporary = createTableViewerColumn(attributeTableViewer, "Type", 40, 4);
		colAttTemporary.setLabelProvider(new ColumnLabelProvider() {
			@Override
			public String getText(Object element) {
				AnnotationFS p = (AnnotationFS) element;

				return p.getFeatureValueAsString(atttemporary);
			}
		});

		TableViewerColumn colAttNE = createTableViewerColumn(attributeTableViewer, "Reference", 60, 5);
		colAttNE.setLabelProvider(new ColumnLabelProvider() {
			@Override
			public String getText(Object element) {
				AnnotationFS p = (AnnotationFS) element;

				FeatureStructure featureValue = p.getFeatureValue(attNEFeature);

				if (featureValue == null) {
					return "NULL";
				}

				else {
					AnnotationFS anno = (AnnotationFS) featureValue;
					return anno.getCoveredText();
				}

			}
		});

	}

	private void initPersonTable(Composite compp) {

		frameFilterLabel = new Label(compp, SWT.NONE);
		frameFilterLabel.setText("Frame Filter:");
		frameFilterButton = new Button(compp, SWT.CHECK);
		frameFilterButton.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				renewPage();
			}
		});

		// searchLabel
		Label searchLabel = new Label(compp, SWT.NONE);
		searchLabel.setText("Search: ");
		final Text searchText = new Text(compp, SWT.BORDER | SWT.SEARCH);
		searchText.setLayoutData(new GridData(GridData.GRAB_HORIZONTAL | GridData.HORIZONTAL_ALIGN_FILL));

		viewer = new TableViewer(compp, SWT.MULTI | SWT.H_SCROLL | SWT.V_SCROLL | SWT.FULL_SELECTION | SWT.BORDER
				| SWT.FILL);

		createPersonTableColumns(viewer);

		// add Menu
		// MenuListener
		final Menu menu = new Menu(viewer.getControl());
		viewer.getControl().setMenu(menu);

		// GoTo
		MenuItem goTo = new MenuItem(menu, SWT.None);

		goTo.setText("GoTo Selected Annotation");

		goTo.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent event) {

				IStructuredSelection sel = (IStructuredSelection) viewer.getSelection();

				AnnotationFS firstElement = (AnnotationFS) sel.getFirstElement();

				int beg = firstElement.getBegin();

				changeHighlighting(beg, firstElement.getEnd(), true);

			}

		});

		MenuItem personModus = new MenuItem(menu, SWT.None);

		personModus.setText("Set this Person to Modus");

		personModus.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent event) {

				// deselect the other modus do this by removing all annotations
				// that belong to this person

				List<AnnotationFS> toDelete = new ArrayList<AnnotationFS>();
				for (AnnotationFS a : editor.getCas().getAnnotationIndex(dummyPersonColorfulOverrideType)) {
					toDelete.add(a);
				}

				for (AnnotationFS to : toDelete) {
					editor.getCas().removeFsFromIndexes(to);
				}

				// select the new modus
				isPersonModusActive = true;

				IStructuredSelection sel = (IStructuredSelection) viewer.getSelection();

				AnnotationFS firstElement = (AnnotationFS) sel.getFirstElement();

				activePersonMode = firstElement;

				// update idFIlter
				idFilter.setAnnotations(annoListPersons, neId, true, activePersonMode.getFeatureValueAsString(neId));

				// create Annotations that show this persons annotations in
				// depth

				for (AnnotationFS person : editor.getCas().getAnnotationIndex(neType)) {

					if (person.getFeatureValueAsString(neId).equals(firstElement.getFeatureValueAsString(neId))) {

						// create an annotation
						AnnotationFS fs = editor.getCas().createAnnotation(dummyPersonColorfulOverrideType,
								person.getBegin(), person.getEnd());

						editor.getCas().addFsToIndexes(fs);

					}
				}

				// redraw
				renewPage();
				editor.invokeReload();
			}

		});

		MenuItem personDeselectModus = new MenuItem(menu, SWT.None);

		personDeselectModus.setText("Deselect modus");

		personDeselectModus.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent event) {

				// deselect the other modus do this by removing all annotations
				// that belong to this person

				List<AnnotationFS> toDelete = new ArrayList<AnnotationFS>();
				for (AnnotationFS a : editor.getCas().getAnnotationIndex(dummyPersonColorfulOverrideType)) {
					toDelete.add(a);
				}

				for (AnnotationFS to : toDelete) {
					editor.getCas().removeFsFromIndexes(to);
				}

				// select the new modus
				isPersonModusActive = false;
				idFilter.setAnnotations(annoListPersons, neId, false,
						annoListPersons.get(0).getFeatureValueAsString(neId));
				activePersonMode = null;

				// redraw
				renewPage();
				editor.invokeReload();
			}

		});

		viewer.getTable().addListener(SWT.MouseDoubleClick, new Listener() {

			@Override
			public void handleEvent(Event e) {
				// get the selected item
				String id = null;
				IStructuredSelection sel = (IStructuredSelection) viewer.getSelection();

				AnnotationFS selected = (AnnotationFS) sel.getFirstElement();
				if (selected == null) {
					return;
				}

				id = selected.getFeatureValueAsString(neId);

				// get the selection in the cas editor

				Point pSelect = editor.getActualSelectedText();

				if (pSelect.y - pSelect.x == 0) {
					// here we update the Features of the annotation

					AnnotationFS anno = editor.getSelectionOfVisibleAnnotations().get(0);

					anno.setFeatureValue(attNEFeature, selected);

					updateAnnotation(anno, attId, id, true);

				}

				else {

					if (editor.getSelectionOfVisibleAnnotations().size() == 1) {
						// update the Annotation
						AnnotationFS ano = editor.getSelectionOfVisibleAnnotations().get(0);

						if (ano.getType().getName().equals(typ.getName())) {

							// ano.setFeatureValueFromString(idFeat, id);
							// ano.setFeatureValueFromString(coreFeat, new
							// Boolean(coreButton.getSelection()).toString());
							// ano.setFeatureValueFromString(nameFeat,
							// names);
							ano.setFeatureValue(attNEFeature, selected);
							updateAnnotation(ano, attId, id, true);

						}

						else {

							// create An Annotation with the correct span
							// and
							// ids
							AnnotationFS anno = editor.getCas().createAnnotation(typ, editor.getActualSelectedText().x,
									editor.getActualSelectedText().y);
							anno.setFeatureValue(attNEFeature, selected);

							// String name =
							// anno.getFeatureValueAsString(nameFeat);
							// if (name == "" || name == null) {
							// // anno.setFeatureValueFromString(nameFeat,
							// // anno.getCoveredText());
							// }

							// anno.setFeatureValueFromString(idFeat, id);
							// anno.setFeatureValueFromString(coreFeat, new
							// Boolean(coreButton.getSelection()).toString());
							// anno.setFeatureValueFromString(nameFeat,
							// names);

							anno.setFeatureValueFromString(attId, id);
							addAnnotation(anno);

						}
					}

					else {

						// create An Annotation with the correct span and
						// ids
						AnnotationFS anno = editor.getCas().createAnnotation(typ, editor.getActualSelectedText().x,
								editor.getActualSelectedText().y);
						anno.setFeatureValueFromString(attId, id);
						anno.setFeatureValue(attNEFeature, selected);
						// String name =
						// anno.getFeatureValueAsString(nameFeat);
						// if (name == "" || name == null) {
						// //anno.setFeatureValueFromString(nameFeat,
						// anno.getCoveredText());
						// }

						// anno.setFeatureValueFromString(idFeat, id);
						// anno.setFeatureValueFromString(coreFeat, new
						// Boolean(coreButton.getSelection()).toString());
						// anno.setFeatureValueFromString(nameFeat, names);

						addAnnotation(anno);
					}
				}

			}

		});

		// make lines and header visible
		final Table table = viewer.getTable();
		table.setHeaderVisible(true);
		table.setLinesVisible(true);

		// content
		viewer.setContentProvider(ArrayContentProvider.getInstance());
		GridData gridData = new GridData(GridData.FILL_VERTICAL);
		gridData.horizontalSpan = 2;
		gridData.grabExcessHorizontalSpace = true;
		gridData.grabExcessVerticalSpace = true;
		gridData.horizontalAlignment = GridData.FILL;
		viewer.getControl().setLayoutData(gridData);
		compp.setLayoutData(gridData);
		// New to support the search

		searchText.addKeyListener(new KeyAdapter() {
			public void keyReleased(KeyEvent ke) {
				filter.setSearchText(searchText.getText());
				viewer.refresh();
			}

		});

		// filter
		filter = new NameFilter();
		viewer.addFilter(filter);

		// id filter

		idFilter = new IDFilterAttViewPersonTable();
		viewer.addFilter(idFilter);

		// frame filter
		frameFilter = new FrameFilterAttViewPersonTable();
		viewer.addFilter(frameFilter);

		colViewerComp = new ColViewerComparatorAttributeViewPersonTable(neId, this);
		viewer.setComparator(colViewerComp);
		createTableViewer();
		// comparator

		// TODO comparator

		ColumnViewerToolTipSupport.enableFor(viewer, ToolTip.NO_RECREATE);
	}

	public void renewPage() {

		// update data model
		AnnotationIndex<AnnotationFS> annotationIndex = editor.getCas().getAnnotationIndex(
				editor.getCas().getTypeSystem().getType(type));

		FSIterator<AnnotationFS> iterator = annotationIndex.iterator();
		annoListAttributes = new ArrayList<AnnotationFS>();
		while (iterator.hasNext()) {
			annoListAttributes.add((AnnotationFS) iterator.next());
		}

		annoListPersons = new ArrayList<AnnotationFS>();

		for (AnnotationFS person : editor.getCas().getAnnotationIndex(neType)) {
			annoListPersons.add(person);
		}

		// update frequencyMaps
		freqMapAttributes = new HashMap<String, Integer>();
		for (AnnotationFS anno : annoListAttributes) {
			// if (freqMap.containsKey(anno.getFeatureValueAsString(idFeat))) {
			// int freq = freqMap.get(anno.getFeatureValueAsString(idFeat));
			// freq += 1;
			// freqMap.put(anno.getFeatureValueAsString(idFeat), freq);
			// }
			//
			// else {
			// freqMap.put(anno.getFeatureValueAsString(idFeat), 1);
			// }
		}

		//

		Runnable r = new Runnable() {

			@Override
			public void run() {

				createTableViewer();

			}
		};

		// reload asynchronous
		overlay.getDisplay().asyncExec(r);

	}

	private void createTableViewer() {

		Integer maxId = 0;
		for (AnnotationFS annot : this.annoListAttributes) {
			if (annot.getFeatureValueAsString(attId) != null && annot.getFeatureValueAsString(attId) != "") {
				Integer ids = Integer.parseInt(annot.getFeatureValueAsString(attId));
				if (ids > maxId) {
					maxId = ids;
				}
			}
		}
		// set null features of attributes
		for (AnnotationFS annot : this.annoListAttributes) {
			if (annot.getFeatureValueAsString(attId) == null || annot.getFeatureValueAsString(attId) == "") {
				annot.setFeatureValueFromString(attId, String.valueOf(++maxId));
				maxId++;
			}

			if (annot.getFeatureValueAsString(attPriority) == null || annot.getFeatureValueAsString(attPriority) == "") {
				annot.setFeatureValueFromString(attPriority, "medium");
			}
		}

		maxId = 0;
		for (AnnotationFS annot : this.annoListPersons) {
			if (annot.getFeatureValueAsString(neId) != null && annot.getFeatureValueAsString(neId) != "") {
				Integer ids = Integer.parseInt(annot.getFeatureValueAsString(neId));
				if (ids > maxId) {
					maxId = ids;
				}
			}
		}

		// set null features of person annotations
		for (AnnotationFS annot : this.annoListAttributes) {
			if (annot.getFeatureValueAsString(neId) == null && annot.getFeatureValueAsString(neId) == "") {
				annot.setFeatureValueFromString(neId, String.valueOf(maxId));
				maxId++;
			}

		}

		ArrayList<AnnotationFS> overrides = new ArrayList<AnnotationFS>();
		for (AnnotationFS ov : editor.getCas().getAnnotationIndex(typOverride)) {
			overrides.add(ov);
		}

		// set input of Tableviewer
		if (!isPersonTableSelected) {
			attributeTableViewer.setInput(annoListAttributes.toArray(new AnnotationFS[0]));
			attributeTableViewer.refresh();
			ovFilter.setAnnotations(overrides, true);
		} else {
			viewer.setInput(annoListPersons.toArray(new AnnotationFS[0]));
			viewer.refresh();
			// ???? why !
		}

	}

	private void createPersonTableColumns(TableViewer viewer) {

		TableViewerColumn colName = createTableViewerColumn(viewer, "Name", 100, 0);
		colName.setLabelProvider(new ColumnLabelProvider() {
			@Override
			public String getText(Object element) {
				AnnotationFS p = (AnnotationFS) element;
				return p.getCoveredText();

			}

		});

		TableViewerColumn colFreq = createTableViewerColumn(viewer, "Freq.", 50, 1);
		colFreq.setLabelProvider(new ColumnLabelProvider() {
			@Override
			public String getText(Object element) {
				AnnotationFS p = (AnnotationFS) element;
				String id = p.getFeatureValueAsString(neId);
				if (freqMapAttributes.containsKey(id)) {
					return freqMapAttributes.get(id).toString();

				}

				else {
					return "1";
				}
			}
		});

		TableViewerColumn colID = createTableViewerColumn(viewer, "ID", 50, 2);
		colID.setLabelProvider(new ColumnLabelProvider() {
			@Override
			public String getText(Object element) {
				AnnotationFS p = (AnnotationFS) element;

				return p.getFeatureValueAsString(neId);
			}
		});

	}

	private TableViewerColumn createTableViewerColumn(TableViewer viewer, String viewer2, int bound, final int colNumber) {
		final TableViewerColumn viewerColumn = new TableViewerColumn(viewer, SWT.NONE);
		final TableColumn column = viewerColumn.getColumn();
		column.setText(viewer2);
		column.setWidth(bound);
		column.setResizable(true);
		column.setMoveable(true);
		column.addSelectionListener(getSelectionAdapter(viewer, column, colNumber));
		return viewerColumn;
	}

	private SelectionAdapter getSelectionAdapter(final TableViewer viewer2, final TableColumn column, final int index) {

		SelectionAdapter selectionAdapter = new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {

				if (viewer2.equals(attributeTableViewer)) {
					colViewerAttView.setColumn(index);
					int dir = colViewerAttView.getDirection();

					viewer2.getTable().setSortDirection(dir);
					viewer2.getTable().setSortColumn(column);
					viewer2.refresh();

				} else {
					colViewerComp.setColumn(index);
					int dir = colViewerComp.getDirection();
					viewer2.getTable().setSortDirection(dir);
					viewer2.getTable().setSortColumn(column);
					viewer2.refresh();
				}
			}
		};
		return selectionAdapter;
	}

	// Methods to change the CAS
	private void deleteAnnotation(AnnotationFS firstElement) {

		// delete all overrides in that stage

		AnnotationIndex<AnnotationFS> annotationIndex = editor.getCas().getAnnotationIndex(typOverride);
		ArrayList<AnnotationFS> toDelete = new ArrayList<AnnotationFS>();
		for (AnnotationFS anno : annotationIndex) {
			if (anno.getBegin() == firstElement.getBegin() && anno.getEnd() == firstElement.getEnd()) {
				toDelete.add(anno);
				// editor.removeAnnotation(anno);
			}
		}

		for (AnnotationFS a : toDelete) {
			editor.removeAnnotation(a);
		}

		editor.removeAnnotation(firstElement);

	}

	private void updateAnnotation(AnnotationFS firstElement, Feature feat, String string, boolean reload) {

		// if (feat.getName().equals(idFeat.getName())) {
		// String oldId = firstElement.getFeatureValueAsString(idFeat);
		// ICorefResolvingStrategy naiveResolver = new
		// NaiveResolvingStrategy(typ, typOverride, idFeat, oldId, string);
		// naiveResolver.resolve(editor.getCas(), firstElement);
		// }

		firstElement.setFeatureValueFromString(feat, string);

		// delete all overrides in that stage
		if (reload == true) {

			AnnotationIndex<AnnotationFS> annotationIndex = editor.getCas().getAnnotationIndex(typOverride);
			ArrayList<AnnotationFS> toDelete = new ArrayList<AnnotationFS>();
			for (AnnotationFS anno : annotationIndex) {
				if (anno.getBegin() == firstElement.getBegin() && anno.getEnd() == firstElement.getEnd()) {
					toDelete.add(anno);
				}
			}

			for (AnnotationFS a : toDelete) {
				editor.removeAnnotation(a);
			}
		}
		// add a true positive - only if none was already on this place - since
		// update is called alot
		// add a false negative

		if (reload) {
			AnnotationFS fss = editor.getCas().createAnnotation(typOverride, firstElement.getBegin(),
					firstElement.getEnd());

			this.editor.addAnnotation(fss);
		}
	}

	// boolean moveCursor
	private void changeHighlighting(int beg, int end, boolean b) {
		editor.highlightRange(beg, end - beg, true);

	}

	private void addAnnotation(AnnotationFS anno) {

		// add Annotation - means we add an Annotation of type NER also an
		// Override Type
		// to display that this annotation was already handled

		this.editor.addAnnotation(anno);

		// add the override Annotation
		CAS cas = this.editor.getCas();

		AnnotationFS fs = cas.createAnnotation(typOverride, anno.getBegin(), anno.getEnd());

		this.editor.addAnnotation(fs);

	}

	public List<AnnotationFS> getAnnoList() {
		return annoListAttributes;
	}

	public void setAnnoList(List<AnnotationFS> annoList) {
		this.annoListAttributes = annoList;
	}

	// boolean moveCursor

	public AnnotationEditorWidget getEditor() {
		return editor;
	}

	public TableViewer getViewer() {
		return viewer;
	}

	public void setViewer(TableViewer viewer) {
		this.viewer = viewer;
	}

	// TODO im sure this is slow with big texts...
	private AnnotationFS getNearestPersonToHighlight(int x) {

		if (activePersonMode == null) {
			return null;
		}

		List<AnnotationFS> personsWithSameIdList = new ArrayList<AnnotationFS>();
		for (AnnotationFS person : annoListPersons) {

			if (person.getFeatureValueAsString(neId).equals(activePersonMode.getFeatureValueAsString(neId))) {
				personsWithSameIdList.add(person);
			}
		}

		// find the one before and after

		AnnotationFS before = null;
		AnnotationFS next = null;
		boolean nextWasFound = false;
		for (AnnotationFS p : personsWithSameIdList) {

			if (p.getEnd() < x) {
				before = p;
			}

			if (p.getBegin() > x && nextWasFound == false) {
				nextWasFound = true;
				next = p;
			}
		}

		// check distances

		if (before == null && next != null) {
			return next;
		}

		else if (next == null && before != null) {
			return before;
		}

		else if (next == null && before == null) {
			return null;
		}

		else if (Math.abs(x - before.getEnd()) <= Math.abs(x - next.getBegin())) {
			return before;
		}

		else if (Math.abs(x - before.getEnd()) > Math.abs(x - next.getBegin())) {
			return next;
		}

		return annoListPersons.get(0);
	}

	public Text getNeuEnt() {
		return neuEnt;
	}

	public void setNeuEnt(Text neuEnt) {
		this.neuEnt = neuEnt;
	}

	@PreDestroy
	public void preDestroy() {
		// TODO Your code here
	}

	@Focus
	public void onFocus() {

		broker.send(IAnnotationEditorEvents.VIEW_STACK_FOCUS_CHANGED, "");

		if (!subscribed && this.editor != null) {
			onEditorInputChanged(this.editor);
		}

		if (this.editor == null) {

			// request the editor if possible
			broker.send(IAnnotationEditorEvents.REQUEST_ACTIVE_EDITOR, this);
			// super.standardSubscribeToEditorDocumentChangedEvents(AttributeAcceptingView.class);
		}

	}

	@Persist
	public void save() {
		// TODO Your code here
	}

	private AnnotationFS getNextToHighLight(AnnotationFS actual) {

		Collections.sort(this.annoListAttributes, new AnnotationComparator());

		for (int i = 0; i < annoListAttributes.size(); i++) {
			AnnotationFS actualH = annoListAttributes.get(i);
			if (actual.getBegin() < annoListAttributes.get(i).getBegin()) {
				if (isPersonModusActive) {

					// only return if the attribute id equals the id of the mode
					FeatureStructure featureValue = actualH.getFeatureValue(attNEFeature);

					if (featureValue != null) {

						if (featureValue.getFeatureValueAsString(neId).equals(
								activePersonMode.getFeatureValueAsString(neId))) {
							return actualH;
						}

					}

				} else {
					return annoListAttributes.get(i);
				}
			}
		}
		return null;

	}

	@Override
	public void onEditorClosed(org.osgi.service.event.Event arg0) {
		// TODO Auto-generated method stub

	}

	@Override
	public void onViewStackChanged(org.osgi.service.event.Event arg0) {
		// TODO Auto-generated method stub

	}

	@Override
	public void onAnnotationAdded(org.osgi.service.event.Event arg0) {
		AnnotationFS added = (AnnotationFS) arg0.getProperty(IEventBroker.DATA);

		renewPage();

		if (getJumpButton().getSelection()) {

			// TODO dirty solution
			AnnotationFS toHIghlight = getNextToHighLight(added);

			if (toHIghlight != null) {
				getEditor().highlightRange(toHIghlight.getBegin(), toHIghlight.getEnd() - toHIghlight.getBegin(), true);

				getEditor().setSelection(toHIghlight);
			}

		}

	}

	@Override
	public void onAnnotationRemoved(org.osgi.service.event.Event arg0) {
		AnnotationFS removed = (AnnotationFS) arg0.getProperty(IEventBroker.DATA);
		renewPage();

		if (getJumpButton().getSelection()) {
			AnnotationFS toHIghlight = getNextToHighLight(removed);

			if (toHIghlight != null) {
				getEditor().highlightRange(toHIghlight.getBegin(), toHIghlight.getEnd() - toHIghlight.getBegin(), true);

				getEditor().setSelection(toHIghlight);
			}
		}

	}

	@Override
	public void onAnnotationChanged(org.osgi.service.event.Event arg0) {
		// TODO Auto-generated method stub

	}

	@Override
	public void onAnnotationSelectionChanged(org.osgi.service.event.Event arg0) {
		List<AnnotationFS> selection = (List<AnnotationFS>) arg0.getProperty(IEventBroker.DATA);

		// System.out.println("this is called whenever a new annotation of the mode is selected");

		for (AnnotationFS a : selection) {
			if (a.getType().equals(typ)) {
				lastSelected = actualSelected;
				actualSelected = a;
				break;
			}
		}

	}

	@Override
	public void onEditorDoubleClicked(org.osgi.service.event.Event arg0) {
		lastTimeDoubleClicked = System.currentTimeMillis();
		List<AnnotationFS> selection = (List<AnnotationFS>) arg0.getProperty(IEventBroker.DATA);

		// TODO this has to be a little bit more sophisticated
		for (AnnotationFS a : selection) {
			if (a.getType().equals(neType)) {
				// set the id of the attribute to the one of the ne
				String featureValueAsString = a.getFeatureValueAsString(neId);

				if (lastSelected != null && featureValueAsString != null) {

					lastSelected.setFeatureValue(attNEFeature, a);
					updateAnnotation(lastSelected, attId, featureValueAsString, true);
				}

				// i wish that would work
				// else if (lastTextSelection != null) {
				//
				// // create an annotation and add it
				// AnnotationFS annotation =
				// editor.getCas().createAnnotation(typ,
				// lastTextSelection.x,
				// lastTextSelection.y);
				// // set the id to the id on which was clicked on
				//
				// annotation.setFeatureValueFromString(attId,
				// featureValueAsString);
				//
				// addAnnotation(annotation);
				// }

				break;
			}

		}

		try {
			Thread.sleep(150);
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		editor.invokeReload();

	}

	@Override
	public void onEditorWasScrolled(org.osgi.service.event.Event arg0) {
		Point visible = (Point) arg0.getProperty(IEventBroker.DATA);

		// change the annotations of the framefilter

		List<AnnotationFS> visibleList = new ArrayList<AnnotationFS>();
		for (AnnotationFS a : editor.getCas().getAnnotationIndex(neType)) {

			int lineAtOffset = editor.getLineAtOffset(a.getEnd());
			int topLine = visible.y;
			int bottomLine = visible.x;

			if (lineAtOffset >= topLine && lineAtOffset <= bottomLine) {
				visibleList.add(a);
			}
		}

		if (frameFilter != null && isPersonTableSelected) {
			frameFilter.setAnnotations(visibleList, frameFilterButton.getSelection());
		}

		renewPage();

	}

	@Override
	public void onEditorCaretChanged(org.osgi.service.event.Event arg0) {
		int caretOffset = (int) arg0.getProperty(IEventBroker.DATA);

		// highlight the according annotation in the table
		if (isPersonTableSelected) {

			AnnotationFS selectedAnno = null;
			for (AnnotationFS neAnno : editor.getCas().getAnnotationIndex(neType)) {

				if (neAnno.getBegin() <= caretOffset && neAnno.getEnd() >= caretOffset) {

					selectedAnno = neAnno;
					break;
				}
			}

			if (selectedAnno != null) {

				// hihglight in table
				IStructuredSelection sel = new StructuredSelection(selectedAnno);
				System.out.println(selectedAnno.getCoveredText());
				viewer.setSelection(sel, true);

			}

		}

		// what should be always done is to highlight the NE which is
		// assigned to that attribute

		// step 1 delete the old annotation
		List<AnnotationFS> toDelete = new ArrayList<AnnotationFS>();
		for (AnnotationFS old : editor.getCas().getAnnotationIndex(neDummyHighlightType)) {
			toDelete.add(old);
		}

		for (AnnotationFS a : toDelete) {
			editor.getCas().removeFsFromIndexes(a);
		}

		// step 2 check if there is the need to create a new annotation
		// (cursor is in side ther annotation of typ

		boolean isInsideAttribute = false;
		for (AnnotationFS attribute : editor.getCas().getAnnotationIndex(typ)) {

			if (caretOffset >= attribute.getBegin() && caretOffset <= attribute.getEnd()) {

				// found !!

				// also update the priority temporary and certainty

				updatePriorityButtons(attribute);

				updateCertainty(attribute);

				String tempo = attribute.getFeatureValueAsString(atttemporary);

				if (tempo == null) {

					buttonMaybeTemporaryAtt.setSelection(false);
					buttonTemporaryAtt.setSelection(false);
					buttonFixAtt.setSelection(false);
				}

				else if (tempo.startsWith("temp")) {

					buttonMaybeTemporaryAtt.setSelection(false);
					buttonTemporaryAtt.setSelection(true);
					buttonFixAtt.setSelection(false);
				}

				else if (tempo.startsWith("may")) {
					buttonMaybeTemporaryAtt.setSelection(true);
					buttonTemporaryAtt.setSelection(false);
					buttonFixAtt.setSelection(false);
				}

				else {
					buttonMaybeTemporaryAtt.setSelection(false);
					buttonTemporaryAtt.setSelection(false);
					buttonFixAtt.setSelection(true);

				}
				// get the according NE annotation
				FeatureStructure featureValue = attribute.getFeatureValue(attNEFeature);

				AnnotationFS neAnno = (AnnotationFS) featureValue;

				if (neAnno != null) {
					AnnotationFS fs = editor.getCas().createAnnotation(neDummyHighlightType, neAnno.getBegin(),
							neAnno.getEnd());

					editor.getCas().addFsToIndexes(fs);
				}
				isInsideAttribute = true;
				break;
			}
		}

		// if theres no attribute we are in and the mouse is hold down
		// and the personmode is active ...
		if (!isInsideAttribute && mouseDown && isPersonModusActive) {

			AnnotationFS next = getNearestPersonToHighlight(caretOffset);

			if (next != null) {
				AnnotationFS fs = editor.getCas()
						.createAnnotation(neDummyHighlightType, next.getBegin(), next.getEnd());

				editor.getCas().addFsToIndexes(fs);
			}

		}

		else if (editor.getActualSelectedText() != null
				&& editor.getActualSelectedText().x - editor.getActualSelectedText().y == 0) {

			// delete all
			List<AnnotationFS> toDelete2 = new ArrayList<AnnotationFS>();
			for (AnnotationFS old : editor.getCas().getAnnotationIndex(neDummyHighlightType)) {
				toDelete2.add(old);
			}

			for (AnnotationFS a : toDelete2) {
				editor.getCas().removeFsFromIndexes(a);
			}
		}

		editor.invokeReload();

	}

	@Override
	public void onEditorMouseUp(org.osgi.service.event.Event arg0) {
		// get the actual text selection
		mouseDown = false;
		if (System.currentTimeMillis() - lastTimeDoubleClicked < 500) {
			return;
		}
		Point actualSelectedText = editor.getActualSelectedText();

		if (actualSelectedText != null && actualSelectedText.x - actualSelectedText.y != 0) {

			AnnotationFS nearest = getNearestPersonToHighlight(actualSelectedText.x);

			// create an annotation if personmode is active
			if (isPersonModusActive) {

				if (nearest != null) {

					AnnotationFS fs = editor.getCas().createAnnotation(typ, actualSelectedText.x, actualSelectedText.y);

					fs.setFeatureValueFromString(attId, nearest.getFeatureValueAsString(neId));

					fs.setFeatureValue(attNEFeature, nearest);
					addAnnotation(fs);

				}

			}
		}

	}

	@Override
	public void onEditorMouseDown(org.osgi.service.event.Event arg0) {
		mouseDown = true;

	}

	@Override
	public void onEditorTextSelectionChanged(org.osgi.service.event.Event arg0) {
		Point point = (Point) arg0.getProperty(IEventBroker.DATA);

		// set the Textfield
		getNeuEnt().setText(getEditor().getWidget().getText().substring(point.x, point.y));

		// if we got the span of an annotation also create the selection
		// in the
		// tableviewer

		// update the last selections
		if (Math.abs(point.x - point.y) > 0) {

		}

		List<AnnotationFS> annoList = getAnnoList();

		for (AnnotationFS anno : annoList) {
			if (anno.getBegin() <= point.x && anno.getEnd() >= point.x) {
				StructuredSelection structuredSelection = new StructuredSelection(anno);
				if (isPersonTableSelected) {
					getViewer().setSelection(structuredSelection);
				}

				else {
					attributeTableViewer.setSelection(structuredSelection);
				}
				break;
			}
		}

	}

	@Override
	public void onEditorMouseMoved(org.osgi.service.event.Event e) {
		// TODO Auto-generated method stub

	}

	private void updateCertainty(AnnotationFS attribute) {
		String unCertain = attribute.getFeatureValueAsString(featIsUncertain);

		if (unCertain == null) {
			buttonUncertain.setSelection(false);
		} else if (unCertain.startsWith("t")) {
			buttonUncertain.setSelection(true);
		}

		else {
			buttonUncertain.setSelection(false);
		}
	}

	private void updatePriorityButtons(AnnotationFS attribute) {
		String prio = attribute.getFeatureValueAsString(attPriority);

		if (prio.startsWith("low")) {
			buttonLowPriority.setSelection(true);
			buttonMidPriority.setSelection(false);
			highPriority.setSelection(false);
		}

		else if (prio.startsWith("med")) {
			buttonLowPriority.setSelection(false);
			buttonMidPriority.setSelection(true);
			highPriority.setSelection(false);
		}

		else {
			buttonLowPriority.setSelection(false);
			buttonMidPriority.setSelection(false);
			highPriority.setSelection(true);
		}
	}

}