package de.uniwue.mk.kall.athen.attributeAcceptingView.widgets;

import java.util.HashMap;

import org.eclipse.jface.dialogs.Dialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

import de.uniwue.mk.kall.athen.appDelegation.hierarchie.IAnnotationEditorDialog;
import de.uniwue.mk.kall.athen.appDelegation.util.ApplicationPreferences;
import de.uniwue.mk.kall.athen.appDelegation.util.ApplicationUtil;

public class AttributeMappingPreferencesDialog extends Dialog implements IAnnotationEditorDialog {

	public AttributeMappingPreferencesDialog(Shell parentShell) {
		super(parentShell);
		preferences = new HashMap<String, String>();
	}

	HashMap<String, String> preferences;

	Label labelNEType;
	Text textNeType;

	// id that maps between Person and Attributes NE-id
	Label labelIDFeature;
	Text textIDFeature;

	// attribute array
	Label labelAttNamedEntity;
	Text textAttNamedEntity;

	// attribute temporary
	Label labelAttTemporary;
	Text textAttTemporary;

	// atttype
	Label labelAttType;
	Text textAttType;

	// attributeid
	Label labelAttIDFeature;
	Text textAttIDFeature;

	Label labelCategoryFeature;
	Text textCategoryFeature;

	Label labelFeatPriority;
	Text textFeatPriority;

	Label labelTypeOverride;
	Text textTypeOverride;

	Label labelIsUncertain;
	Text textIsUncertain;

	Button buttonSetBuiltIn;

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * org.eclipse.jface.dialogs.Dialog#createDialogArea(org.eclipse.swt.widgets
	 * .Composite)
	 */
	protected Control createDialogArea(Composite parent) {

		parent.getShell().setText("Specify View Settings");

		GridLayout layout = new GridLayout();

		layout.numColumns = 2;

		parent.setLayout(layout);

		// =======ADD WIDGETS====

		// ne type
		labelNEType = new Label(parent, SWT.NONE);
		textNeType = new Text(parent, SWT.None);

		// ne id
		labelIDFeature = new Label(parent, SWT.NONE);
		textIDFeature = new Text(parent, SWT.None);

		// ne FS Array
		labelAttNamedEntity = new Label(parent, SWT.NULL);
		textAttNamedEntity = new Text(parent, SWT.NULL);

		// att type
		labelAttType = new Label(parent, SWT.NULL);
		textAttType = new Text(parent, SWT.NULL);

		// att id
		labelAttIDFeature = new Label(parent, SWT.NULL);
		textAttIDFeature = new Text(parent, SWT.NULL);

		// att priority
		labelFeatPriority = new Label(parent, SWT.NONE);
		textFeatPriority = new Text(parent, SWT.None);

		// attribute temporary
		labelAttTemporary = new Label(parent, SWT.NULL);
		textAttTemporary = new Text(parent, SWT.NULL);

		// attributename
		labelCategoryFeature = new Label(parent, SWT.NONE);
		textCategoryFeature = new Text(parent, SWT.None);

		// att override
		labelTypeOverride = new Label(parent, SWT.NONE);
		textTypeOverride = new Text(parent, SWT.None);

		// att undertain

		labelIsUncertain = new Label(parent, SWT.NONE);
		textIsUncertain = new Text(parent, SWT.NONE);

		// texts

		labelNEType.setText(ApplicationPreferences.ATTRIBUTEAGREEMENTVIEW_NETYPE);
		labelIDFeature.setText(ApplicationPreferences.ATTRIBUTEAGREEMENTVIEW_NE_FEATURE_ID);
		labelAttNamedEntity.setText(ApplicationPreferences.ATTRIBUTEAGREEMENTVIEW_ATT_NEFEATURE);
		labelAttType.setText(ApplicationPreferences.ATTRIBUTEAGREEMENTVIEW_ATTTYPE);
		labelAttIDFeature.setText(ApplicationPreferences.ATTRIBUTEAGREEMENTVIEW_ATTID);
		labelFeatPriority.setText(ApplicationPreferences.ATTRIBUTEAGREEMENTVIEW_ATTPRIORITY);
		labelAttTemporary.setText(ApplicationPreferences.ATTRIBUTEAGREEMENTVIEW_ATTTEMPORARY);
		labelCategoryFeature.setText(ApplicationPreferences.ATTRIBUTEAGREEMENTVIEW_ATTCATEGORY);
		labelTypeOverride.setText(ApplicationPreferences.ATTRIBUTEAGREEMENTVIEW_ATT_TYPE_OVERRIDE);
		labelIsUncertain.setText(ApplicationPreferences.ATTRIBUTEAGREEMENTVIEW_ISUNCERTAIN);

		buttonSetBuiltIn = new Button(parent, SWT.None);

		buttonSetBuiltIn.setText("Use Built-In Configuration");

		buttonSetBuiltIn.addSelectionListener(new SelectionListener() {

			@Override
			public void widgetSelected(SelectionEvent e) {

				// set all preferences
				textNeType.setText("de.uniwue.kalimachos.coref.type.NamedEntity");
				textIDFeature.setText("ID");
				textAttType.setText("de.uniwue.kalimachos.coref.type.Attribute");
				textAttIDFeature.setText("AttributeID");
				textFeatPriority.setText("Priority");
				textAttTemporary.setText("Temporary");
				textCategoryFeature.setText("Category");
				textAttNamedEntity.setText("NamedEntity");
				textTypeOverride.setText("de.uniwue.kalimachos.coref.type.AttributeAlreadyHandled");
				textIsUncertain.setText("Uncertain");

			}

			@Override
			public void widgetDefaultSelected(SelectionEvent e) {
				widgetSelected(e);

			}
		});

		textNeType.setText(ApplicationUtil.getFromPreferences(labelNEType.getText(), "preference not found"));
		textIDFeature.setText(ApplicationUtil.getFromPreferences(labelIDFeature.getText(), "preference not found"));
		textAttNamedEntity.setText(ApplicationUtil.getFromPreferences(labelAttNamedEntity.getText(),
				"preference not found"));
		textAttType.setText(ApplicationUtil.getFromPreferences(labelAttType.getText(), "preference not found"));
		textAttIDFeature
				.setText(ApplicationUtil.getFromPreferences(labelAttIDFeature.getText(), "preference not found"));
		textFeatPriority
				.setText(ApplicationUtil.getFromPreferences(labelFeatPriority.getText(), "preference not found"));
		textAttTemporary
				.setText(ApplicationUtil.getFromPreferences(labelAttTemporary.getText(), "preference not found"));
		textCategoryFeature.setText(ApplicationUtil.getFromPreferences(labelCategoryFeature.getText(),
				"preference not found"));
		textTypeOverride
				.setText(ApplicationUtil.getFromPreferences(labelTypeOverride.getText(), "preference not found"));

		textIsUncertain.setText(ApplicationUtil.getFromPreferences(labelIsUncertain.getText(), "preference not found"));

		return parent;
	}

	@Override
	protected void okPressed() {

		// save to the preference map

		// TODO use the string constants instead of the literals
		this.preferences.put(labelNEType.getText(), textNeType.getText());
		this.preferences.put(labelIDFeature.getText(), textIDFeature.getText());
		this.preferences.put(labelAttNamedEntity.getText(), textAttNamedEntity.getText());
		this.preferences.put(labelAttType.getText(), textAttType.getText());
		this.preferences.put(labelAttIDFeature.getText(), textAttIDFeature.getText());
		this.preferences.put(labelFeatPriority.getText(), textFeatPriority.getText());
		this.preferences.put(labelAttTemporary.getText(), textAttTemporary.getText());
		this.preferences.put(labelCategoryFeature.getText(), textCategoryFeature.getText());
		this.preferences.put(labelTypeOverride.getText(), textTypeOverride.getText());
		this.preferences.put(labelIsUncertain.getText(), textIsUncertain.getText());

		setReturnCode(OK);
		close();
	}

	@Override
	public HashMap<String, String> getPreferences() {

		return this.preferences;
	}

}
