package de.uniwue.mk.kall.athen.attributeAcceptingView.widgets;

import java.util.HashSet;
import java.util.List;

import org.apache.uima.cas.text.AnnotationFS;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.jface.viewers.ViewerFilter;

public class FrameFilterAttViewPersonTable extends ViewerFilter {

	/*
	 * Filter that only displays the annotations that are currently visible in
	 * the editor (non-Javadoc)
	 * 
	 * @see
	 * org.eclipse.jface.viewers.ViewerFilter#select(org.eclipse.jface.viewers
	 * .Viewer, java.lang.Object, java.lang.Object)
	 */

	public FrameFilterAttViewPersonTable() {
		onScreenSet = new HashSet<AnnotationFS>();
	}

	private boolean filterActive;
	private HashSet<AnnotationFS> onScreenSet;

	@Override
	public boolean select(Viewer viewer, Object parentElement, Object element) {
		AnnotationFS p = (AnnotationFS) element;
		if (filterActive) {
			if (onScreenSet.contains(p)) {
				return true;
			}

			return false;
		}

		return true;
	}

	// should be called whenever the widget scrolls vertically
	public void setAnnotations(List<AnnotationFS> annoList, boolean filterActive) {
		// ensure that the value can be used for matching
		onScreenSet.clear();
		this.filterActive = filterActive;

		onScreenSet.addAll(annoList);

	}

}
