package de.uniwue.mk.kall.athen.attributeAcceptingView.widgets;

import java.util.HashSet;
import java.util.List;

import org.apache.uima.cas.Feature;
import org.apache.uima.cas.text.AnnotationFS;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.jface.viewers.ViewerFilter;

public class IDFilterAttViewPersonTable extends ViewerFilter {

	private HashSet<AnnotationFS> unique;

	private boolean filterActive;

	public IDFilterAttViewPersonTable() {
		unique = new HashSet<AnnotationFS>();
	}

	public void setAnnotations(List<AnnotationFS> annoList, Feature idFeat, boolean filterActive, String id) {
		// ensure that the value can be used for matching
		unique.clear();
		this.filterActive = filterActive;
		for (AnnotationFS anno : annoList) {

			if (anno.getFeatureValueAsString(idFeat).equals(id))
				unique.add(anno);
		}

	}

	@Override
	public boolean select(Viewer viewer, Object parentElement, Object element) {

		AnnotationFS p = (AnnotationFS) element;
		if (filterActive) {
			if (unique.contains(p)) {
				return true;
			}

			return false;
		}

		return true;
	}
}
