package de.uniwue.mk.kall.athen.corefExplanationview.widgets;

import java.util.HashMap;

import org.eclipse.jface.dialogs.Dialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

import de.uniwue.mk.kall.athen.appDelegation.hierarchie.IAnnotationEditorDialog;
import de.uniwue.mk.kall.athen.appDelegation.util.ApplicationPreferences;
import de.uniwue.mk.kall.athen.appDelegation.util.ApplicationUtil;

public class CorefExplainPreferencesDialog extends Dialog implements IAnnotationEditorDialog {

	HashMap<String, String> preferences;

	// type of the debug
	private Label labelDebugType;
	private Text textDebugType;

	// isNamedEntityFeature
	private Label labelisNEFeature;
	private Text textisNEFeature;

	// Gender
	private Label labelGenderFeature;
	private Text textGenderFeature;

	// Numerus
	private Label labelNumerusFeature;
	private Text textNumerusFeature;

	// Person
	private Label labelpersonFeature;
	private Text textpersonFeature;

	// isResolvedCorrectly
	private Label labelIsResolvedCorrectly;
	private Text textIsResolvedCorrectly;

	// isSubject
	private Label labelIsSubject;
	private Text textIsSubject;

	// id
	private Label labelID;
	private Text textID;

	// COnversationtype
	private Label labelConvType;
	private Text textConvType;

	// interaction agent
	private Label labelAgent;
	private Text textAgent;

	// interaktion recipient
	private Label labelRecipient;
	private Text textRecipient;

	// resolvedTo
	private Label labelResolvedTo;
	private Text textResolvedTo;
	Button buttonSetBuiltIn;

	public CorefExplainPreferencesDialog(Shell parentShell) {
		super(parentShell);

		preferences = new HashMap<String, String>();

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * org.eclipse.jface.dialogs.Dialog#createDialogArea(org.eclipse.swt.widgets
	 * .Composite)
	 */
	protected Control createDialogArea(Composite parent) {

		parent.getShell().setText("Specify View Settings");

		GridLayout layout = new GridLayout();

		layout.numColumns = 2;

		parent.setLayout(layout);

		// =======ADD WIDGETS====

		labelDebugType = new Label(parent, SWT.NONE);
		textDebugType = new Text(parent, SWT.NONE);

		labelisNEFeature = new Label(parent, SWT.NONE);
		textisNEFeature = new Text(parent, SWT.NONE);

		labelGenderFeature = new Label(parent, SWT.NONE);
		textGenderFeature = new Text(parent, SWT.NONE);

		labelNumerusFeature = new Label(parent, SWT.NONE);
		textNumerusFeature = new Text(parent, SWT.NONE);

		labelpersonFeature = new Label(parent, SWT.NONE);
		textpersonFeature = new Text(parent, SWT.NONE);

		labelIsResolvedCorrectly = new Label(parent, SWT.NONE);
		textIsResolvedCorrectly = new Text(parent, SWT.NONE);

		labelResolvedTo = new Label(parent, SWT.NONE);
		textResolvedTo = new Text(parent, SWT.NONE);

		labelIsSubject = new Label(parent, SWT.NONE);
		textIsSubject = new Text(parent, SWT.NONE);

		labelID = new Label(parent, SWT.NONE);
		textID = new Text(parent, SWT.NONE);

		labelConvType = new Label(parent, SWT.NONE);
		textConvType = new Text(parent, SWT.NONE);

		labelAgent = new Label(parent, SWT.NONE);
		textAgent = new Text(parent, SWT.NONE);

		labelRecipient = new Label(parent, SWT.NONE);
		textRecipient = new Text(parent, SWT.NONE);

		labelDebugType.setText("Enter CorefDebugType");
		labelisNEFeature.setText("Enter IsNEFeature");
		labelGenderFeature.setText("DebugGender Feature");
		labelNumerusFeature.setText("DebugNumerus Feature");
		labelpersonFeature.setText("Debug PersonFeature");
		labelIsResolvedCorrectly.setText("Enter IsResolvedCorrectly");
		labelID.setText("Enter Debug-ID");
		labelResolvedTo.setText("Enter ResolvedToFeature");
		labelIsSubject.setText("Enter Subject Feature");
		labelAgent.setText("Enter Agent Feature");
		labelRecipient.setText("Enter Recipient Feature");
		labelConvType.setText("Enter Conversation Type");

		buttonSetBuiltIn = new Button(parent, SWT.None);

		buttonSetBuiltIn.setText("Use Built-In Configuration");

		buttonSetBuiltIn.addSelectionListener(new SelectionListener() {

			@Override
			public void widgetSelected(SelectionEvent e) {

				// set all preferences

				textDebugType.setText("de.uniwue.mk.kallimachos.CoreferenceDebugtype");
				textisNEFeature.setText("IsNamedEntity");
				textGenderFeature.setText("Gender");
				textNumerusFeature.setText("Numerus");
				textpersonFeature.setText("Person");
				textIsResolvedCorrectly.setText("IsResolvedCorrectly");
				textID.setText("ID");
				textResolvedTo.setText("ResolvedTo");
				textIsSubject.setText("IsSubject");
				textAgent.setText("Agent");
				textRecipient.setText("Recipient");
				textConvType.setText("de.uniwue.kalimachos.coref.type.Conversation");

			}

			@Override
			public void widgetDefaultSelected(SelectionEvent e) {
				widgetSelected(e);

			}
		});

		textDebugType.setText(ApplicationUtil.getFromPreferences(ApplicationPreferences.EXPLAIN_COREF_DEBUGTYPE,
				"preference not found"));

		textisNEFeature.setText(ApplicationUtil.getFromPreferences(ApplicationPreferences.EXPLAIN_COREF_ISNE,
				"preference not found"));
		textGenderFeature.setText(ApplicationUtil.getFromPreferences(ApplicationPreferences.EXPLAIN_COREF_GENDER,
				"preference not found"));
		textNumerusFeature.setText(ApplicationUtil.getFromPreferences(ApplicationPreferences.EXPLAIN_COREF_NUMERUS,
				"preference not found"));
		textpersonFeature.setText(ApplicationUtil.getFromPreferences(ApplicationPreferences.EXPLAIN_COREF_PERSON,
				"preference not found"));
		textIsResolvedCorrectly.setText(ApplicationUtil.getFromPreferences(
				ApplicationPreferences.EXPLAIN_COREF_ISRESOLVEDCORRECTLY, "preference not found"));

		textID.setText(ApplicationUtil.getFromPreferences(ApplicationPreferences.EXPLAIN_COREF_ID_FEATURE,
				"preference not found"));
		textResolvedTo.setText(ApplicationUtil.getFromPreferences(ApplicationPreferences.EXPLAIN_COREF_RESOLVED_TO,
				"preference not found"));
		textIsSubject.setText(ApplicationUtil.getFromPreferences(ApplicationPreferences.EXPLAIN_COREF_ISSUBJECT,
				"preference not found"));

		textConvType.setText(ApplicationUtil.getFromPreferences(ApplicationPreferences.EXPLAIN_COREF_CONVTYPE,
				"preference not found"));

		textAgent.setText(ApplicationUtil.getFromPreferences(ApplicationPreferences.EXPLAIN_COREF_AGENT,
				"preference not found"));

		textRecipient.setText(ApplicationUtil.getFromPreferences(ApplicationPreferences.EXPLAIN_COREF_RECIPIENT,
				"preference not found"));

		return parent;
	}

	@Override
	protected void okPressed() {

		// save to the preference map

		// TODO use the string constants instead of the literals
		this.preferences.put(ApplicationPreferences.EXPLAIN_COREF_DEBUGTYPE, textDebugType.getText());
		this.preferences.put(ApplicationPreferences.EXPLAIN_COREF_GENDER, textGenderFeature.getText());
		this.preferences.put(ApplicationPreferences.EXPLAIN_COREF_NUMERUS, textNumerusFeature.getText());
		this.preferences.put(ApplicationPreferences.EXPLAIN_COREF_ISNE, textisNEFeature.getText());
		this.preferences.put(ApplicationPreferences.EXPLAIN_COREF_ISRESOLVEDCORRECTLY,
				textIsResolvedCorrectly.getText());
		this.preferences.put(ApplicationPreferences.EXPLAIN_COREF_PERSON, textpersonFeature.getText());
		this.preferences.put(ApplicationPreferences.EXPLAIN_COREF_ID_FEATURE, textID.getText());
		this.preferences.put(ApplicationPreferences.EXPLAIN_COREF_RESOLVED_TO, textResolvedTo.getText());
		this.preferences.put(ApplicationPreferences.EXPLAIN_COREF_ISSUBJECT, textIsSubject.getText());
		this.preferences.put(ApplicationPreferences.EXPLAIN_COREF_AGENT, textAgent.getText());
		this.preferences.put(ApplicationPreferences.EXPLAIN_COREF_RECIPIENT, textRecipient.getText());
		this.preferences.put(ApplicationPreferences.EXPLAIN_COREF_CONVTYPE, textConvType.getText());

		setReturnCode(OK);
		close();
	}

	@Override
	public HashMap<String, String> getPreferences() {

		return this.preferences;
	}

}
