package de.uniwue.mk.kall.athen.corefGlobalview.structs;

import org.apache.uima.cas.text.AnnotationFS;

public class CorefGlobalRelation {

	private AnnotationFS agens;
	private AnnotationFS recipient;
	private AnnotationFS relation;

	private String type;

	// a relation can change during the novel, therefore use a start and an end
	private int from;
	private int to;

	// how certain is the system about the output
	private ERelationCertainty certainty;

	private boolean userAccepted;

	private boolean isAttribute;

	public CorefGlobalRelation(AnnotationFS relation, AnnotationFS agens, AnnotationFS recipient, String type,
			int from, int to, ERelationCertainty certainty, boolean isAttribute, boolean userAccepted) {
		super();
		this.agens = agens;
		this.recipient = recipient;
		this.type = type;
		this.from = from;
		this.to = to;
		this.certainty = certainty;
		this.userAccepted = userAccepted;
		this.isAttribute = isAttribute;
		this.relation = relation;
	}

	public AnnotationFS getAgens() {
		return agens;
	}

	public void setAgens(AnnotationFS agens) {
		this.agens = agens;
	}

	public AnnotationFS getRelation() {
		return relation;
	}

	public void setRelation(AnnotationFS relation) {
		this.relation = relation;
	}

	public AnnotationFS getRecipient() {
		return recipient;
	}

	public void setRecipient(AnnotationFS recipient) {
		this.recipient = recipient;
	}

	public String getType() {
		return type;
	}

	public void setType(String type) {
		this.type = type;
	}

	public int getFrom() {
		return from;
	}

	public void setFrom(int from) {
		this.from = from;
	}

	public int getTo() {
		return to;
	}

	public void setTo(int to) {
		this.to = to;
	}

	public ERelationCertainty getCertainty() {
		return certainty;
	}

	public void setCertainty(ERelationCertainty certainty) {
		this.certainty = certainty;
	}

	public boolean isUserAccepted() {
		return userAccepted;
	}

	public void setUserAccepted(boolean userAccepted) {
		this.userAccepted = userAccepted;
	}

	public boolean isAttribute() {
		return isAttribute;
	}

	public void setAttribute(boolean isAttribute) {
		this.isAttribute = isAttribute;
	}

}
