package de.uniwue.mk.kall.athen.corefGlobalview.widgets;

import org.eclipse.jface.viewers.Viewer;
import org.eclipse.jface.viewers.ViewerComparator;
import org.eclipse.swt.SWT;

import de.uniwue.mk.kall.athen.corefGlobalview.structs.CorefGlobalStruct;
import de.uniwue.mk.kall.athen.corefGlobalview.ui.CorefGlobalView;

public class ColViewerComparatorCorefGlobalShell extends ViewerComparator {
	private int propertyIndex;
	private static final int DESCENDING = 1;
	private int direction = DESCENDING;
	private CorefGlobalView view;

	public ColViewerComparatorCorefGlobalShell(CorefGlobalView page) {
		this.propertyIndex = 0;
		this.view = page;
		direction = DESCENDING;

	}

	public int getDirection() {
		return direction == 1 ? SWT.DOWN : SWT.UP;
	}

	public void setColumn(int column) {
		if (column == this.propertyIndex) {
			// Same column as last sort; toggle the direction
			direction = 1 - direction;
		} else {
			// New column; do an ascending sort
			this.propertyIndex = column;
			direction = DESCENDING;
		}
	}

	@Override
	public int compare(Viewer viewer, Object e1, Object e2) {
		CorefGlobalStruct p1 = (CorefGlobalStruct) e1;
		CorefGlobalStruct p2 = (CorefGlobalStruct) e2;
		int rc = 0;

		switch (propertyIndex) {
		case 0:
			// name
			String p1Name = p1.getAnnos().get(0).getFeatureValueAsString(view.getNameFeature());
			String p2Name = p2.getAnnos().get(0).getFeatureValueAsString(view.getNameFeature());
			rc = p1Name.compareTo(p2Name);
			break;
		case 1:
			int diff = p1.getNrTrueName() - p2.getNrTrueName();
			if (diff < 0)
				rc = -1;
			else if (diff == 0)
				rc = 0;
			else
				rc = 1;
			break;

		case 2:
			diff = p1.getNrAppelatives() - p2.getNrAppelatives();
			if (diff < 0)
				rc = -1;
			else if (diff == 0)
				rc = 0;
			else
				rc = 1;
			break;

		case 3:
			diff = p1.getNrPron() - p2.getNrPron();
			if (diff < 0)
				rc = -1;
			else if (diff == 0)
				rc = 0;
			else
				rc = 1;
			break;
		default:
			// sort by name
			p1Name = p1.getAnnos().get(0).getFeatureValueAsString(view.getNameFeature());
			p2Name = p2.getAnnos().get(0).getFeatureValueAsString(view.getNameFeature());
			rc = p1Name.compareTo(p2Name);
		}
		// If descending order, flip the direction
		if (direction == DESCENDING) {
			rc = -rc;
		}
		return rc;
	}
}
