package de.uniwue.mk.kall.athen.corefGlobalview.widgets;

import java.util.List;

import org.apache.uima.cas.text.AnnotationFS;
import org.eclipse.e4.core.services.events.IEventBroker;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;

import de.uniwue.mk.kall.athen.corefGlobalview.ui.CorefGlobalView;
import de.uniwue.mk.kall.athen.widget.editor.AnnotationEditorWidget;

public class NavigationShell {

	CorefGlobalView view;
	AnnotationEditorWidget editor;

	private Shell shell;
	private List<AnnotationFS> highLightedAnnos;
	private int index = 0;

	public NavigationShell(IEventBroker broker, CorefGlobalView view, List<AnnotationFS> highLightedAnnos) {

		this.view = view;
		this.editor = view.getEditor();
		this.highLightedAnnos = highLightedAnnos;

		initUI();
	}

	private void initUI() {

		shell = new Shell(Display.getCurrent());

		shell.setText("Personeditingshell");
		shell.setLayout(new FillLayout(SWT.HORIZONTAL));

		shell.setSize(200, 200);

		initLayout();
		shell.pack();
		shell.open();

	}

	private void initLayout() {

		Button buttonNextAnno = new Button(shell, SWT.PUSH);
		buttonNextAnno.setText("Next");
		Button buttonPreviousAnno = new Button(shell, SWT.PUSH);
		buttonPreviousAnno.setText("Previous");

		buttonPreviousAnno.addSelectionListener(new SelectionAdapter() {

			@Override
			public void widgetSelected(SelectionEvent e) {
				index--;
				if (index < 0)
					index = 0;

				AnnotationFS a = highLightedAnnos.get(index);
				editor.highlightRange(a.getBegin(), a.getEnd() - a.getBegin(), true);

			}

		});

		buttonPreviousAnno.setText("Previous");

		buttonNextAnno.addSelectionListener(new SelectionAdapter() {

			@Override
			public void widgetSelected(SelectionEvent e) {
				index++;
				if (index >= highLightedAnnos.size())
					index = highLightedAnnos.size() - 1;

				AnnotationFS a = highLightedAnnos.get(index);
				editor.highlightRange(a.getBegin(), a.getEnd() - a.getBegin(), true);

			}

		});

	}

}
