package de.uniwue.mk.kall.athen.depparse.analyzer;

import java.util.List;

import org.apache.uima.cas.Feature;
import org.apache.uima.cas.text.AnnotationFS;
import org.eclipse.jface.dialogs.Dialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;

public class AnnoSelectionDialog extends Dialog {

	private Composite parent;

	private List<AnnotationFS> toSelect;

	private org.eclipse.swt.widgets.List list;

	private Feature featPhraseType;

	private AnnotationFS selectedAnno;

	private int selectionIndex = -1;

	public AnnoSelectionDialog(Shell parentShell, List<AnnotationFS> toSelect, Feature phraseType, AnnotationFS anno) {
		super(parentShell);

		this.toSelect = toSelect;
		this.featPhraseType = phraseType;
		this.selectedAnno = anno;

	}

	@Override
	protected Control createDialogArea(Composite parent) {

		Label labelFeatureValueFor = new Label(parent, SWT.NONE);
		labelFeatureValueFor.setText("Annotation: ");

		Label labelAnno = new Label(parent, SWT.NONE);
		labelAnno.setText(this.selectedAnno.getCoveredText() + "|"
				+ this.selectedAnno.getFeatureValueAsString(featPhraseType));

		list = new org.eclipse.swt.widgets.List(parent, SWT.BORDER | SWT.MULTI | SWT.V_SCROLL);

		for (AnnotationFS a : toSelect) {
			list.add(a.getCoveredText());
		}

		list.addSelectionListener(new SelectionAdapter() {

			@Override
			public void widgetSelected(SelectionEvent e) {

				AnnoSelectionDialog.this.selectionIndex = list.getSelectionIndex();

			}

		});

		return parent;
	}

	public AnnotationFS getSelectedAnno() {

		if (selectionIndex == -1)
			return null;

		return toSelect.get(selectionIndex);
	}

	protected void configureShell(Shell shell) {
		super.configureShell(shell);
		shell.setText("Select the according parent");
	}

}
