package de.uniwue.mk.kall.athen.depparse.analyzer;

import javax.annotation.PostConstruct;
import javax.annotation.PreDestroy;
import javax.inject.Inject;

import org.apache.uima.cas.CAS;
import org.apache.uima.cas.Feature;
import org.apache.uima.cas.Type;
import org.apache.uima.cas.text.AnnotationFS;
import org.eclipse.e4.core.services.events.IEventBroker;
import org.eclipse.e4.ui.di.Focus;
import org.eclipse.e4.ui.di.Persist;
import org.eclipse.e4.ui.workbench.modeling.EModelService;
import org.eclipse.e4.ui.workbench.modeling.EPartService;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Composite;

import de.uniwue.mk.kall.athen.appDelegation.hierarchie.IPerspectiveDecoupledPart;
import de.uniwue.mk.kall.athen.part.editor.subordinate.AEditorSubordinateViewPart;
import de.uniwue.mk.kall.athen.widget.editor.AnnotationEditorWidget;
import de.uniwue.mk.kall.athen.widget.editor.EEditorEvent;
import de.uniwue.mk.kall.athen.widget.editor.IAnnotationEditorListener;
import de.uniwue.mkrug.kall.typesystemutil.Util_impl;

public class DependencyParseAnalyzer extends AEditorSubordinateViewPart implements IAnnotationEditorListener {

	// CONSTANTS

	private static String viewId = "de.uniwue.mkrug.kallimachos.annotation.editor.part.dependencyparseanalyzer";

	// FIELDS======

	private static Class<?> CLASS_THIS = DependencyParseAnalyzer.class;

	@Inject
	private static IEventBroker broker;
	@Inject
	static EPartService partService;

	@Inject
	EModelService modelService;

	private Type sentenceType;

	private int editorSentBegin;

	// Widget
	private AnnotationEditorWidget widget;

	private Util_impl util;

	private int defaultTopMargin;

	private AnnotationFS editorSelectedSentence;

	private Type typeDepParseOldCAS;

	private Feature featWordIndexOldCAS;

	private Feature featHeadAnnoOldCAS;

	private Feature featDepRelOldCAS;

	@Inject
	public DependencyParseAnalyzer() {
		super();
		super.viewId = viewId;
		super.class_this = CLASS_THIS;
	}

	@PostConstruct
	public void postConstruct(Composite parent) {

		super.overlay = parent;
		super.part = partService.findPart(viewId);
		super.partService = partService;

		// this is important since in the struct the broker is not injected
		// yet!!
		super.setBroker(broker);
	}

	@PreDestroy
	public void preDestroy() {
		// TODO Your code here
	}

	@Focus
	public void onFocus() {
		super.onFocus();

	}

	public void initLayout(Composite parent) {

		// composite gets three coloumns

		parent.setLayoutData(new GridData(GridData.FILL_BOTH | GridData.GRAB_HORIZONTAL | GridData.GRAB_VERTICAL));

		// add a Label/textfield for the types that are about to be compared

		// add selection listener

		// add selection listener

		this.widget = new AnnotationEditorWidget(parent, SWT.NONE);
		this.widget.setNotifyDocumentChange(false);
		this.defaultTopMargin = this.editor.getWidget().getTopMargin();

	}

	public AnnotationEditorWidget getEditor() {
		return editor;
	}

	public void setEditor(AnnotationEditorWidget editor) {
		this.editor = editor;
	}

	public void renewPage() {

		super.overlay.layout();

	}

	@Persist
	public void save() {
		// TODO Your code here
	}

	private void copyAnnotationsFromOldToNew(CAS cas, AnnotationFS editorSelectedSentence2) {

		for (AnnotationFS depRel : editor.getCas().getAnnotationIndex(typeDepParseOldCAS)) {
			// TODO too much work

		}

	}

	@Override
	public void initModel() {
		// no model in this view

	}

	@Override
	public boolean initTypes() {
		// we do not need any types

		util = new Util_impl(super.editor.getCas());
		this.sentenceType = util.getSentenceType();

		this.typeDepParseOldCAS = util.getDependencyType();
		this.featWordIndexOldCAS = util.getWordNumerFeature();
		this.featDepRelOldCAS = util.depRelFeature();
		this.featHeadAnnoOldCAS = this.typeDepParseOldCAS.getFeatureByBaseName("HeadAnnotation");

		return true;
	}

	@Override
	public void performEditorChange(EEditorEvent eventType, Object changedObject) {
		// TODO Auto-generated method stub

		System.out.println("UIOUOIUioiou");
		System.out.println(eventType);

	}

}