package de.uniwue.mk.kall.athen.dualEditor.ui;

import org.eclipse.e4.core.services.events.IEventBroker;
import org.eclipse.swt.custom.CaretEvent;
import org.eclipse.swt.custom.CaretListener;

import de.uniwue.mk.kall.athen.events.IAnnotationEditorEvents;

public class DualCaretAdapter implements CaretListener {

	private long oldOffSetGold = 0;
	private long oldOffSetCompare = 0;

	// those do always reload
	private static final int RELOAD_DISTANCE = 2000000;

	private AnnotatorAgreementAnnotationEditor editor;

	private IEventBroker broker;

	public DualCaretAdapter(AnnotatorAgreementAnnotationEditor editor, IEventBroker broker) {
		this.editor = editor;
		this.broker = broker;
	}

	@Override
	public void caretMoved(CaretEvent event) {

		broker.send(IAnnotationEditorEvents.EDITOR_CARET_CHANGED, event.caretOffset);

		// if the Caret is Moved - check the diffrence in Position between
		if (oldOffSetGold == 0) {
			// invoke reloading of Annotation
			invokeReload(event.caretOffset, RELOAD_DISTANCE);
		}

		if (Math.abs(event.caretOffset - oldOffSetGold) > RELOAD_DISTANCE) {
			oldOffSetGold = event.caretOffset;
			// invoke reload of Annotations
			invokeReload(event.caretOffset, RELOAD_DISTANCE);
		}

		// modus - check

	}

	public long getOldOffSet() {
		return oldOffSetGold;
	}

	public void setOldOffSet(long oldOffSet) {
		this.oldOffSetGold = oldOffSet;
	}

	public static int getReloadDistance() {
		return RELOAD_DISTANCE;
	}

	private void invokeReload(int caretOffset, int reloadDistance) {

		// editor.invokeReload(caretOffset, reloadDistance);

	}

}
