package de.uniwue.mk.kall.athen.luceneView.widget;

import java.util.ArrayList;
import java.util.List;

import org.apache.uima.cas.Feature;
import org.apache.uima.cas.Type;
import org.apache.uima.cas.TypeSystem;
import org.eclipse.jface.viewers.ITreeContentProvider;
import org.eclipse.jface.viewers.Viewer;

public class TypeBrowserContentProvider implements ITreeContentProvider {

	@Override
	public void dispose() {
	}

	@Override
	public void inputChanged(Viewer viewer, Object oldInput, Object newInput) {
	}

	@Override
	public Object[] getElements(Object inputElement) {
		if (inputElement instanceof TypeSystem) {
			// collect all types in the typesystem in a list
			List<Type> list = new ArrayList<>();
			((TypeSystem) inputElement).getTypeIterator().forEachRemaining(
					type -> list.add(type));
			return list.toArray();
		}
		return null;
	}

	@Override
	public Object[] getChildren(Object parentElement) {
		if (parentElement instanceof Type) {
			// type -> return features
			return ((Type) parentElement).getFeatures()
					.stream().filter(feat -> feat.getRange().isPrimitive())
					.toArray();
		}
		return null;
	}

	@Override
	public Object getParent(Object element) {
		if (element instanceof Feature) {
			return ((Feature) element).getDomain();
		}
		return null;
	}

	@Override
	public boolean hasChildren(Object element) {
		if (element instanceof Type) {
			return ((Type) element).getNumberOfFeatures() > 0;
		}
		return false;
	}

}
