package de.uniwue.mk.kall.athen.luceneView.widget;

import javax.annotation.PreDestroy;

import org.apache.uima.cas.Feature;
import org.apache.uima.cas.Type;
import org.eclipse.jface.viewers.StyledCellLabelProvider;
import org.eclipse.jface.viewers.ViewerCell;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.GC;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.widgets.Display;

public class TypeBrowserLabelProvider extends StyledCellLabelProvider {
	private Image imgType;
	private Image imgFeature;


	public TypeBrowserLabelProvider() {
		createImages();
	}


	private void createImages() {
		// image for types
		imgType = new Image(Display.getCurrent(), 16, 16);
		GC gcType = new GC(imgType);
		gcType.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_BLUE));
		gcType.fillRectangle(0, 0, 16, 16);
		gcType.drawString("Type", 0, 0);
		gcType.dispose();
		// image for features
		imgFeature = new Image(Display.getCurrent(), 16, 16);
		GC gcFeature = new GC(imgFeature);
		gcFeature.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_CYAN));
		gcFeature.fillRectangle(0, 0, 16, 16);
		gcFeature.drawString("Feature", 0, 0);
		gcFeature.dispose();
	}

	@Override
	public void update(ViewerCell cell) {
		Object element = cell.getElement();

		if (element instanceof Type) {
			cell.setImage(imgType);
			cell.setText(((Type) element).getName());
		} else if (element instanceof Feature) {
			Feature feat = (Feature) element;
			cell.setImage(imgFeature);
			cell.setText(feat.getShortName() + " [" + feat.getRange().getShortName() + "]");
		}
		super.update(cell);
	}

	@PreDestroy
	public void dispose() {
		imgType.dispose();
		imgFeature.dispose();
	}
}
