package de.uniwue.mk.kall.athen.part.editor;

import java.util.HashSet;
import java.util.List;

import org.apache.uima.cas.Feature;
import org.apache.uima.cas.text.AnnotationFS;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.jface.viewers.ViewerFilter;

public class IDFilter extends ViewerFilter {

	private HashSet<AnnotationFS> unique;

	private boolean filterActive;

	public IDFilter() {
		unique = new HashSet<AnnotationFS>();
	}

	public void setAnnotations(List<AnnotationFS> annoList, Feature idFeat, boolean filterActive,
			List<AnnotationFS> overrides) {
		// ensure that the value can be used for matching
		unique.clear();
		this.filterActive = filterActive;
		HashSet<String> ids = new HashSet<String>();

		for (AnnotationFS ov : overrides) {

			for (AnnotationFS a : annoList) {

				if (a.getBegin() == ov.getBegin()) {
					if (!ids.contains(a.getFeatureValueAsString(idFeat))) {
						ids.add(a.getFeatureValueAsString(idFeat));
						unique.add(a);

					}
					break;
				}
			}
		}
		for (AnnotationFS anno : annoList) {

			if (!ids.contains(anno.getFeatureValueAsString(idFeat))) {
				ids.add(anno.getFeatureValueAsString(idFeat));
				unique.add(anno);
			}

		}
	}

	@Override
	public boolean select(Viewer viewer, Object parentElement, Object element) {

		AnnotationFS p = (AnnotationFS) element;
		if (filterActive) {
			if (unique.contains(p)) {
				return true;
			}

			return false;
		}

		return true;
	}
}
