package de.uniwue.mk.kall.athen.part.editor;

import java.util.ArrayList;
import java.util.List;

import org.apache.uima.cas.text.AnnotationFS;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.jface.viewers.ViewerFilter;

public class UnderlyingAnnotationFilter extends ViewerFilter {

	List<AnnotationFS> overrides;
	private boolean active;

	public UnderlyingAnnotationFilter() {
		overrides = new ArrayList<AnnotationFS>();
	}

	@Override
	public boolean select(Viewer viewer, Object parentElement, Object element) {
		AnnotationFS p = (AnnotationFS) element;

		if (!active)
			return true;
		for (AnnotationFS over : overrides) {
			if (over.getBegin() == p.getBegin() && over.getEnd() == p.getEnd()) {
				// needs a check for the id
				return true;
			}
		}

		return false;
	}

	public void setAnnotations(List<AnnotationFS> overrides, boolean active) {
		this.overrides.clear();
		this.overrides.addAll(overrides);
		this.active = active;

	}

}
