package de.uniwue.mk.kall.athen.part.editor.dialog;

import org.apache.uima.cas.text.AnnotationFS;
import org.eclipse.jface.dialogs.Dialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;

import de.uniwue.mk.kall.athen.widget.editor.AnnotationEditorWidget;

public class EditorDoubleClickDialog extends Dialog {

	private AnnotationFS selectedAnno;

	private UIMAFeatureChangeComposite featChangeComp;

	private AnnotationEditorWidget editor;

	public EditorDoubleClickDialog(Shell parentShell, AnnotationFS selectedAnno, AnnotationEditorWidget editor) {
		super(parentShell);

		this.editor = editor;
		this.selectedAnno = selectedAnno;
	}

	@Override
	protected Control createDialogArea(Composite parent) {

		Composite composite = (Composite) super.createDialogArea(parent);
		composite.setLayout(new GridLayout(1, false));

		Label labelSelectedAnno = new Label(parent, SWT.NONE);
		String text = selectedAnno.getCoveredText();
		labelSelectedAnno.setText("Change features for: " + ((text.length() < 100) ? text : text.substring(0, 100)));
		featChangeComp = new UIMAFeatureChangeComposite(parent, SWT.NONE, editor);

		featChangeComp.setAnnotation(selectedAnno);

		Button buttonRemoveAnno = new Button(parent, SWT.PUSH);
		buttonRemoveAnno.setText("Delete Annotation");

		buttonRemoveAnno.addSelectionListener(new SelectionAdapter() {

			@Override
			public void widgetSelected(SelectionEvent e) {

				editor.removeAnnotation(selectedAnno);
				EditorDoubleClickDialog.this.close();

			}

		});

		return composite;
	}

	protected void configureShell(Shell shell) {
		super.configureShell(shell);
		shell.setText("Feature Assigning Dialog");
	}
}
