package de.uniwue.mk.kall.athen.part.editor.dialog;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

import org.eclipse.swt.custom.StyledText;

import de.uniwue.mk.kall.athen.widget.editor.AnnotationEditorWidget;

public class EditorFindHandler implements FindListener {

	private String widgetText;
	SearchDialog dialog;
	private AnnotationEditorWidget editor;

	private int lastMatch;
	private String lastSearchString;

	public EditorFindHandler(StyledText widget, SearchDialog dialog, AnnotationEditorWidget editor) {

		this.widgetText = widget.getText();
		this.dialog = dialog;
		this.editor = editor;
	}

	@Override
	public boolean find() {

		String searchString = dialog.getSearchString();
		if (!searchString.equals(lastSearchString)) {
			lastMatch = 0;
		}
		lastSearchString = searchString;

		Matcher m = Pattern.compile(Pattern.quote(searchString)).matcher(widgetText);

		boolean find = m.find(lastMatch);

		if (find) {
			editor.highlightRange(m.start(), m.end() - m.start(), true);
			lastMatch = m.end();
		}
		return true;
	}
}
