package de.uniwue.mk.kall.athen.part.editor.dialog;

import java.util.HashMap;

import org.eclipse.e4.core.services.events.IEventBroker;
import org.eclipse.jface.dialogs.Dialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

import de.uniwue.mk.kall.athen.appDelegation.hierarchie.IAnnotationEditorDialog;
import de.uniwue.mk.kall.athen.appDelegation.util.ApplicationPreferences;
import de.uniwue.mk.kall.athen.appDelegation.util.ApplicationUtil;

public class EditorPreferencesDialog extends Dialog implements IAnnotationEditorDialog {

	HashMap<String, String> preferences;

	Label labelTSD;
	Text textTSD;
	Button buttonSelectTSD;
	Button buttonUseDefault;

	private Composite parent;

	public EditorPreferencesDialog(Shell parentShell, IEventBroker broker) {
		super(parentShell);

		preferences = new HashMap<String, String>();
	}

	protected Control createDialogArea(Composite parent) {

		parent.getShell().setText("Specify Path to UIMA Typesystem");

		this.parent = parent;

		GridLayout layout = new GridLayout();

		layout.numColumns = 3;

		parent.setLayout(layout);

		labelTSD = new Label(parent, SWT.NONE);
		textTSD = new Text(parent, SWT.NONE);

		buttonSelectTSD = new Button(parent, SWT.None);

		labelTSD.setText(ApplicationPreferences.EDITOR_TSD_PATH);

		textTSD.setText(ApplicationUtil.getFromPreferences(ApplicationPreferences.EDITOR_TSD_PATH,
				"no specified Typesystem found"));

		buttonSelectTSD.setText(" choose TypeSystem ");
		buttonSelectTSD.addSelectionListener(new SelectionListener() {

			@Override
			public void widgetSelected(SelectionEvent e) {

				FileDialog dlg = new FileDialog(EditorPreferencesDialog.this.parent.getShell(), SWT.NONE);

				dlg.setFilterNames(new String[] { "*.xml" });

				dlg.setFilterExtensions(new String[] { "*.xml" });

				dlg.setFilterPath(ApplicationUtil.getFromPreferences(ApplicationPreferences.WORKSPACE, "null"));

				String selectedTypeSystem = dlg.open();

				if (selectedTypeSystem != null) {
					textTSD.setText(selectedTypeSystem);

				}

			}

			@Override
			public void widgetDefaultSelected(SelectionEvent e) {
				widgetSelected(e);

			}
		});

		buttonUseDefault = new Button(parent, SWT.NONE);

		buttonUseDefault.setText("Use Default");

		buttonUseDefault.addSelectionListener(new SelectionListener() {

			@Override
			public void widgetSelected(SelectionEvent e) {

				// use coreftypesystem from that projects descriptor folder
				// TODO ??

			}

			@Override
			public void widgetDefaultSelected(SelectionEvent e) {

				widgetSelected(e);

			}
		});

		return parent;
	}

	@Override
	protected void okPressed() {

		// save to the preference map

		// TODO use the string constants instead of the literals
		this.preferences.put(this.labelTSD.getText(), this.textTSD.getText());

		setReturnCode(OK);
		close();
	}

	@Override
	public HashMap<String, String> getPreferences() {
		return this.preferences;
	}

}
