package de.uniwue.mk.kall.athen.part.editor.dialog;

import org.eclipse.jface.viewers.CellEditor;
import org.eclipse.jface.viewers.EditingSupport;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.jface.viewers.TextCellEditor;

import de.uniwue.kalimachos.coref.editor.drawingstructure.TypeStyleDataStructure;
import de.uniwue.mk.kall.athen.widget.editor.AnnotationEditorWidget;

public class LayerEditingSupport extends EditingSupport {

	private TableViewer viewer;
	private AnnotationEditorWidget corefEditor;

	private final CellEditor editor;

	public LayerEditingSupport(TableViewer viewer, AnnotationEditorWidget editor) {
		super(viewer);
		this.viewer = viewer;
		this.corefEditor = editor;
		this.editor = new TextCellEditor(viewer.getTable());
	}

	@Override
	protected CellEditor getCellEditor(Object element) {
		return editor;
	}

	@Override
	protected boolean canEdit(Object element) {
		return true;
	}

	@Override
	protected Object getValue(Object element) {
		return String.valueOf(((TypeStyleDataStructure) element).getLayer());
	}

	@Override
	protected void setValue(Object element, Object value) {
		TypeStyleDataStructure from = (TypeStyleDataStructure) element;
		int int1 = Integer.parseInt((String) value);
		if (int1 < 0) {
			throw new IllegalArgumentException("Only Values >= 0");
		}
		from.setLayer(int1);
		// layer changed !!!

		corefEditor.layerChanged(from);
		viewer.refresh();

	}

}