package de.uniwue.mk.kall.athen.part.editor.subordinate;

import org.apache.uima.cas.Feature;
import org.apache.uima.cas.text.AnnotationFS;
import org.eclipse.jface.viewers.CellEditor;
import org.eclipse.jface.viewers.ColumnViewer;
import org.eclipse.jface.viewers.EditingSupport;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.jface.viewers.TextCellEditor;

import de.uniwue.mk.kall.athen.widget.editor.AnnotationEditorWidget;

public class RightViewTableEditingSupport extends EditingSupport {

	private ColumnViewer viewer;
	private Feature feat;
	private TextCellEditor editor;
	private AnnotationEditorWidget annEditor;

	public RightViewTableEditingSupport(TableViewer viewer, Feature feat, AnnotationEditorWidget annEditor) {
		super(viewer);

		this.viewer = viewer;
		this.editor = new TextCellEditor(viewer.getTable());
		this.feat = feat;
		this.annEditor = annEditor;
	}

	@Override
	protected void setValue(Object element, Object value) {
		AnnotationFS p = (AnnotationFS) element;

		p.setFeatureValueFromString(feat, (String) value);

		annEditor.changeAnnotation(p);

		viewer.update(element, null);

	}

	@Override
	protected Object getValue(Object element) {
		AnnotationFS p = (AnnotationFS) element;

		return p.getFeatureValueAsString(feat);
	}

	@Override
	protected CellEditor getCellEditor(Object element) {
		return this.editor;
	}

	@Override
	protected boolean canEdit(Object element) {
		return true;
	}

}
