package de.uniwue.mk.kall.athen.posView.ui;

import java.util.ArrayList;
import java.util.List;

import javax.inject.Inject;

import org.eclipse.swt.custom.StyleRange;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.widgets.Display;

import de.uniwue.kalimachos.coref.editor.drawingstructure.AnnoStyle;
import de.uniwue.mk.kall.athen.part.editor.subordinate.ARightViewTablePart;
import de.uniwue.mk.kall.athen.part.editor.subordinate.TableColumnStruct;
import de.uniwue.mk.kall.editorPainting.paintingstrategies.specialized.POSDrawingStrategy;

public class POSTaggingView extends ARightViewTablePart {

	private static final String viewId = "de.uniwue.mkrug.kallimachos.annotation.editor.part.21";

	@Inject
	public POSTaggingView() {
		super(viewId);
		// set the values in the parent class
		super.CLASS_THIS = POSTaggingView.class;
		super.viewId = viewId;

		// types
		super.typeHandledS = "de.uniwue.kallimachos.coref.type.posAlreadyHandled";
		super.typeModusS = "de.uniwue.kalimachos.coref.type.POS";

		String featPOS = "POSTag";
		String featLemma = "Lemma";

		// yellow
		StyleRange rangeModus = new StyleRange();
		rangeModus.background = new Color(Display.getCurrent(), 255, 247, 255);
		AnnoStyle styleModus = new AnnoStyle(new POSDrawingStrategy(rangeModus, featPOS), rangeModus);
		super.styleModus = styleModus;

		List<TableColumnStruct> columns = new ArrayList<TableColumnStruct>();

		columns.add(new TableColumnStruct(FEAT_COVERED_TEXT, 100, "Text"));
		columns.add(new TableColumnStruct(featPOS, 80, "POSTAG"));
		columns.add(new TableColumnStruct(featLemma, 100, "Lemma"));

		super.columns = columns;

	}
}
