package de.uniwue.mk.kall.athen.projectExplorer.actions;

import java.io.File;

import javax.inject.Inject;

import org.eclipse.e4.core.services.events.IEventBroker;
import org.eclipse.jface.action.Action;
import org.eclipse.swt.widgets.TreeItem;

import de.uniwue.mk.kall.athen.events.IAnnotationEditorEvents;

public class DeleteResourceAction extends Action {

	private TreeItem[] items;

	@Inject
	IEventBroker broker;

	public DeleteResourceAction(TreeItem[] items, IEventBroker broker) {
		super("Lschen");
		this.items = items;
		this.broker = broker;

	}

	@Override
	public void run() {

		// send event to the manager so that he can delete the correction

		for (TreeItem item : items) {

			if (item.getData() instanceof File) {

				File f = (File) item.getData();

				f.delete();
			}

		}
		broker.send(IAnnotationEditorEvents.FILE_DELETED_ACTION_EVENT, "");

	}

}
