package de.uniwue.mk.kall.athen.projectExplorer.actions;

import java.io.File;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.StandardCopyOption;

import org.eclipse.e4.core.services.events.IEventBroker;
import org.eclipse.jface.action.Action;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.Shell;

import de.uniwue.mk.kall.athen.appDelegation.util.ApplicationPreferences;
import de.uniwue.mk.kall.athen.appDelegation.util.ApplicationUtil;
import de.uniwue.mk.kall.athen.events.IAnnotationEditorEvents;

public class ImportDataAction extends Action {
	private static String fileSeparator = System.getProperty("file.separator");
	private IEventBroker broker;
	private Shell shell;
	private File parent;

	public ImportDataAction(IEventBroker broker, Shell shell, File parent) {
		super("Import Data");
		this.shell = shell;
		this.broker = broker;
		this.parent = parent;

	}

	@Override
	public void run() {

		FileDialog fd = new FileDialog(shell, SWT.OPEN | SWT.MULTI);

		fd.setText("Choose .xmi or textfiles to open");
		fd.setFilterPath(ApplicationUtil.getFromPreferences(ApplicationPreferences.WORKSPACE, "null"));
		String[] filterExt = { "*.txt", "*.xmi" };

		fd.setFilterExtensions(filterExt);
		String selected = fd.open();

		String folder = new File(selected).getParent();

		String[] fileNames = fd.getFileNames();

		for (String path : fileNames) {

			String name = new File(path).getName();

			File toCopy = new File(parent.getAbsolutePath() + fileSeparator + name);

			File pathFile = new File(folder + fileSeparator + name);

			try {
				Files.copy(pathFile.toPath(), toCopy.toPath(), StandardCopyOption.REPLACE_EXISTING);
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}

		}

		broker.send(IAnnotationEditorEvents.RELOAD_PROJECTS, "");

	}
}
