package de.uniwue.mk.kall.athen.projectExplorer.actions;

import java.awt.Desktop;
import java.io.File;
import java.io.IOException;

import javax.inject.Inject;

import org.eclipse.e4.core.services.events.IEventBroker;
import org.eclipse.e4.ui.workbench.modeling.EPartService;
import org.eclipse.jface.action.Action;

import de.uniwue.mk.kall.athen.events.IAnnotationEditorEvents;

public class OpenXMIResourceAction extends Action {

	private File file;

	@Inject
	EPartService partService;

	@Inject
	IEventBroker broker;

	public OpenXMIResourceAction(File file2, IEventBroker broker, EPartService partService) {
		super("Open");
		this.file = file2;
		this.broker = broker;
		this.partService = partService;

	}

	@Override
	public void run() {

		// send event to the manager so that he can delete the correction

		if (file.getAbsolutePath().endsWith(".xmi")) {

			broker.send(IAnnotationEditorEvents.OPEN_XMI_REQUESTED, file);
		}

		else if (file.getAbsolutePath().endsWith(".xml") || file.getAbsolutePath().endsWith(".txt")) {
			if (file.exists()) {

				try {
					Desktop.getDesktop().open(file);
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
		}

		else {
			// shall this editor be able to open all kinds of files ?
		}

	}

}
