package de.uniwue.mk.kall.athen.projectExplorer.conversion;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;

import org.apache.uima.cas.CAS;
import org.apache.uima.cas.impl.XmiCasDeserializer;
import org.apache.uima.cas.impl.XmiCasSerializer;
import org.xml.sax.SAXException;

import de.uniwue.mkrug.kall.typesystemutil.Util_impl;

public class XMIDocument extends ADocument {

	public XMIDocument(Object content, EFormat format) {
		super(content, format, ".xmi");

	}

	// the content of this document is a CAS
	@Override
	public Object getContent() {
		return this.content;
	}

	@Override
	public void serialize(File toFile) {
		toFile = DocumentFormatUtil.formatFileEnding(toFile, this);
		FileOutputStream streamOut;
		try {
			streamOut = new FileOutputStream(toFile);
			XmiCasSerializer.serialize((CAS) this.content, streamOut);
			streamOut.close();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (SAXException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}

	@Override
	public void deserialize(File toDeserialize) {
		CAS cas = Util_impl.createCas();
		try {
			FileInputStream fileInputStream = new FileInputStream(toDeserialize);
			XmiCasDeserializer.deserialize(fileInputStream, cas);
			fileInputStream.close();
		} catch (SAXException | IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		// set the content
		this.content = cas;

	}

}
