package de.uniwue.mk.kall.athen.projectExplorer.ui;

import java.io.File;

import org.eclipse.jface.viewers.ITreeContentProvider;
import org.eclipse.jface.viewers.Viewer;

import de.uniwue.mk.kall.athen.projectExplorer.projectDescription.AnnotationWorkspace;
import de.uniwue.mk.kall.athen.projectExplorer.projectDescription.IAnnotationProject;

public class ProjectExplorerContentProvider implements ITreeContentProvider {

	@Override
	public void dispose() {
	}

	@Override
	public Object[] getElements(Object inputElement) {

		if (inputElement instanceof AnnotationWorkspace) {

			AnnotationWorkspace ws = (AnnotationWorkspace) inputElement;

			return ws.getProjects().toArray(new IAnnotationProject[0]);
		}

		else if (inputElement instanceof IAnnotationProject) {

			IAnnotationProject proj = (IAnnotationProject) inputElement;

			File[] fArr = new File[3];

			fArr[0] = proj.getDescFolder();
			fArr[1] = proj.getInputFolder();
			fArr[2] = proj.getOutputFolder();

			return fArr;

		}

		System.out.println(inputElement.getClass());
		return (File[]) inputElement;
	}

	@Override
	public Object[] getChildren(Object parentElement) {

		if (parentElement instanceof IAnnotationProject) {

			IAnnotationProject proj = (IAnnotationProject) parentElement;

			File[] fArr = new File[3];

			fArr[0] = proj.getDescFolder();
			fArr[1] = proj.getInputFolder();
			fArr[2] = proj.getOutputFolder();

			return fArr;

		}

		File file = (File) parentElement;
		return file.listFiles();
	}

	@Override
	public Object getParent(Object element) {

		// TODO this seems wrong

		if (element instanceof String) {
			File f = new File((String) element);
			return f.getParentFile();
		}

		if (element instanceof IAnnotationProject) {
			IAnnotationProject proj = (IAnnotationProject) element;

			return proj.getProjectFolder().getParent();
		}
		File file = (File) element;
		return file.getParentFile();
	}

	@Override
	public boolean hasChildren(Object element) {

		if (element instanceof IAnnotationProject) {
			return true;
		}

		File file = (File) element;
		if (file.isDirectory()) {
			return true;
		}
		return false;
	}

	@Override
	public void inputChanged(Viewer viewer, Object oldInput, Object newInput) {
		// TODO Auto-generated method stub

	}

}
