package de.uniwue.mk.kall.athen.projectExplorer.ui;

import java.io.File;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.StandardCopyOption;
import java.util.Iterator;

import org.eclipse.jface.util.LocalSelectionTransfer;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.jface.viewers.ViewerDropAdapter;
import org.eclipse.swt.dnd.DropTargetEvent;
import org.eclipse.swt.dnd.FileTransfer;
import org.eclipse.swt.dnd.TransferData;

public class ProjectExplorerDropAdapter extends ViewerDropAdapter {

	public ProjectExplorerDropAdapter(Viewer viewer) {
		super(viewer);
	}

	@Override
	public boolean performDrop(Object event) {

		return false;
	}

	@Override
	public void drop(DropTargetEvent event) {
		// even has "To" information
		// int location = this.determineLocation(event);
		File to = (File) determineTarget(event);

		if (LocalSelectionTransfer.getTransfer().isSupportedType(event.currentDataType)) {
			IStructuredSelection sel = (IStructuredSelection) LocalSelectionTransfer.getTransfer().getSelection();
			IStructuredSelection struct = (IStructuredSelection) sel;

			Iterator iterator = struct.iterator();

			while (iterator.hasNext()) {

				Path path = ((File) iterator.next()).toPath();
				File toFile = new File(to.getAbsolutePath() + "/" + path.toFile().getName());
				try {
					Files.move(path, toFile.toPath(), StandardCopyOption.REPLACE_EXISTING);
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}

			}

			// File from = (File) struct.getFirstElement();
		}
		
		else if(FileTransfer.getInstance().isSupportedType(event.currentDataType)){
			
			//retrieve all files
			if(event.data instanceof String[]){
				String[] fileNames = (String[]) event.data;
				
				for(String s : fileNames){
					File toFile = new File(to.getAbsolutePath() + "/" + new File(s).getName());
					try {
						Files.move(new File(s).toPath(), toFile.toPath(), StandardCopyOption.REPLACE_EXISTING);
					} catch (IOException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
				}
			}
		}

		super.drop(event);
	}

	@Override
	public boolean validateDrop(Object target, int operation, TransferData transferType) {

		if (target instanceof File) {
			File f = (File) target;

			return f.isDirectory();

		}
		return false;
	}

}
