package de.uniwue.mk.kall.athen.relationview.ui;

import org.apache.uima.cas.Feature;
import org.apache.uima.cas.text.AnnotationFS;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.jface.viewers.ViewerComparator;
import org.eclipse.swt.SWT;

public class ColViewerComparatorRelationView extends ViewerComparator {
	private int propertyIndex;
	private static final int DESCENDING = 1;
	private int direction = DESCENDING;
	private Feature agens2;
	private Feature type;
	private Feature agens;
	private RelationAnnotationView page;

	public ColViewerComparatorRelationView(Feature agens2, Feature type, Feature agens, RelationAnnotationView page) {
		this.propertyIndex = 0;
		this.agens = agens;
		this.type = type;
		this.page = page;
		this.agens2 = agens2;
		direction = DESCENDING;

	}

	public int getDirection() {
		return direction == 1 ? SWT.DOWN : SWT.UP;
	}

	public void setColumn(int column) {
		if (column == this.propertyIndex) {
			// Same column as last sort; toggle the direction
			direction = 1 - direction;
		} else {
			// New column; do an ascending sort
			this.propertyIndex = column;
			direction = DESCENDING;
		}
	}

	@Override
	public int compare(Viewer viewer, Object e1, Object e2) {
		AnnotationFS p1 = (AnnotationFS) e1;
		AnnotationFS p2 = (AnnotationFS) e2;
		int rc = 0;

		switch (propertyIndex) {
		case 0:
			// text
			rc = p1.getCoveredText().compareTo(p2.getCoveredText());
			break;
		case 1:
			// agens

			AnnotationFS annAgensP1 = ((AnnotationFS) p1.getFeatureValue(agens));

			String agensP1 = (annAgensP1 == null) ? "null" : annAgensP1.getCoveredText();
			AnnotationFS annAgensP2 = ((AnnotationFS) p2.getFeatureValue(agens));

			String agensP2 = (annAgensP2 == null) ? "null" : annAgensP2.getCoveredText();
			rc = agensP1.compareTo(agensP2);
			break;
		case 2:
			// agens2
			AnnotationFS annAgens2P1 = ((AnnotationFS) p1.getFeatureValue(agens2));

			String agens2P1 = (annAgens2P1 == null) ? "null" : annAgens2P1.getCoveredText();
			AnnotationFS annAgens2P2 = ((AnnotationFS) p2.getFeatureValue(agens2));

			String agens2P2 = (annAgens2P2 == null) ? "null" : annAgens2P2.getCoveredText();
			rc = agens2P1.compareTo(agens2P2);
			break;
		case 3:
			// typ
			String typP1 = p1.getFeatureValueAsString(type);

			if (typP1 == null) {
				typP1 = "null";
			}

			String typP2 = p2.getFeatureValueAsString(type);
			if (typP2 == null) {
				typP2 = "null";
			}

			rc = typP1.compareTo(typP2);
			break;

		default:
			rc = p1.getCoveredText().compareTo(p2.getCoveredText());
		}
		// If descending order, flip the direction
		if (direction == DESCENDING) {
			rc = -rc;
		}
		return rc;
	}
}
