package de.uniwue.mk.kall.athen.relationview.ui;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

import javax.annotation.PostConstruct;
import javax.inject.Inject;

import org.apache.uima.cas.CAS;
import org.apache.uima.cas.CASException;
import org.apache.uima.cas.FSIterator;
import org.apache.uima.cas.Feature;
import org.apache.uima.cas.Type;
import org.apache.uima.cas.text.AnnotationFS;
import org.apache.uima.cas.text.AnnotationIndex;
import org.apache.uima.ruta.rule.AnnotationComparator;
import org.eclipse.e4.core.services.events.IEventBroker;
import org.eclipse.e4.ui.di.Focus;
import org.eclipse.e4.ui.model.application.MApplication;
import org.eclipse.e4.ui.model.application.ui.MElementContainer;
import org.eclipse.e4.ui.model.application.ui.MUIElement;
import org.eclipse.e4.ui.model.application.ui.basic.MPart;
import org.eclipse.e4.ui.workbench.modeling.EModelService;
import org.eclipse.e4.ui.workbench.modeling.EPartService;
import org.eclipse.jface.dialogs.InputDialog;
import org.eclipse.jface.viewers.ArrayContentProvider;
import org.eclipse.jface.viewers.ColumnLabelProvider;
import org.eclipse.jface.viewers.ColumnViewerToolTipSupport;
import org.eclipse.jface.viewers.ComboViewer;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.jface.viewers.TableViewerColumn;
import org.eclipse.jface.viewers.ViewerCell;
import org.eclipse.jface.window.ToolTip;
import org.eclipse.jface.window.Window;
import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.StyleRange;
import org.eclipse.swt.events.KeyAdapter;
import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.MouseListener;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.MenuItem;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.Text;
import org.osgi.service.event.Event;

import de.uniwue.kalimachos.coref.editor.drawingstructure.AnnoStyle;
import de.uniwue.kalimachos.coref.paintingStrategies.BackgroundDrawingStrategy;
import de.uniwue.mk.kall.athen.appDelegation.hierarchie.IPerspectiveDecoupledPart;
import de.uniwue.mk.kall.athen.appDelegation.ui.MasterPart;
import de.uniwue.mk.kall.athen.appDelegation.util.ApplicationPreferences;
import de.uniwue.mk.kall.athen.appDelegation.util.ApplicationUtil;
import de.uniwue.mk.kall.athen.events.IAnnotationEditorEvents;
import de.uniwue.mk.kall.athen.part.editor.subordinate.AEditorSubordinateViewPart;
import de.uniwue.mk.kall.athen.widget.editor.AnnotationEditorWidget;
import de.uniwue.mk.kall.editorPainting.paintingstrategies.specialized.NamedEntityDrawingStrategy;
import de.uniwue.mk.kall.editorPainting.paintingstrategies.specialized.RelationDrawingStrategy;

public class RelationAnnotationView extends AEditorSubordinateViewPart {

	// TODO not refactored
	private CAS cas;
	private static final Class<RelationAnnotationView> CLASS_THIS = RelationAnnotationView.class;
	@Inject
	static EPartService partService;

	@Inject
	MApplication app;

	@Inject
	static IEventBroker broker;

	@Inject
	EModelService modelService;

	static String viewId = "de.uniwue.mkrug.kallimachos.annotation.editor.part.15";

	// the main type of this view
	private Type relationType;

	private String typeTempString = "de.uniwue.kalimachos.coref.type.temp3";

	// override type of this view
	private Type typeOverwrite;
	private Type indicatorType;

	// Features
	private Feature agensFeature;
	private Feature agens2Feature;
	private Feature typeFeature;
	private Feature descriptionFeature;

	// the "model"
	private List<AnnotationFS> annoList;

	// helper - for mouseselection per double click
	private AnnotationFS actualSelection = null;
	private Point lastClick = null;
	private boolean actualLastChanged = false;
	private Point lastMousePosition;

	// widgets
	private TableViewer viewer;
	private Button buttonAddNew;
	private Button buttonAccept;
	private Button buttonDelete;
	private Button buttonJump;
	private Button buttonAddMetaAnnotation;
	private ColViewerComparatorRelationView colViewerComp;
	private ComboViewer comboViewer;
	private Type neType;
	private Button buttonJumpToNext;
	private Text textMouseSelection;
	private Type tempType;
	private Feature neName;
	private Text textMouseSelection2;
	private AnnotationFS actualSelection2;
	private Button buttonCreateNewRelation;
	private Button buttonToNextIndicator;

	@Inject
	public RelationAnnotationView() {
		super();
		super.viewId = viewId;
		super.class_this = CLASS_THIS;
	}

	@PostConstruct
	public void postConstruct(Composite parent) {

		System.out.println("Construct RelationView");

		super.overlay = parent;
		super.overlay.setLayout(new FillLayout());

		super.part = partService.findPart(viewId);
	}

	@Override
	protected void initLayout(Composite parent) {

		GridLayout mainLayout = new GridLayout(1, true);
		parent.setLayout(mainLayout);

		// layout is spreaded into 3 Composites ( i hope this will not be
		// changed too much afterwards...)

		// firs compositer for buttons
		initLayoutForComposite1(parent);

		// second layout for a dropdown box unneeded
		// initLayoutForComposite2(parent);
		// composite 5 - mouse selection helper and jumpButton
		initLayoutForComposite5(parent);

		// init layout for compopsite 3
		initLayoutForComposite3(parent);

		// init layout for componetn 4 - export to gephi
		initLayoutForComposite4(parent);

		// composite 3 has the table with all relations
		initLayoutForComposite6(parent);

		// ColumnViewerToolTipSupport.enableFor(viewer, ToolTip.NO_RECREATE);

	}

	private void initLayoutForComposite5(Composite parent) {

		Composite c5 = new Composite(parent, SWT.BORDER);

		c5.setLayout(new GridLayout(2, true));

		Label labelMouseSelection = new Label(c5, SWT.BOLD);
		labelMouseSelection.setText("Person1-Selection: ");

		textMouseSelection = new Text(c5, SWT.BORDER);
		textMouseSelection.setLayoutData(new GridData(GridData.GRAB_HORIZONTAL | GridData.FILL_HORIZONTAL));

		if (actualSelection != null) {
			textMouseSelection.setText(actualSelection.getCoveredText());
		}
		textMouseSelection.setEditable(false);

		Label labelMouseSelection2 = new Label(c5, SWT.BOLD);
		labelMouseSelection2.setText("Person2-Selection: ");

		textMouseSelection2 = new Text(c5, SWT.BORDER);
		textMouseSelection2.setLayoutData(new GridData(GridData.GRAB_HORIZONTAL | GridData.FILL_HORIZONTAL));

		if (actualSelection2 != null) {
			textMouseSelection2.setText(actualSelection2.getCoveredText());
		}
		textMouseSelection2.setEditable(false);

		Label labelCreateNew = new Label(c5, SWT.PUSH);
		labelCreateNew.setText("Create new Annotation: ");
		buttonCreateNewRelation = new Button(c5, SWT.PUSH);
		buttonCreateNewRelation.setText(" Create ");

		buttonCreateNewRelation.addSelectionListener(new SelectionListener() {

			@Override
			public void widgetSelected(SelectionEvent e) {

				if (actualSelection != null && actualSelection2 != null) {

					int beg = Math.min(actualSelection.getBegin(), actualSelection2.getBegin());
					int end = Math.max(actualSelection.getEnd(), actualSelection2.getEnd());

					AnnotationFS fs = cas.createAnnotation(relationType, beg, end);

					fs.setFeatureValue(agensFeature, actualSelection);
					fs.setFeatureValue(agens2Feature, actualSelection2);

					String sel = (String) ((IStructuredSelection) comboViewer.getSelection()).getFirstElement();
					fs.setFeatureValueFromString(typeFeature, sel);

					addAnnotation(fs);

				}

			}

			@Override
			public void widgetDefaultSelected(SelectionEvent e) {
				widgetSelected(e);

			}
		});

	}

	private void initLayoutForComposite4(Composite parent) {

		Composite c4 = new Composite(parent, SWT.NONE);

		c4.setLayout(new GridLayout(2, true));

		Button buttonExportToGephi = new Button(c4, SWT.PUSH);

		buttonExportToGephi.setText("Export...");

		buttonExportToGephi.addSelectionListener(new SelectionListener() {

			@Override
			public void widgetSelected(SelectionEvent e) {

				// // TODO open file save dialog
				// File destination = null;
				// // create the graph
				// GephiGraphCreator graphCreator = new GephiGraphCreator(cas);
				//
				// Gexf gexf = graphCreator.create();
				//
				// // write to file
				// GephiGEFXFormatUtil.writeToFile(destination, gexf);

			}

			@Override
			public void widgetDefaultSelected(SelectionEvent e) {
				widgetSelected(e);

			}
		});
		Button buttonViewGephi = new Button(c4, SWT.PUSH);

		buttonViewGephi.setText("View Graph");

	}

	private void initLayoutForComposite3(Composite parent) {

		Composite c = new Composite(parent, SWT.NONE);

		c.setLayout(new GridLayout());

		buttonAddMetaAnnotation = new Button(c, SWT.PUSH);

		buttonAddMetaAnnotation.setText("Add Annotation with knowledge...");

		buttonAddMetaAnnotation.addSelectionListener(new SelectionListener() {

			@Override
			public void widgetSelected(SelectionEvent e) {

				RelationMetaAnnotationDialog dialog = new RelationMetaAnnotationDialog(new Shell(),
						RelationAnnotationView.this);

				int open = dialog.open();

				// success !!
				if (open == 0) {

					// do nothing ??? TODO
				}

			}

			@Override
			public void widgetDefaultSelected(SelectionEvent e) {
				widgetSelected(e);

			}
		});

	}

	private void initLayoutForComposite6(Composite parent) {

		Composite comp3 = new Composite(parent, SWT.NULL);

		comp3.setLayout(new GridLayout(1, true));

		comp3.setLayoutData(new GridData(GridData.GRAB_HORIZONTAL | GridData.HORIZONTAL_ALIGN_FILL
				| GridData.VERTICAL_ALIGN_FILL | GridData.GRAB_VERTICAL));

		buttonJumpToNext = new Button(comp3, SWT.CHECK);
		buttonJumpToNext.setText("Jump To Next");
		buttonJumpToNext.setSelection(true);

		buttonToNextIndicator = new Button(comp3, SWT.NONE);

		buttonToNextIndicator.setText("To next Indicator");
		buttonToNextIndicator.addSelectionListener(new SelectionListener() {

			@Override
			public void widgetSelected(SelectionEvent e) {

				int index = editor.getWidget().getCaretOffset();

				for (AnnotationFS a : cas.getAnnotationIndex(indicatorType)) {

					if (a.getBegin() > index) {
						RelationAnnotationView.this.editor.highlightRange(a.getBegin(), a.getEnd() - a.getBegin(), true);

						RelationAnnotationView.this.editor.setSelection(a);
						break;
					}
				}

			}

			@Override
			public void widgetDefaultSelected(SelectionEvent e) {
				// TODO Auto-generated method stub

			}
		});

		// contains the tableviewer
		viewer = new TableViewer(comp3, SWT.MULTI | SWT.H_SCROLL | SWT.V_SCROLL | SWT.FULL_SELECTION | SWT.BORDER
				| SWT.FILL);

		// make it use all remaining space
		viewer.getControl().setLayoutData(
				new GridData(GridData.GRAB_HORIZONTAL | GridData.HORIZONTAL_ALIGN_FILL | GridData.VERTICAL_ALIGN_FILL
						| GridData.GRAB_VERTICAL));

		createColumns(viewer);

		// make lines and header visible
		final Table table = viewer.getTable();
		table.setHeaderVisible(true);
		table.setLinesVisible(true);

		// content
		viewer.setContentProvider(new ArrayContentProvider());

		// mouse

		viewer.getTable().addMouseListener(new MouseListener() {

			@Override
			public void mouseUp(MouseEvent e) {
				lastClick = new Point(e.x, e.y);

			}

			@Override
			public void mouseDown(MouseEvent e) {
				// TODO Auto-generated method stub

			}

			@Override
			public void mouseDoubleClick(MouseEvent e) {
				// TODO Auto-generated method stub

			}
		});

		addTableViewerMenu();
		addTableViewerKeyListener();
		addTableViewMouseDoubleClickListener();

		createTableViewer();
		// comparator
		this.colViewerComp = new ColViewerComparatorRelationView(agens2Feature, typeFeature, agensFeature, this);
		viewer.setComparator(colViewerComp);
		ColumnViewerToolTipSupport.enableFor(viewer, ToolTip.NO_RECREATE);

	}

	private void addTableViewMouseDoubleClickListener() {
		// MOUSE DOUBLE CLICK LISTENER
		viewer.getTable().addListener(SWT.MouseDoubleClick, new Listener() {

			@Override
			public void handleEvent(org.eclipse.swt.widgets.Event e) {
				// get the selected item
				IStructuredSelection sel = (IStructuredSelection) viewer.getSelection();

				AnnotationFS selected = (AnnotationFS) sel.getFirstElement();
				if (selected == null) {
					return;
				}

				// get the coloumn id where the user decided to click on

				ViewerCell cell = viewer.getCell(lastClick);

				if (cell == null)
					return;
				int columnIndex = cell.getColumnIndex();
				Feature selF = null;
				if (columnIndex == 1) {
					selF = agensFeature;
				}

				else if (columnIndex == 2) {
					selF = agens2Feature;
				}

				else if (columnIndex == 0) {
					selF = typeFeature;
				}

				if (selF == null)
					return;
				if (selF.equals(agensFeature) && actualSelection != null) {

					AnnotationFS agens = (AnnotationFS) selected.getFeatureValue(agensFeature);
					AnnotationFS agens2 = (AnnotationFS) selected.getFeatureValue(agens2Feature);
					selected.setFeatureValue(agensFeature, actualSelection);

					// remove the according override

					List<AnnotationFS> toDelete = new ArrayList<AnnotationFS>();
					for (AnnotationFS ov : cas.getAnnotationIndex(typeOverwrite)) {

						if (agens2 != null && agens != null)
							if (ov.getBegin() == agens2.getBegin() || ov.getBegin() == agens.getBegin()) {
								toDelete.add(ov);
							}
					}

					for (AnnotationFS a : toDelete) {
						cas.removeFsFromIndexes(a);
					}

					// also delete the annotation and add it new

					AnnotationFS fsNew = cas.createAnnotation(relationType,
							Math.min(selected.getBegin(), actualSelection.getBegin()),
							Math.max(selected.getEnd(), actualSelection.getEnd()));

					// copy all the values
					fsNew.setFeatureValue(agensFeature, selected.getFeatureValue(agensFeature));
					fsNew.setFeatureValue(agens2Feature, selected.getFeatureValue(agens2Feature));
					fsNew.setFeatureValueFromString(typeFeature, selected.getFeatureValueAsString(typeFeature));

					cas.removeFsFromIndexes(selected);
					addAnnotation(fsNew);
				}

				else if (selF.equals(agens2Feature) && actualSelection2 != null) {
					AnnotationFS agens2 = (AnnotationFS) selected.getFeatureValue(agens2Feature);
					AnnotationFS agens = (AnnotationFS) selected.getFeatureValue(agensFeature);
					selected.setFeatureValue(agens2Feature, actualSelection2);

					// remove the according override

					List<AnnotationFS> toDelete = new ArrayList<AnnotationFS>();
					for (AnnotationFS ov : cas.getAnnotationIndex(typeOverwrite)) {

						if (agens2 != null && agens != null) {
							if (ov.getBegin() == agens2.getBegin() || ov.getBegin() == agens.getBegin()) {
								toDelete.add(ov);
							}
						}
					}

					for (AnnotationFS a : toDelete) {
						cas.removeFsFromIndexes(a);
					}

					// also delete the annotation and add it new - soubnds
					// stupid but onyl way to change a span

					AnnotationFS fsNew = cas.createAnnotation(relationType,
							Math.min(selected.getBegin(), actualSelection2.getBegin()),
							Math.max(selected.getEnd(), actualSelection2.getEnd()));

					// copy all the values
					fsNew.setFeatureValue(agensFeature, selected.getFeatureValue(agensFeature));
					fsNew.setFeatureValue(agens2Feature, selected.getFeatureValue(agens2Feature));
					fsNew.setFeatureValueFromString(typeFeature, selected.getFeatureValueAsString(typeFeature));

					cas.removeFsFromIndexes(selected);
					addAnnotation(fsNew);
				}

				else if (selF.equals(typeFeature)) {

					// TODO open dialog

					RelationSelectTypeInputDialog dialog = new RelationSelectTypeInputDialog(
							RelationAnnotationView.this.overlay.getShell(), RelationAnnotationView.this);

					int code = dialog.open();

					// SUCCESS!
					if (code == 0) {

						String selectedType = dialog.getSelectedType();

						selected.setFeatureValueFromString(typeFeature, selectedType);
					}
				}

				// renew page

				try {
					// addOverrides(selected);
					renewPage();
				} catch (CASException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}

			}
		});

	}

	private void addTableViewerKeyListener() {
		// KEYLISTENER
		// enter listener to update the values
		viewer.getTable().addKeyListener(new KeyAdapter() {

			@Override
			public void keyPressed(KeyEvent e) {
				if (((IStructuredSelection) viewer.getSelection()).getFirstElement() == null) {
					return;
				}

				if (e.keyCode == SWT.CR) {
					IStructuredSelection selection = (IStructuredSelection) viewer.getSelection();
					AnnotationFS anno = (AnnotationFS) selection.getFirstElement();
					ArrayList<AnnotationFS> list = new ArrayList<AnnotationFS>();

					InputDialog dlg = new InputDialog(Display.getCurrent().getActiveShell(), "",
							"Enter a new Description of this relation", "", null);
					if (dlg.open() == Window.OK) {

						updateAnnotation(anno, descriptionFeature, dlg.getValue(), true);

					}

				}
			}
		});

	}

	private void addTableViewerMenu() {
		final Menu menu = new Menu(viewer.getControl());
		viewer.getControl().setMenu(menu);

		// Delete
		MenuItem del = new MenuItem(menu, SWT.None);

		del.setText("Delete Selected Annotation");

		del.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent event) {

				IStructuredSelection sel = (IStructuredSelection) viewer.getSelection();

				AnnotationFS firstElement = (AnnotationFS) sel.getFirstElement();

				deleteAnnotation(firstElement);

			}

		});

		// GoTo

		MenuItem goTo = new MenuItem(menu, SWT.None);

		goTo.setText("GoTo Selected Annotation");

		goTo.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent event) {

				IStructuredSelection sel = (IStructuredSelection) viewer.getSelection();

				AnnotationFS firstElement = (AnnotationFS) sel.getFirstElement();

				int beg = firstElement.getBegin();

				changeHighlighting(beg, firstElement.getEnd(), true);

			}

		});

	}

	private void createTableViewer() {
		// set input of Tableviewer
		annoList = new ArrayList<AnnotationFS>();

		for (AnnotationFS a : cas.getAnnotationIndex(relationType)) {

			annoList.add(a);
		}
		viewer.setInput(annoList);

		viewer.refresh();

	}

	private void initLayoutForComposite2(Composite parent) {

		Composite comp2 = new Composite(parent, SWT.NONE);

		GridLayout layout = new GridLayout();

		layout.numColumns = 3;
		comp2.setLayout(layout);

	}

	private List<String> initRelationTypes() {

		List<String> relationTypes = new ArrayList<String>();

		// add all known relationtypes

		String[] tempTypes = new String[] { "hatVater", "hatMutter", "hatTochter" };

		// also add those saved in preferences by the user
		// TODO !!

		String fromPreferences = ApplicationUtil.getFromPreferences(ApplicationPreferences.RELATION_TYPES, "null");

		if (!fromPreferences.equals("null")) {

			for (String s : fromPreferences.split(";")) {
				if (!s.contains(" "))
					relationTypes.add(s);
			}
		}

		relationTypes.addAll(Arrays.asList(tempTypes));

		// sort alphabetically
		Collections.sort(relationTypes);

		return relationTypes;

	}

	/*
	 * This composite containes just the buttons to add/accept/delete
	 */
	private void initLayoutForComposite1(Composite parent) {

		Composite comp1 = new Composite(parent, SWT.BORDER);

		GridLayout layout = new GridLayout();

		layout.numColumns = 3;
		comp1.setLayout(layout);

		buttonAddNew = new Button(comp1, SWT.PUSH);

		buttonAddNew.setText("New Relation");

		buttonAddNew.addSelectionListener(new SelectionListener() {

			@Override
			public void widgetSelected(SelectionEvent e) {

				AnnotationFS selected = null;
				if (editor.getSelectionOfVisibleAnnotations().size() > 0) {
					for (AnnotationFS anno : editor.getSelectionOfVisibleAnnotations()) {
						if (anno.getType().equals(relationType)) {
							selected = anno;

						}
					}
				}

				// remove vorschlag
				CAS cas = editor.getCas();
				// get the selection

				// if (selected == null) {

				Point selection = editor.getActualSelectedText();
				if (selection == null || selection.x == selection.y) {
					return;
				}
				AnnotationFS anno = cas.createAnnotation(relationType, selection.x, selection.y);

				// "snap the closest NEs into Agens and Agens2"

				List<AnnotationFS> coveredNes = getCovered(anno, neType);

				if (coveredNes.size() > 0) {
					anno.setFeatureValue(agensFeature, coveredNes.get(0));
					anno.setFeatureValue(agens2Feature, coveredNes.get(coveredNes.size() - 1));
				}

				// read feature from combobox
				IStructuredSelection comboSelection = (IStructuredSelection) comboViewer.getSelection();

				String typeOfRel = (String) comboSelection.getFirstElement();

				anno.setFeatureValueFromString(typeFeature, typeOfRel);

				// finally add the annotation
				addAnnotation(anno);

				// jump to next if this is wanted
				// TODO

				highLightNextAnno(anno);

				// }

			}

			@Override
			public void widgetDefaultSelected(SelectionEvent e) {

				widgetSelected(e);

			}
		});

		buttonAccept = new Button(comp1, SWT.PUSH);
		buttonAccept.setText("Accept and to Next");

		buttonAccept.addSelectionListener(new SelectionListener() {

			@Override
			public void widgetSelected(SelectionEvent e) {

				// addOverrwrite type

				// TODO jump to next
				AnnotationFS selected = null;
				if (editor.getSelectionOfVisibleAnnotations().size() > 0) {
					for (AnnotationFS anno : editor.getSelectionOfVisibleAnnotations()) {
						if (anno.getType().equals(relationType)) {
							selected = anno;

						}
					}
				}

				if (selected != null) {
					highLightNextAnno(selected);
					addOverrides(selected);

				}

				else {

					// jump to next relation

					int caretOffset = editor.getWidget().getCaretOffset();

					for (AnnotationFS toHighLight : cas.getAnnotationIndex(relationType)) {

						if (toHighLight.getBegin() > caretOffset) {
							RelationAnnotationView.this.editor.highlightRange(toHighLight.getBegin(),
									toHighLight.getEnd() - toHighLight.getBegin(), true);

							RelationAnnotationView.this.editor.setSelection(toHighLight);
							break;
						}
					}
				}

			}

			@Override
			public void widgetDefaultSelected(SelectionEvent e) {
				widgetSelected(e);
			}
		});

		buttonDelete = new Button(comp1, SWT.PUSH);
		buttonDelete.setText("Delete");

		buttonDelete.addSelectionListener(new SelectionListener() {

			@Override
			public void widgetSelected(SelectionEvent e) {

				AnnotationFS selected = null;
				if (editor.getSelectionOfVisibleAnnotations().size() > 0) {
					for (AnnotationFS anno : editor.getSelectionOfVisibleAnnotations()) {
						if (anno.getType().equals(relationType)) {
							selected = anno;

						}
					}
				}

				if (selected != null) {

					deleteAnnotation(selected);

					// jumpToNext //TODO
					highLightNextAnno(selected);

				}

			}

			@Override
			public void widgetDefaultSelected(SelectionEvent e) {
				widgetSelected(e);

			}
		});

		Label labelTextComboViewer = new Label(comp1, SWT.NONE);
		labelTextComboViewer.setText("Choose Type: ");
		comboViewer = new ComboViewer(comp1, SWT.NONE);

		comboViewer.setContentProvider(ArrayContentProvider.getInstance());

		// init all relations
		List<String> relationTypes = initRelationTypes();

		// set them into the combobox
		comboViewer.setInput(relationTypes.toArray(new String[0]));

		Button buttonAddType = new Button(comp1, SWT.NONE);
		buttonAddType.setText("New Relationtype");

		buttonAddType.addSelectionListener(new SelectionListener() {

			@Override
			public void widgetSelected(SelectionEvent e) {

				// open a dialog => save the new error category =>reload
				NewRelationTypeDialog dialog = new NewRelationTypeDialog(overlay.getShell());

				int open = dialog.open();

				// success
				if (open == 0) {

					String text = dialog.getErrorCategory();

					// create string for preferences

					String prefText = "";
					for (String errorCode : ApplicationUtil.getFromPreferences(ApplicationPreferences.RELATION_TYPES,
							"null").split(";")) {
						if (errorCode.equals("null") || errorCode.split(" ").length > 1) {
							continue;
						}
						prefText += errorCode + ";";
					}

					prefText += text;

					ApplicationUtil.saveToPreferences(ApplicationPreferences.RELATION_TYPES, prefText);

					// reload
					try {
						renewPage();
					} catch (CASException e1) {
						// TODO Auto-generated catch block
						e1.printStackTrace();
					}

				}

			}

			@Override
			public void widgetDefaultSelected(SelectionEvent e) {
				widgetSelected(e);

			}
		});
	}

	public List<AnnotationFS> getCovered(AnnotationFS cover, Type t) {

		List<AnnotationFS> covered = new ArrayList<AnnotationFS>();

		int beg = (cover.getBegin() - 1) > 0 ? cover.getBegin() : cover.getBegin();

		int end = (cover.getEnd() + 1 > cas.getDocumentText().length()) ? cover.getEnd() : cover.getEnd();

		AnnotationFS dummyAnno = cas.createAnnotation(t, beg, end);

		FSIterator<AnnotationFS> subiterator = cas.getAnnotationIndex(t).subiterator(dummyAnno);

		while (subiterator.hasNext()) {
			covered.add(subiterator.next());
		}

		return covered;

	}

	// boolean moveCursor
	private void changeHighlighting(int beg, int end, boolean b) {
		editor.highlightRange(beg, end - beg, true);

	}

	private AnnotationFS getNextToHighLight(AnnotationFS actual) {

		Collections.sort(this.annoList, new AnnotationComparator());

		for (int i = 0; i < annoList.size(); i++) {
			if (actual.getBegin() < annoList.get(i).getBegin()) {
				return annoList.get(i);
			}
		}
		return null;

	}

	private void createColumns(TableViewer viewer2) {
		TableViewerColumn synonyme = createTableViewerColumn("Relationstyp", 50, 0);
		synonyme.setLabelProvider(new ColumnLabelProvider() {
			@Override
			public String getText(Object element) {
				AnnotationFS p = (AnnotationFS) element;

				String typeSelected = p.getFeatureValueAsString(typeFeature);

				if (typeSelected == null) {
					return "null";
				}
				return typeSelected;
			}

		});

		// TableViewerColumn colName = createTableViewerColumn("Description",
		// 100, 0);
		// colName.setLabelProvider(new ColumnLabelProvider() {
		// @Override
		// public String getText(Object element) {
		// AnnotationFS p = (AnnotationFS) element;
		//
		// String featureValueAsString =
		// p.getFeatureValueAsString(descriptionFeature);
		//
		// if (featureValueAsString == null) {
		// return p.getCoveredText();
		// }
		// return featureValueAsString;
		//
		// }
		//
		// });

		TableViewerColumn colFreq = createTableViewerColumn("Person1", 60, 1);
		colFreq.setLabelProvider(new ColumnLabelProvider() {
			@Override
			public String getText(Object element) {
				AnnotationFS p = (AnnotationFS) element;
				AnnotationFS agens = (AnnotationFS) p.getFeatureValue(agensFeature);

				if (agens == null) {
					return "null";
				}

				// get Name of that person aka head of corefchain

				String name = agens.getFeatureValueAsString(neName);

				if (name != null) {
					return name;
				}
				return agens.getCoveredText();
			}
		});

		TableViewerColumn colID = createTableViewerColumn("Person2", 60, 2);
		colID.setLabelProvider(new ColumnLabelProvider() {
			@Override
			public String getText(Object element) {
				AnnotationFS p = (AnnotationFS) element;

				AnnotationFS agens2 = (AnnotationFS) p.getFeatureValue(agens2Feature);

				if (agens2 == null) {
					return "null";
				}

				String name = agens2.getFeatureValueAsString(neName);

				if (name != null) {
					return name;
				}
				return agens2.getCoveredText();
			}
		});

		colFreq.getColumn().pack();
		colID.getColumn().pack();
		synonyme.getColumn().pack();

	}

	private TableViewerColumn createTableViewerColumn(String viewer2, int bound, final int colNumber) {
		final TableViewerColumn viewerColumn = new TableViewerColumn(viewer, SWT.NONE);
		final TableColumn column = viewerColumn.getColumn();
		column.setText(viewer2);
		column.setWidth(bound);
		column.setResizable(true);
		column.setMoveable(true);
		column.addSelectionListener(getSelectionAdapter(column, colNumber));
		return viewerColumn;
	}

	private SelectionAdapter getSelectionAdapter(final TableColumn column, final int index) {
		SelectionAdapter selectionAdapter = new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				colViewerComp.setColumn(index);
				int dir = colViewerComp.getDirection();
				viewer.getTable().setSortDirection(dir);
				viewer.getTable().setSortColumn(column);
				viewer.refresh();
			}
		};
		return selectionAdapter;
	}

	@Override
	public void coupleToPerspective() {
		System.out.println("Couple RelationView");

		MasterPart.subscribeForEvent(CLASS_THIS, IAnnotationEditorEvents.VIEW_STACK_FOCUS_CHANGED,
				onViewStackChangedHandler);

		super.standardSubscribeToEditorDocumentChangedEvents(CLASS_THIS);

	}

	@Override
	public void decoupleFromPerspective() {
		System.out.println("Decouple RelationView");

		MasterPart.unsubscribeFromEvent(CLASS_THIS, 
				IAnnotationEditorEvents.VIEW_STACK_FOCUS_CHANGED,
				onViewStackChangedHandler);
		super.standardUnsubscribeFromEditorDocumentChangedEvents(CLASS_THIS);

	}

	@Override
	public void onEditorClosed(Event arg0) {
		// remove all components

		System.out.println("close relationView");

		if (this.overlay != null && !this.overlay.isDisposed()) {
			for (Control c : this.overlay.getChildren()) {
				c.dispose();
			}
		}

		// unsubscribe from editor notifications

		super.standardUnsubscribeFromEditorEvents(CLASS_THIS);

		isSubscribedToEditorEvents = false;
		this.editor = null;

	}

	/*
	 * Method to instantiate everything needed of the cas, stored in the editor
	 */
	@Override
	public void onEditorInputChanged(AnnotationEditorWidget editor) {

		System.out.println("On Editor Input changed Relationview");

		// check if we should render anything at all
		if (!isPartActive()) {
			return;
		}

		this.cas = editor.getCas();
		this.editor = editor;

		// initialize all types needed for this view, this view needs an o
		boolean correctlyInitiated = initTypes();

		// annotate temp types

		// delete all former parts to assure no doubles on the view
		// ====REMOVE ALL CONTROLS THAT WERE ADDED BEFORE====
		for (Control c : overlay.getChildren()) {
			c.dispose();
		}

		// init the Layout
		initLayout(overlay);

		// init the candidates if not yet present
		try {
			initCandidates();
			// annotateTemporaryTypeAnnos();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		if (!isSubscribedToEditorEvents) {
			System.out.println("Subscribe if not done yet");
			super.standardSubscribeToEditorEvents(CLASS_THIS);
		}

		// ====reload=====
		overlay.layout();
		overlay.getParent().layout();

	}

	private void annotateTemporaryTypeAnnos() {

		List<AnnotationFS> toDelete = new ArrayList<AnnotationFS>();

		for (AnnotationFS a : cas.getAnnotationIndex(tempType)) {
			toDelete.add(a);
		}

		for (AnnotationFS a : toDelete) {
			cas.removeFsFromIndexes(a);
		}

		for (AnnotationFS a : cas.getAnnotationIndex(relationType)) {

			AnnotationFS createAnnotation = cas.createAnnotation(tempType, a.getBegin(), a.getEnd());

			cas.addFsToIndexes(createAnnotation);
		}

	}

	private void initCandidates() throws IOException {

		AnnotationIndex<AnnotationFS> annotationIndex = cas.getAnnotationIndex(relationType);

		// we dont destroy anything that was already present
		if (annotationIndex.size() != 0) {
			return;
		}

		// annotate dummies

		HashSet<String> indicator = new HashSet<String>();
		InputStream indicatorRessource = ApplicationUtil.getBundleRessourceAsStream("/ressources/FamilyRelation.txt");

		BufferedReader reader = new BufferedReader(new InputStreamReader(indicatorRessource));

		String line = null;

		while ((line = reader.readLine()) != null) {

			indicator.add(line.trim());
			indicator.add(line.trim() + "s");
			indicator.add(line.trim() + "es");
		}

		reader.close();

		// annotate

		// TODO hardcoded tokens
		for (AnnotationFS token : cas.getAnnotationIndex(cas.getTypeSystem().getType(
				"de.uniwue.kalimachos.coref.type.POS"))) {

			if (indicator.contains(token.getCoveredText())) {
				// create Annotation
				AnnotationFS fs = cas.createAnnotation(relationType, token.getBegin(), token.getEnd());

				cas.addFsToIndexes(fs);
			}
		}

		// refresh

		try {
			renewPage();
		} catch (CASException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}

	// get all types used in this view and set their styles
	@Override
	public boolean initTypes() {

		// first fetch string from preferences
		String prefRelationType = ApplicationUtil.getFromPreferences(ApplicationPreferences.RELATION_TYPE, "null");
		String prefRelationTypeOverride = ApplicationUtil.getFromPreferences(
				ApplicationPreferences.RELATION_OVERRIDE_TYPE, "null");
		String prefNEType = ApplicationUtil.getFromPreferences(ApplicationPreferences.COREFVIEW_NE_TYPE, "null");

		// features
		String prefRelationFeatureType = ApplicationUtil.getFromPreferences(
				ApplicationPreferences.RELATION_FEATURE_TYPE, "null");
		String prefRelationFeatureAgens = ApplicationUtil.getFromPreferences(
				ApplicationPreferences.RELATION_FEATURE_AGENS, "null");
		String prefRelationFeatureAgens2 = ApplicationUtil.getFromPreferences(
				ApplicationPreferences.RELATION_FEATURE_AGENS2, "null");
		// TODO dirty
		String prefRelationDescFeature = "Description";

		// NE Features
		String prefNeId = ApplicationUtil.getFromPreferences(ApplicationPreferences.COREFVIEW_NE_ID, "null");
		String prefNePseudo = ApplicationUtil.getFromPreferences(ApplicationPreferences.COREFVIEW_NE_PSEUDO, "null");
		String prefNeCore = ApplicationUtil.getFromPreferences(ApplicationPreferences.COREFVIEW_NE_CORE, "null");
		String prefNeCoreRange = ApplicationUtil.getFromPreferences(ApplicationPreferences.COREFVIEW_NE_CORERANGE,
				"null");
		String prefNeNumerus = ApplicationUtil.getFromPreferences(ApplicationPreferences.COREFVIEW_NE_NUMERUS, "null");
		String prefNename = ApplicationUtil.getFromPreferences(ApplicationPreferences.COREFVIEW_NE_NAME, "null");

		// null handling - this indicates that the user didnt initialize
		// correctly - only use a subset and have faith in the user
		if (prefRelationType.equals("null") || prefRelationTypeOverride.equals("null") || prefNEType.equals("null")) {
			return false;
		}

		this.relationType = cas.getTypeSystem().getType(prefRelationType);
		this.typeOverwrite = cas.getTypeSystem().getType(prefRelationTypeOverride);
		neType = cas.getTypeSystem().getType(prefNEType);

		tempType = cas.getTypeSystem().getType(typeTempString);

		// TODO dirty
		indicatorType = cas.getTypeSystem().getType("de.uniwue.kalimachos.coref.type.FamilyRelationIndicator");

		// set everything unnneded invisible

		this.editor.allStylesInvisible();

		// TODO null handling
		Feature idFeat = neType.getFeatureByBaseName(prefNeId);
		Feature coreFeat = neType.getFeatureByBaseName(prefNeCore);
		Feature pseudoFeat = neType.getFeatureByBaseName(prefNePseudo);
		Feature numerusFeat = neType.getFeatureByBaseName(prefNeNumerus);
		Feature coreRangeFeat = neType.getFeatureByBaseName(prefNeCoreRange);
		neName = neType.getFeatureByBaseName(prefNename);

		// relation features

		this.agens2Feature = relationType.getFeatureByBaseName(prefRelationFeatureAgens2);
		this.agensFeature = relationType.getFeatureByBaseName(prefRelationFeatureAgens);
		this.typeFeature = relationType.getFeatureByBaseName(prefRelationFeatureType);
		this.descriptionFeature = relationType.getFeatureByBaseName(prefRelationDescFeature);

		// Visibility

		editor.changeVisibility(relationType, true);
		editor.changeVisibility(typeOverwrite, true);
		editor.changeVisibility(neType, true);
		editor.changeVisibility(indicatorType, true);
		// editor.changeVisibility(tempType, true);

		// layer

		editor.changeLayer(relationType, 0);
		editor.changeLayer(typeOverwrite, 2);
		editor.changeLayer(neType, 2);
		editor.changeLayer(indicatorType, 1);

		// yellow - overwrite
		StyleRange rangeOv = new StyleRange();
		rangeOv.background = new Color(overlay.getDisplay(), 232, 246, 75);
		AnnoStyle style2 = new AnnoStyle(new BackgroundDrawingStrategy(rangeOv), rangeOv);

		// style - blue NEs
		StyleRange rangeTyp = new StyleRange();
		rangeTyp.background = new Color(overlay.getDisplay(), 0, 0, 255);
		AnnoStyle style = new AnnoStyle(new NamedEntityDrawingStrategy(rangeTyp, idFeat.getShortName(), null, null,
				null, null, null), rangeTyp);

		// StyleRange rangeTyp = new StyleRange();
		// rangeTyp.background = new Color(overlay.getDisplay(), 0, 0, 255);
		// AnnoStyle style = new AnnoStyle(new BoxDrawingStrategy(rangeTyp),
		// rangeTyp);

		// style for relations a slight red

		StyleRange rangeRelationType = new StyleRange();
		rangeRelationType.background = new Color(overlay.getDisplay(), 220, 0, 0);

		AnnoStyle styleRelationType = new AnnoStyle(new RelationDrawingStrategy(rangeRelationType,
				agensFeature.getShortName(), agens2Feature.getShortName()), rangeRelationType);

		StyleRange rangeTempType = new StyleRange();
		rangeTempType.background = new Color(overlay.getDisplay(), 220, 0, 0);
		AnnoStyle styleTempType = new AnnoStyle(new BackgroundDrawingStrategy(rangeTempType), rangeTempType);

		// apply
		editor.changeStyle(relationType, styleRelationType);
		editor.changeStyle(neType, style);
		editor.changeStyle(typeOverwrite, style2);
		editor.changeStyle(tempType, styleTempType);

		// also change the modus
		editor.setActiveMode(relationType);

		return true;

	}

	private boolean isPartActive() {
		MUIElement selectedElement = null;
		if (part != null) {
			MElementContainer<MUIElement> parent = part.getParent();
			selectedElement = parent.getSelectedElement();
		}
		if (selectedElement == null || !selectedElement.getElementId().equals(viewId)) {
			// this part is not visible => dont render it but unsubscribe
			// the
			// listener if they are
			// remove all listeners
			super.standardUnsubscribeFromEditorEvents(CLASS_THIS);
			return false;
		}

		return true;
	}

	@Override
	public void onViewStackChanged(Event arg0) {
		MPart findPart = partService.findPart(viewId);

		if (findPart == null) {
			return;
		}

		MElementContainer<MUIElement> parent = findPart.getParent();
		MUIElement selectedElement = parent.getSelectedElement();

		if (!selectedElement.getElementId().equals(viewId)) {
			// this part is not visible => dont render it but
			// unsubscribe the
			// listener if they are
			// remove all listeners
			super.standardUnsubscribeFromEditorEvents(CLASS_THIS);
		}

	}

	private void highLightNextAnno(AnnotationFS selected) {

		if (!buttonJumpToNext.getSelection()) {
			return;
		}
		AnnotationFS toHighLight = getNextToHighLight(selected);

		if (toHighLight != null) {
			RelationAnnotationView.this.editor.highlightRange(toHighLight.getBegin(), toHighLight.getEnd()
					- toHighLight.getBegin(), true);

			RelationAnnotationView.this.editor.setSelection(toHighLight);
		}
	}

	@Override
	public void onAnnotationAdded(Event e) {
		AnnotationFS added = (AnnotationFS) e.getProperty(IEventBroker.DATA);

		try {
			renewPage();
		} catch (CASException ev) {
			ev.printStackTrace();
		}

	}

	@Override
	public void onAnnotationRemoved(Event arg0) {
		AnnotationFS removed = (AnnotationFS) arg0.getProperty(IEventBroker.DATA);
		try {
			renewPage();
		} catch (CASException e) {
			e.printStackTrace();
		}

		// if (getJumpButton().getSelection()) {
		// AnnotationFS toHIghlight = getNextToHighLight(removed);
		//
		// if (toHIghlight != null) {
		// this.editor.highlightRange(toHIghlight.getBegin(),
		// toHIghlight.getEnd() - toHIghlight.getBegin(), true);
		//
		// getEditor().setSelection(toHIghlight);
		// }
		// }

	}

	@Override
	public void onAnnotationChanged(Event arg0) {
		// TODO Auto-generated method stub

	}

	@Override
	public void onAnnotationSelectionChanged(Event arg0) {
		// TODO Auto-generated method stub

	}

	@Focus
	public void onFocus() {

		broker.send(IAnnotationEditorEvents.VIEW_STACK_FOCUS_CHANGED, "");

		if (!isSubscribedToEditorEvents && this.editor != null) {
			onEditorInputChanged(this.editor);
		}

		if (this.editor == null) {

			// request the editor if possible
			broker.send(IAnnotationEditorEvents.REQUEST_ACTIVE_EDITOR, this);
			super.standardSubscribeToEditorDocumentChangedEvents(CLASS_THIS);
		}

	}

	@Override
	public void onEditorDoubleClicked(Event arg0) {

		for (AnnotationFS a : editor.getCas().getAnnotationIndex(neType)) {

			//
			// int caretOffset = editor.getWidget().getCaretOffset();

			Rectangle textBounds = editor.getWidget().getTextBounds(a.getBegin(), a.getEnd());

			if (textBounds.contains(lastMousePosition)) {

				if (actualLastChanged == false) {
					this.actualSelection = a;
					this.textMouseSelection.setText(a.getCoveredText());
					actualLastChanged = true;
				} else {
					this.actualSelection2 = a;
					this.textMouseSelection2.setText(a.getCoveredText());
					actualLastChanged = false;
				}
				return;

			}
			// if (a.getBegin() <= caretOffset && a.getEnd() >= caretOffset) {
			//
			// if (actualLastChanged == false) {
			// this.actualSelection = a;
			// this.textMouseSelection.setText(a.getCoveredText());
			// actualLastChanged = true;
			// } else {
			// this.actualSelection2 = a;
			// this.textMouseSelection2.setText(a.getCoveredText());
			// actualLastChanged = false;
			// }
			// return;
			// }
		}

		this.actualSelection = null;
		this.textMouseSelection.setText("");
		this.actualSelection2 = null;
		this.textMouseSelection2.setText("");

	}

	@Override
	public void onEditorWasScrolled(Event arg0) {
		// TODO Auto-generated method stub

	}

	@Override
	public void onEditorCaretChanged(Event arg0) {

		int caretOffset = editor.getWidget().getCaretOffset();

		for (AnnotationFS ne : cas.getAnnotationIndex(neType)) {

			if (ne.getBegin() <= caretOffset && ne.getEnd() >= caretOffset) {
				StructuredSelection ss = new StructuredSelection(ne);

				viewer.setSelection(ss);
			}

		}

	}

	@Override
	public void onEditorMouseUp(Event event) {

	}

	@Override
	public void onEditorMouseDown(Event arg0) {

	}

	@Override
	public void onEditorTextSelectionChanged(Event arg0) {
		// TODO Auto-generated method stub

	}

	private void addAnnotation(AnnotationFS anno) {
		// add Annotation - means we add an Annotation of type NER also an
		// Override Type
		// to display that this annotation was already handled

		this.editor.addAnnotation(anno);

		// add the override Annotation
		addOverrides(anno);

	}

	private void addOverrides(AnnotationFS anno) {
		CAS cas = this.editor.getCas();

		AnnotationFS agensAnno = (AnnotationFS) anno.getFeatureValue(agensFeature);

		if (agensAnno != null) {
			AnnotationFS fs = cas.createAnnotation(typeOverwrite, agensAnno.getBegin(), agensAnno.getEnd());
			this.editor.addAnnotation(fs);
		}
		AnnotationFS agens2Anno = (AnnotationFS) anno.getFeatureValue(agens2Feature);

		if (agens2Anno != null) {
			AnnotationFS fs = cas.createAnnotation(typeOverwrite, agens2Anno.getBegin(), agens2Anno.getEnd());
			this.editor.addAnnotation(fs);
		}
	}

	private void updateAnnotation(AnnotationFS firstElement, Feature feat, String string, boolean reload) {

		firstElement.setFeatureValueFromString(feat, string);

		// delete all overrides in that stage
		if (reload == true) {

			AnnotationIndex<AnnotationFS> annotationIndex = editor.getCas().getAnnotationIndex(typeOverwrite);
			ArrayList<AnnotationFS> toDelete = new ArrayList<AnnotationFS>();
			for (AnnotationFS anno : annotationIndex) {
				if (anno.getBegin() == firstElement.getBegin() && anno.getEnd() == firstElement.getEnd()) {
					toDelete.add(anno);
				}
			}

			for (AnnotationFS a : toDelete) {
				editor.removeAnnotation(a);
			}
		}
		// add a true positive - only if none was already on this place - since
		// update is called alot
		// add a false negative

		if (reload) {
			AnnotationFS fss = editor.getCas().createAnnotation(typeOverwrite, firstElement.getBegin(),
					firstElement.getEnd());

			this.editor.addAnnotation(fss);
		}
	}

	private void deleteAnnotation(AnnotationFS selected) {
		// delete all overrides in that stage

		AnnotationIndex<AnnotationFS> annotationIndex = editor.getCas().getAnnotationIndex(typeOverwrite);
		ArrayList<AnnotationFS> toDelete = new ArrayList<AnnotationFS>();
		for (AnnotationFS anno : annotationIndex) {
			if (anno.getBegin() >= selected.getBegin() && anno.getEnd() <= selected.getEnd()) {
				toDelete.add(anno);
				// editor.removeAnnotation(anno);
			}
		}

		for (AnnotationFS a : toDelete) {
			editor.removeAnnotation(a);
		}

		editor.removeAnnotation(selected);

	}

	public void renewPage() throws CASException {

		Runnable r = new Runnable() {

			@Override
			public void run() {
				createTableViewer();
				// init all relations
				List<String> relationTypes = initRelationTypes();

				// set them into the combobox
				comboViewer.setInput(relationTypes.toArray(new String[0]));

			}
		};

		// reload asynchronous
		overlay.getDisplay().asyncExec(r);

	}

	public String[] getAllRelationTypes() {
		List<String> initRelationTypes = initRelationTypes();
		return initRelationTypes.toArray(new String[0]);
	}

	public List<String> getAllNEsAsString() {

		Set<String> neStrings = new HashSet<String>();

		for (AnnotationFS ne : cas.getAnnotationIndex(neType)) {
			neStrings.add(ne.getCoveredText());
		}
		return new ArrayList<String>(neStrings);
	}

	public AnnotationEditorWidget getEditor() {
		return this.editor;
	}

	public Type getRelationType() {
		return this.relationType;
	}

	public Feature getRelationTypeFeature() {
		return this.typeFeature;
	}

	public Feature getRelationDescription() {
		return this.descriptionFeature;
	}

	public Type getOverwriteType() {
		return typeOverwrite;
	}

	public List<AnnotationFS> getCoveringNes(AnnotationFS cover) {
		return getCovered(cover, neType);

	}

	public Feature getAgensFeature() {

		return this.agensFeature;
	}

	public Feature getAgens2Feature() {
		return agens2Feature;
	}

	@Override
	public void onEditorMouseMoved(Event e) {

		this.lastMousePosition = (Point) e.getProperty(IEventBroker.DATA);

	}

	@Override
	public void initModel() {
		// TODO Auto-generated method stub

	}

}
