package de.uniwue.mk.kall.athen.relationview.ui;

import java.util.HashMap;

import org.eclipse.jface.dialogs.Dialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

import de.uniwue.mk.kall.athen.appDelegation.hierarchie.IAnnotationEditorDialog;
import de.uniwue.mk.kall.athen.appDelegation.util.ApplicationPreferences;
import de.uniwue.mk.kall.athen.appDelegation.util.ApplicationUtil;

public class RelationPreferencesDialogue extends Dialog implements IAnnotationEditorDialog {

	HashMap<String, String> preferences;

	Label labelNEType;
	Text textNeType;
	Label labelIDFeature;
	Text textIDFeature;
	Label labelNumerusFeature;
	Text textNUmerusFeature;

	Label labelAgensFeature;
	Text textAgensFeature;

	Label labelPseudoFeature;
	Text textPseudoFeature;
	Label labelAgens2Feature;
	Text textAgens2Feature;
	Label labelCoreFeature;
	Text textCoreFeature;

	Label labelFeatCoreRange;
	Text textFeatCoreRange;

	Label labelTypeOverride;
	Text textTypeOverride;

	Label labelFeatureType;
	Text textFeatureType;

	Label labeRelationType;
	Text textRelationType;

	Button buttonSetBuiltIn;

	public RelationPreferencesDialogue(Shell parentShell) {
		super(parentShell);

		preferences = new HashMap<String, String>();

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * org.eclipse.jface.dialogs.Dialog#createDialogArea(org.eclipse.swt.widgets
	 * .Composite)
	 */
	protected Control createDialogArea(Composite parent) {

		parent.getShell().setText("Specify View Settings");

		GridLayout layout = new GridLayout();

		layout.numColumns = 2;

		parent.setLayout(layout);

		// =======ADD WIDGETS====

		labelNEType = new Label(parent, SWT.NONE);
		textNeType = new Text(parent, SWT.None);
		labelIDFeature = new Label(parent, SWT.NONE);
		textIDFeature = new Text(parent, SWT.None);
		labelNumerusFeature = new Label(parent, SWT.NONE);
		textNUmerusFeature = new Text(parent, SWT.None);

		labelAgensFeature = new Label(parent, SWT.NONE);
		textAgensFeature = new Text(parent, SWT.None);

		labelPseudoFeature = new Label(parent, SWT.NONE);
		textPseudoFeature = new Text(parent, SWT.None);
		labelAgens2Feature = new Label(parent, SWT.NONE);
		textAgens2Feature = new Text(parent, SWT.None);
		labelCoreFeature = new Label(parent, SWT.NONE);
		textCoreFeature = new Text(parent, SWT.None);

		labelFeatCoreRange = new Label(parent, SWT.NONE);
		textFeatCoreRange = new Text(parent, SWT.None);

		labelTypeOverride = new Label(parent, SWT.NONE);
		textTypeOverride = new Text(parent, SWT.None);

		labelFeatureType = new Label(parent, SWT.NONE);
		textFeatureType = new Text(parent, SWT.None);

		labeRelationType = new Label(parent, SWT.NONE);
		textRelationType = new Text(parent, SWT.None);

		labelNEType.setText("Enter Named-Entity-Type");
		labelIDFeature.setText("Enter Named-Entity ID Feature");
		labelNumerusFeature.setText("Enter Named-Entity-Numerus-Feature");
		labelPseudoFeature.setText("Enter Named-Entity-Pseudo Feature");
		labelCoreFeature.setText("Enter Named-Entity-Core-Feature");
		labelFeatCoreRange.setText("Enter CoreRange-Feature");

		labelTypeOverride.setText("Enter Relation Override Type");

		labeRelationType.setText("Enter Relationtype");
		labelFeatureType.setText("Enter Relationtype-Feature");
		labelAgensFeature.setText("Enter Relation Agens Feature");
		labelAgens2Feature.setText("Enter Relation Agens2 Feature");

		buttonSetBuiltIn = new Button(parent, SWT.None);

		buttonSetBuiltIn.setText("Use Built-In Configuration");

		buttonSetBuiltIn.addSelectionListener(new SelectionListener() {

			@Override
			public void widgetSelected(SelectionEvent e) {

				// set all preferences
				textNeType.setText("de.uniwue.kalimachos.coref.type.NamedEntity");
				textAgens2Feature.setText("Agens2");
				textIDFeature.setText("ID");
				textNUmerusFeature.setText("Numerus");
				textAgensFeature.setText("Agens");
				textCoreFeature.setText("CoreNamedEntity");
				textPseudoFeature.setText("Pseudo");
				textFeatCoreRange.setText("CoreRange");
				textTypeOverride.setText("de.uniwue.kalimachos.coref.type.RelationAlreadyHandled");
				textFeatureType.setText("Type");
				textRelationType.setText("de.uniwue.kalimachos.coref.type.Relation");

			}

			@Override
			public void widgetDefaultSelected(SelectionEvent e) {
				widgetSelected(e);

			}
		});

		textNeType.setText(ApplicationUtil.getFromPreferences(labelNEType.getText(), "preference not found"));

		textIDFeature.setText(ApplicationUtil.getFromPreferences(labelIDFeature.getText(), "preference not found"));
		textNUmerusFeature.setText(ApplicationUtil.getFromPreferences(labelNumerusFeature.getText(),
				"preference not found"));
		textAgensFeature
				.setText(ApplicationUtil.getFromPreferences(labelAgensFeature.getText(), "preference not found"));
		textPseudoFeature.setText(ApplicationUtil.getFromPreferences(labelPseudoFeature.getText(),
				"preference not found"));
		textAgens2Feature.setText(ApplicationUtil.getFromPreferences(labelAgens2Feature.getText(),
				"preference not found"));
		textCoreFeature.setText(ApplicationUtil.getFromPreferences(labelCoreFeature.getText(), "preference not found"));
		textTypeOverride
				.setText(ApplicationUtil.getFromPreferences(labelTypeOverride.getText(), "preference not found"));
		textFeatCoreRange.setText(ApplicationUtil.getFromPreferences(labelFeatCoreRange.getText(),
				"Preference not found"));
		textFeatureType.setText(ApplicationUtil.getFromPreferences(labelFeatureType.getText(), "Preference not found"));
		textRelationType
				.setText(ApplicationUtil.getFromPreferences(labeRelationType.getText(), "Preference not found"));

		return parent;
	}

	@Override
	protected void okPressed() {

		// save to the preference map

		// TODO use the string constants instead of the literals
		this.preferences.put(ApplicationPreferences.COREFVIEW_NE_TYPE, textNeType.getText());
		this.preferences.put(labelIDFeature.getText(), textIDFeature.getText());
		this.preferences.put(labelNumerusFeature.getText(), textNUmerusFeature.getText());
		this.preferences.put(labelAgensFeature.getText(), textAgensFeature.getText());
		this.preferences.put(labelPseudoFeature.getText(), textPseudoFeature.getText());
		this.preferences.put(labelAgens2Feature.getText(), textAgens2Feature.getText());
		this.preferences.put(labelTypeOverride.getText(), textTypeOverride.getText());
		this.preferences.put(labelCoreFeature.getText(), textCoreFeature.getText());
		this.preferences.put(labelFeatCoreRange.getText(), textFeatCoreRange.getText());
		this.preferences.put(labelFeatureType.getText(), textFeatureType.getText());
		this.preferences.put(labeRelationType.getText(), textRelationType.getText());

		setReturnCode(OK);
		close();
	}

	@Override
	public HashMap<String, String> getPreferences() {

		return this.preferences;
	}

}
