package de.uniwue.mk.kall.athen.tokenView.ui;

import java.util.ArrayList;
import java.util.List;

import javax.inject.Inject;

import org.eclipse.swt.custom.StyleRange;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.widgets.Display;

import de.uniwue.kalimachos.coref.editor.drawingstructure.AnnoStyle;
import de.uniwue.kalimachos.coref.paintingStrategies.BackgroundGCDrawingStrategy;
import de.uniwue.mk.kall.athen.part.editor.subordinate.ARightViewTablePart;
import de.uniwue.mk.kall.athen.part.editor.subordinate.TableColumnStruct;

public class TokenView extends ARightViewTablePart {

	private static final String viewId = "de.uniwue.mkrug.kallimachos.annotation.editor.part.23";

	@Inject
	public TokenView() {
		super(viewId);
		// set the values in the parent class
		super.CLASS_THIS = TokenView.class;
		super.viewId = viewId;

		// types
		super.typeHandledS = "de.uniwue.kallimachos.coref.type.posAlreadyHandled";
		super.typeModusS = "de.uniwue.kalimachos.coref.type.POS";

		// yellow
		StyleRange rangeModus = new StyleRange();
		rangeModus.background = new Color(Display.getCurrent(), 255, 247, 255);
		AnnoStyle styleModus = new AnnoStyle(new BackgroundGCDrawingStrategy(rangeModus), rangeModus);
		// AnnoStyle styleModus = new AnnoStyle(new
		// BackgroundGCDrawingStrategy(rangeModus), rangeModus);
		super.styleModus = styleModus;

		List<TableColumnStruct> columns = new ArrayList<TableColumnStruct>();
		columns.add(new TableColumnStruct(FEAT_COVERED_TEXT, 100, "Text"));
		super.columns = columns;
	}

}
