package de.uniwue.mk.kall.coreferenceview.ui;

import org.apache.uima.cas.text.AnnotationFS;
import org.eclipse.jface.util.LocalSelectionTransfer;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.jface.viewers.ViewerDropAdapter;
import org.eclipse.swt.dnd.DropTargetEvent;
import org.eclipse.swt.dnd.TransferData;

public class TableViewerDropListener extends ViewerDropAdapter {

	private final Viewer viewer;

	private CorefView view;

	private AnnotationFS to;

	private AnnotationFS from;

	public TableViewerDropListener(Viewer viewer, CorefView view) {
		super(viewer);
		this.viewer = viewer;
		this.view = view;
	}

	@Override
	public void drop(DropTargetEvent event) {
		// even has "To" information
		// int location = this.determineLocation(event);
		AnnotationFS anno = (AnnotationFS) determineTarget(event);
		to = anno;

		if (LocalSelectionTransfer.getTransfer().isSupportedType(event.currentDataType)) {
			ISelection sel = LocalSelectionTransfer.getTransfer().getSelection();
			IStructuredSelection struct = (IStructuredSelection) sel;
			from = (AnnotationFS) struct.getFirstElement();
		}

		super.drop(event);
	}

	// This method performs the actual drop
	// We simply add the String we receive to the model and trigger a refresh of
	// the
	// viewer by calling its setInput method.
	@Override
	public boolean performDrop(Object data) {
		view.performDragnDropChange(from, to);

		return true;
	}

	@Override
	public boolean validateDrop(Object target, int operation, TransferData transferType) {
		return true;

	}

}
