package de.uniwue.kalimachos.coref.paintingStrategies;

import org.apache.uima.cas.text.AnnotationFS;
import org.eclipse.swt.custom.StyleRange;
import org.eclipse.swt.custom.StyledText;
import org.eclipse.swt.graphics.GC;

import de.uniwue.kalimachos.coref.editor.drawingstructure.TypeStyleDataStructure;

public class BackgroundDrawingStrategy implements IExpensiveDrawingStrategy {

	private StyleRange styleRange;

	public BackgroundDrawingStrategy(StyleRange styleRange) {

		this.styleRange = styleRange;

	}

	public StyleRange getStyleRange() {
		return styleRange;
	}

	public void setStyleRange(StyleRange styleRange) {
		this.styleRange = styleRange;
	}

	@Override
	public void drawAnnotation(TypeStyleDataStructure struct, AnnotationFS anno, StyledText widget, GC gc) {

		StyleRange styleRange = this.styleRange;
		styleRange.start = anno.getBegin();
		styleRange.length = anno.getEnd() - anno.getBegin();
		widget.setStyleRange(styleRange);

		// Dispose ressource
		gc.dispose();
	}

	@Override
	public int getLineHeight(AnnotationFS anno) {
		return 0;
	}

}
