package de.uniwue.kalimachos.coref.paintingStrategies;

import org.apache.uima.cas.text.AnnotationFS;
import org.eclipse.swt.custom.StyleRange;
import org.eclipse.swt.custom.StyledText;
import org.eclipse.swt.graphics.GC;
import org.eclipse.swt.graphics.Rectangle;

import de.uniwue.kalimachos.coref.editor.drawingstructure.TypeStyleDataStructure;

public class BackgroundGCDrawingStrategy implements IAnnotationDrawingStrategy {

	private StyleRange styleRange;

	public BackgroundGCDrawingStrategy(StyleRange styleRange) {

		this.styleRange = styleRange;

	}

	public StyleRange getStyleRange() {
		return styleRange;
	}

	public void setStyleRange(StyleRange styleRange) {
		this.styleRange = styleRange;
	}

	@Override
	public void drawAnnotation(TypeStyleDataStructure struct, AnnotationFS anno, StyledText widget, GC gc) {

		StyleRange styleRange = this.styleRange;
		styleRange.start = anno.getBegin();
		styleRange.length = anno.getEnd() - anno.getBegin();
		// widget.setStyleRange(styleRange);

		int length = anno.getEnd() - anno.getBegin();
		int offset = anno.getBegin();
		if (length != 0) {
			Rectangle bounds = widget.getTextBounds(offset, offset + length - 1);
			// Dispose ressource

			int shrinkage = 0;
			gc.setBackground(styleRange.background);
			Rectangle rect = new Rectangle(bounds.x + shrinkage, bounds.y + shrinkage, bounds.width - shrinkage,
					bounds.height - shrinkage);
			// gc.setBackground(styleRange.background);
			gc.setAlpha(80);
			gc.fillRectangle(rect);
			gc.dispose();

		}

	}

	@Override
	public int getLineHeight(AnnotationFS anno) {
		return 0;
	}
}
