package de.uniwue.kalimachos.coref.paintingStrategies;

import org.apache.uima.cas.text.AnnotationFS;
import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.StyleRange;
import org.eclipse.swt.custom.StyledText;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.GC;
import org.eclipse.swt.graphics.RGB;

import de.uniwue.kalimachos.coref.editor.drawingstructure.TypeStyleDataStructure;

public class ItalicDrawingStrategy implements IExpensiveDrawingStrategy {

	private StyleRange styleRange;

	public ItalicDrawingStrategy(StyleRange styleRange) {

		this.styleRange = styleRange;
	}

	@Override
	public void drawAnnotation(TypeStyleDataStructure struct, AnnotationFS anno, StyledText widget, GC gc) {

		Color black = new Color(widget.getDisplay(), new RGB(0, 0, 0));
		Color white = new Color(widget.getDisplay(), new RGB(255, 255, 255));

		int length = anno.getEnd() - anno.getBegin();
		int offset = anno.getBegin();

		if (length > 0) {

			// also set the text to italic
			styleRange.start = anno.getBegin();
			styleRange.length = length;
			styleRange.fontStyle = SWT.ITALIC;
			// styleRange.foreground = black;
			// styleRange.background = white;
		}
		widget.setStyleRange(styleRange);

		gc.dispose();
		black.dispose();
		white.dispose();

	}

	@Override
	public int getLineHeight(AnnotationFS anno) {
		return 0;
	}

}
