package de.uniwue.mk.kall.editorPainting.featurerepresentation;

import java.util.HashMap;
import java.util.Map;

import org.apache.uima.cas.Feature;
import org.apache.uima.cas.text.AnnotationFS;
import org.eclipse.jface.text.source.Annotation;
import org.eclipse.jface.text.source.AnnotationPainter.IDrawingStrategy;
import org.eclipse.swt.custom.StyledText;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.GC;

import de.uniwue.kalimachos.coref.editor.drawingstructure.TypeStyleDataStructure;
import de.uniwue.kalimachos.coref.paintingStrategies.INeedBothAnnotationDrawingStrategy;

//TODO should be marshallable
public class GeneralConfigurableDrawingStrategy implements IDrawingStrategy, INeedBothAnnotationDrawingStrategy {

	private Map<Feature, AFeatureDrawingStyling> featureStylings;

	// has to be here for JAXB
	public GeneralConfigurableDrawingStrategy() {
		featureStylings = new HashMap<Feature, AFeatureDrawingStyling>();
	}

	public Map<Feature, AFeatureDrawingStyling> getFeatureStylings() {
		return featureStylings;
	}

	public void setFeatureStylings(Map<Feature, AFeatureDrawingStyling> featureStylings) {
		this.featureStylings = featureStylings;
	}

	// used to draw with GC
	@Override
	public void draw(Annotation anno, GC gc, StyledText widget, int offset, int length, Color color) {
		for (AFeatureDrawingStyling styling : featureStylings.values()) {
			styling.draw(anno, widget, gc);
		}

	}

	// used to draw with widget
	@Override
	public void manipulateWidget(TypeStyleDataStructure struct, AnnotationFS anno, StyledText widget, GC gc) {

		for (AFeatureDrawingStyling styling : featureStylings.values()) {
			styling.manipulateWidget(anno, widget, gc);
		}

	}

}
