package de.uniwue.mk.kall.editorPainting.paintingstrategies.specialized;

import org.apache.uima.cas.Feature;
import org.apache.uima.cas.text.AnnotationFS;
import org.eclipse.swt.custom.StyleRange;
import org.eclipse.swt.custom.StyledText;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.FontData;
import org.eclipse.swt.graphics.GC;
import org.eclipse.swt.graphics.Rectangle;

import de.uniwue.kalimachos.coref.editor.drawingstructure.TypeStyleDataStructure;
import de.uniwue.kalimachos.coref.paintingStrategies.IAnnotationDrawingStrategy;

public class TermViewConceptGoldDrawingStrategy implements IAnnotationDrawingStrategy {

	private static final int FONTSIZE = 8;
	private StyleRange styleRange;
	private Feature featID;

	public TermViewConceptGoldDrawingStrategy(StyleRange rangeConceptGold, Feature featConceptIdGold) {

		this.styleRange = rangeConceptGold;
		this.featID = featConceptIdGold;
	}

	@Override
	public void drawAnnotation(TypeStyleDataStructure struct, AnnotationFS anno, StyledText widget, GC gc) {

		// draw a rectangle
		int length = anno.getEnd() - anno.getBegin();
		int offset = anno.getBegin();
		if (length != 0) {
			if (gc != null) {
				Rectangle bounds = widget.getTextBounds(offset, offset + length - 1);

				gc.setForeground(styleRange.background);
				Font initialFont = widget.getFont();
				FontData[] fontData = initialFont.getFontData();
				for (int i = 0; i < fontData.length; i++) {
					fontData[i].setHeight(7);
				}

				Font font = new Font(gc.getDevice(), fontData);
				gc.setFont(font);

				int correctedHeight;

				if (bounds.height > 0) {
					correctedHeight = bounds.height - 1;
				} else {
					correctedHeight = bounds.height;
				}

				int correctedWidth;

				if (bounds.width > 0)
					correctedWidth = bounds.width - 1;
				else
					correctedWidth = bounds.width;

				gc.drawRectangle(bounds.x, bounds.y, correctedWidth, correctedHeight);

				gc.drawString(anno.getFeatureValueAsString(featID), bounds.x + bounds.width - 1,
						bounds.y - widget.getLineHeight() + FONTSIZE);

			}

		}
	}

	@Override
	public int getLineHeight(AnnotationFS anno) {
		return IAnnotationDrawingStrategy.WIDGET_DEFAULT_LINEHEIGHT;
	}
}
