package de.uniwue.mk.kall.editorPainting.paintingstrategies.specialized;

import org.apache.uima.cas.text.AnnotationFS;
import org.eclipse.swt.custom.StyleRange;
import org.eclipse.swt.custom.StyledText;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.GC;
import org.eclipse.swt.graphics.RGB;
import org.eclipse.swt.widgets.Display;

import de.uniwue.kalimachos.coref.editor.drawingstructure.TypeStyleDataStructure;
import de.uniwue.kalimachos.coref.paintingStrategies.IAnnotationDrawingStrategy;
import de.uniwue.mkrug.kall.typesystemutil.Util_impl;

public class TokenDrawingStrategy implements IAnnotationDrawingStrategy {
	private Color[] colors;
	private int currentColor;
	private boolean useBrighterColor = false;

	public TokenDrawingStrategy(StyleRange range) {
		colors = new Color[2];
		colors[0] = new Color(Display.getCurrent(), new RGB(100, 100, 220));
		colors[1] = new Color(Display.getCurrent(), new RGB(170, 170, 250));
		currentColor = 0;
	}

	@Override
	public void drawAnnotation(TypeStyleDataStructure struct, AnnotationFS anno, StyledText widget, GC gc) {

		StyleRange range = widget.getStyleRangeAtOffset(anno.getBegin());
		if (range != null) {
			gc.dispose();
			return;
		}

		StyleRange styleRange = new StyleRange();
		styleRange.start = anno.getBegin();
		styleRange.length = anno.getEnd() - anno.getBegin();
		//styleRange.background = colors[currentColor];
		
		// change the Color of the GC object
		Util_impl util = new Util_impl(anno.getCAS());
		if (util.getIndexOfTypeInDocument(anno) % 2 == 0) {
			styleRange.background = colors[0];
		} else {
			styleRange.background = colors[1];
		}
		widget.setStyleRange(styleRange);

//		currentColor = (currentColor + 1) % colors.length;

		gc.dispose();
	}

	@Override
	public int getLineHeight(AnnotationFS anno) {
		return 0;
	}

}
