package de.uniwue.mk.kall.grammarView;

import java.util.HashMap;

import org.eclipse.jface.dialogs.Dialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

import de.uniwue.mk.kall.athen.appDelegation.hierarchie.IAnnotationEditorDialog;
import de.uniwue.mk.kall.athen.appDelegation.util.ApplicationUtil;

public class GrammarPreferencesDialogue extends Dialog implements IAnnotationEditorDialog {

	HashMap<String, String> preferences;

	Label labelGrammarType;
	Text textGrammarType;
	Label labelGrammerFeature;
	Text textGrammarFeature;

	Label labelTypeOverride;
	Text textTypeOverride;

	Button buttonSetBuiltIn;

	public GrammarPreferencesDialogue(Shell parentShell) {
		super(parentShell);

		preferences = new HashMap<String, String>();

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * org.eclipse.jface.dialogs.Dialog#createDialogArea(org.eclipse.swt.widgets
	 * .Composite)
	 */
	protected Control createDialogArea(Composite parent) {

		parent.getShell().setText("Specify View Settings");

		GridLayout layout = new GridLayout();

		layout.numColumns = 2;

		parent.setLayout(layout);

		// =======ADD WIDGETS====

		labelGrammarType = new Label(parent, SWT.NONE);
		textGrammarType = new Text(parent, SWT.None);
		labelGrammerFeature = new Label(parent, SWT.NONE);
		textGrammarFeature = new Text(parent, SWT.None);

		labelTypeOverride = new Label(parent, SWT.NONE);
		textTypeOverride = new Text(parent, SWT.None);

		labelGrammarType.setText("Enter Grammar-Type");
		labelGrammerFeature.setText("Enter GrammarFunction Feature");

		labelTypeOverride.setText("Enter Grammer-Override Type");

		buttonSetBuiltIn = new Button(parent, SWT.None);

		buttonSetBuiltIn.setText("Use Built-In Configuration");

		buttonSetBuiltIn.addSelectionListener(new SelectionListener() {

			@Override
			public void widgetSelected(SelectionEvent e) {

				// set all preferences
				textGrammarType.setText("de.uniwue.kalimachos.coref.type.GrammarType");
				textGrammarFeature.setText("GrammarFunction");
				textTypeOverride.setText("de.uniwue.kalimachos.coref.type.GrammarAlreadyHandled");

			}

			@Override
			public void widgetDefaultSelected(SelectionEvent e) {
				widgetSelected(e);

			}
		});

		textGrammarType.setText(ApplicationUtil.getFromPreferences(labelGrammarType.getText(), "preference not found"));

		textGrammarFeature.setText(ApplicationUtil.getFromPreferences(labelGrammerFeature.getText(),
				"preference not found"));

		textTypeOverride
				.setText(ApplicationUtil.getFromPreferences(labelTypeOverride.getText(), "preference not found"));

		return parent;
	}

	@Override
	protected void okPressed() {

		// save to the preference map

		// TODO use the string constants instead of the literals
		this.preferences.put(labelGrammarType.getText(), textGrammarType.getText());
		this.preferences.put(labelGrammerFeature.getText(), textGrammarFeature.getText());
		this.preferences.put(labelTypeOverride.getText(), textTypeOverride.getText());

		setReturnCode(OK);
		close();
	}

	@Override
	public HashMap<String, String> getPreferences() {

		return this.preferences;
	}

}
