package de.uniwue.mk.kall.ie.ieview.dialog;

import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.semanticweb.owlapi.model.OWLObjectProperty;
import org.semanticweb.owlapi.model.OWLOntology;

import de.uniwue.mk.kall.ie.terminology.struct.IEOntology;
import de.uniwue.mk.kall.ie.terminology.struct.OWLOntologyPropertyWrapper;

public class DomainAndRangeComposite extends Composite{
	
	private PropertyAssignClassComposite domainComposite;
	private PropertyAssignClassComposite rangeComposite;
	private OWLOntologyPropertyWrapper property;
	private IEOntology ontology;
	
	
	
	public static final String DOMAIN_BEHAVIOUR = "Domain_BEHAVIOUR";
	public static final String RANGE_BEHAVIOUR = "Range_BEHAVIOUR";

	public DomainAndRangeComposite(Composite parent, int style) {
		super(parent, style);
		
		this.setLayout(new GridLayout(2, true));
		domainComposite = new PropertyAssignClassComposite(this, SWT.NONE,DOMAIN_BEHAVIOUR);
		rangeComposite = new PropertyAssignClassComposite(this, SWT.NONE,RANGE_BEHAVIOUR);
	}

	public void setInput(OWLOntologyPropertyWrapper property,IEOntology ontology){
		this.property = property;
		this.ontology = ontology;
		updateLayout();
	}

	private void updateLayout() {
		domainComposite.setInput(property,ontology);
		rangeComposite.setInput(property,ontology);
		layout();
		
	}
}
