package de.uniwue.mk.kall.ie.ieview.dialog;

import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.StyledText;
import org.eclipse.swt.events.KeyAdapter;
import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.semanticweb.owlapi.model.OWLEntity;
import org.semanticweb.owlapi.model.OWLOntology;

import de.uniwue.mk.kall.ie.terminology.util.OWLUtil;

public class NameEditingComposite extends Composite {

	private Label labelName;

	private StyledText textName;

	private Label labelFullIRI;

	private OWLOntology ontology;

	private OWLEntity entity;
	
	private String newIRI;

	public NameEditingComposite(Composite parent, int style) {
		super(parent, style);

		this.setLayout(new GridLayout(2, false));
		GridData layoutData = new GridData(GridData.GRAB_HORIZONTAL | GridData.FILL_HORIZONTAL);
		this.setLayoutData(layoutData);

		labelName = new Label(this, SWT.NONE);
		labelName.setText("Name");

		textName = new StyledText(this, SWT.BORDER);
		textName.setLayoutData(layoutData);
		textName.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_TITLE_BACKGROUND_GRADIENT));

		labelFullIRI = new Label(this, SWT.BORDER);
		GridData layoutDataIRI = new GridData(GridData.GRAB_HORIZONTAL | GridData.FILL_HORIZONTAL);
		layoutDataIRI.horizontalSpan = 2;
		labelFullIRI.setLayoutData(layoutDataIRI);

		textName.addKeyListener(new KeyAdapter() {

			@Override
			public void keyReleased(KeyEvent e) {
				
				NameEditingComposite.this.newIRI = entity.getIRI().getNamespace() + textName.getText();
				boolean doesAlreadyExist = OWLUtil.doesEntityExist(newIRI, ontology);
				if(doesAlreadyExist){
					labelFullIRI.setText("Entity does already exist!");
					NameEditingComposite.this.getParent().layout();
					return;
				}

				//IRI is free
				labelFullIRI.setText(newIRI);
				
				NameEditingComposite.this.layout();
				parent.layout();
				parent.redraw();
			}

		});

	}

	public void setInput(OWLEntity entity, OWLOntology ontology) {
		this.ontology = ontology;
		this.entity = entity;
		textName.setText(entity.getIRI().getFragment());
		labelFullIRI.setText(entity.getIRI().toString());

	}

	public String getNewIRI() {
		
		return this.newIRI;
	}

}
