package de.uniwue.mk.kall.ie.ieview.dialog;

import org.eclipse.jface.dialogs.Dialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.StyledText;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Shell;

import de.uniwue.mk.kall.ie.terminology.struct.IEOntology;
import de.uniwue.mk.kall.ie.terminology.struct.OWLOntologyClassWrapper;

public class OWLClassWrapperEditDialog extends Dialog {

	private StyledText widget;
	private Shell shell;
	private IEOntology ontology;
	private OWLOntologyClassWrapper classToEdit;
	private OWLAnnotationEditComposite annotationComposite;
	private ComplexClassComposite complexClassComposite;
	private NameEditingComposite nameEditingComposite;
	

	public OWLClassWrapperEditDialog(Shell parentShell, IEOntology ontology, OWLOntologyClassWrapper classToEdit) {
		super(parentShell);

		this.shell = parentShell;
		this.ontology = ontology;
		this.classToEdit = classToEdit;

	}

	protected Control createDialogArea(Composite parent) {

		parent.getShell().setText("Edit the class " + classToEdit.getWrappedClass().getIRI().getFragment());

		// layout
		GridLayout layout = new GridLayout(1, false);
		layout.marginBottom = 10;
		layout.marginTop = 10;
		layout.marginLeft = 15;
		layout.marginRight = 15;
		parent.setLayout(layout);

		nameEditingComposite = new NameEditingComposite(parent, SWT.NONE);
		nameEditingComposite.setInput(classToEdit.getWrappedClass(), ontology.getOntology());


		// add annotation composite
		annotationComposite = new OWLAnnotationEditComposite(parent, SWT.BORDER);
		annotationComposite.setInput(ontology.getOntology(), classToEdit.getWrappedClass());
		GridData gd = new GridData(GridData.GRAB_HORIZONTAL | GridData.FILL_HORIZONTAL);
		gd.horizontalSpan = 5;
		annotationComposite.setLayoutData(gd);

		// complex class composite

		complexClassComposite = new ComplexClassComposite(parent, SWT.BORDER);
		complexClassComposite.setInput(ontology, classToEdit.getWrappedClass());
		complexClassComposite.setLayoutData(gd);

		// font.dispose();
		return parent;
	}

	@Override
	protected void setShellStyle(int newShellStyle) {
		super.setShellStyle(SWT.CLOSE | SWT.MODELESS | SWT.BORDER | SWT.TITLE | SWT.RESIZE);
		setBlockOnOpen(false);
	}

	public String getNewIRI() {
		return nameEditingComposite.getNewIRI();
	}


	
//	@Override
//	protected Point getInitialSize() {
//		return new Point(550, 800);
//	}
	
	


}
