package de.uniwue.mk.kall.ie.ieview.dialog;

import org.eclipse.jface.dialogs.Dialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.StyledText;
import org.eclipse.swt.events.KeyAdapter;
import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;

import de.uniwue.mk.kall.ie.terminology.struct.IEOntology;
import de.uniwue.mk.kall.ie.terminology.struct.OWLOntologyClassWrapper;
import de.uniwue.mk.kall.ie.terminology.struct.OWLOntologyPropertyWrapper;

public class OWLPropertyWrapperEditDialog extends Dialog {

	private StyledText widget;
	private Shell shell;
	private IEOntology ontology;
	private OWLOntologyPropertyWrapper propertyToEdit;
	private NameEditingComposite nameEditingComposite;
	private PropertyEditingComposite propertyEditingComposite;


	public OWLPropertyWrapperEditDialog(Shell parentShell, IEOntology ontology,
			OWLOntologyPropertyWrapper propertyToEdit) {
		super(parentShell);

		this.shell = parentShell;
		this.ontology = ontology;
		this.propertyToEdit = propertyToEdit;

	}

	protected Control createDialogArea(Composite parent) {

		parent.getShell().setText("Edit the property " + propertyToEdit.getWrappedProperty().getIRI().getFragment());

		// layout
		GridLayout layout = new GridLayout(1, false);
		layout.marginBottom = 10;
		layout.marginTop = 10;
		layout.marginLeft = 15;
		layout.marginRight = 15;
		parent.setLayout(layout);

		// TODO investigate why the font cannot be accessed
		// Font font = new Font(Display.getDefault(), "Segoe UI", 10,
		// SWT.NORMAL);

		nameEditingComposite = new NameEditingComposite(parent, SWT.NONE);
		nameEditingComposite.setInput(propertyToEdit.getWrappedProperty(), ontology.getOntology());
		
		propertyEditingComposite = new PropertyEditingComposite(parent, SWT.NONE);
		propertyEditingComposite.setInput(propertyToEdit, ontology);
		

		// font.dispose();
		return parent;
	}

	@Override
	protected void setShellStyle(int newShellStyle) {
		super.setShellStyle(SWT.CLOSE | SWT.MODELESS | SWT.BORDER | SWT.TITLE | SWT.RESIZE);
		setBlockOnOpen(false);
	}

	@Override
	protected Point getInitialSize() {
		return new Point(600, 400);
	}

	public String getNewIRI() {
		return this.nameEditingComposite.getNewIRI();
	}

}
