package de.uniwue.mk.kall.ie.ieview.dialog;

import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;

import de.uniwue.mk.kall.ie.terminology.struct.IEOntology;
import de.uniwue.mk.kall.ie.terminology.struct.OWLOntologyPropertyWrapper;

public class PropertyEditingComposite extends Composite{

	private PropertyCharacteristicsComposite propertyCharacteristicsComposite;
	private DomainAndRangeComposite domainAndRangeComposite;
	private OWLOntologyPropertyWrapper propertyToEdit;
	private IEOntology ontology;
	public PropertyEditingComposite(Composite parent, int style) {
		super(parent, style);
		this.setLayout(new GridLayout(1, false));
		GridData layoutData = new GridData(GridData.GRAB_HORIZONTAL | GridData.FILL_BOTH|GridData.GRAB_VERTICAL);
		this.setLayoutData(layoutData);
		
		propertyCharacteristicsComposite = new PropertyCharacteristicsComposite(this,
				SWT.BORDER);
		GridData gd = new GridData(GridData.GRAB_HORIZONTAL | GridData.FILL_HORIZONTAL);
		gd.horizontalSpan = 2;
		propertyCharacteristicsComposite.setLayoutData(gd);
		
		domainAndRangeComposite = new DomainAndRangeComposite(this, SWT.BORDER);
		GridData gd2 = new GridData(GridData.GRAB_HORIZONTAL | GridData.FILL_BOTH | GridData.GRAB_VERTICAL);
		gd2.horizontalSpan = 2;
		domainAndRangeComposite.setLayoutData(gd2);
	}
	
	public void setInput(OWLOntologyPropertyWrapper property, IEOntology ontology){
		this.propertyToEdit = property;
		this.ontology = ontology;
		propertyCharacteristicsComposite.setInput(propertyToEdit.getWrappedProperty(), ontology.getOntology());
		
		domainAndRangeComposite.setInput(propertyToEdit, ontology);
		layout();
		
	}

}
