package de.uniwue.mk.kall.ie.ieview.dialog;

import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import org.eclipse.jface.dialogs.Dialog;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Shell;
import org.semanticweb.owlapi.model.OWLClass;

import de.uniwue.mk.kall.ie.ieview.widget.TreeHierarchyComposite;
import de.uniwue.mk.kall.ie.terminology.struct.IEOntology;
import de.uniwue.mk.kall.ie.terminology.struct.OWLOntologyClassWrapper;

public class SelectClassesDialog extends Dialog {

	private IEOntology ontology;
	private Shell shell;
	private TreeHierarchyComposite treeHierarchyComposite;

	private List<OWLClass> selectedClasses;

	public SelectClassesDialog(Shell parentShell, IEOntology ontology) {
		super(parentShell);

		this.shell = parentShell;
		this.ontology = ontology;
		this.selectedClasses = new LinkedList<>();
	}

	protected Control createDialogArea(Composite parent) {
		treeHierarchyComposite = new TreeHierarchyComposite(parent, SWT.BORDER, null);
		treeHierarchyComposite.setOntology(ontology);
		return parent;
	}

	@Override
	protected Point getInitialSize() {
		return new Point(400, 400);
	}

	@Override
	protected void okPressed() {

		IStructuredSelection sel = (IStructuredSelection) treeHierarchyComposite.getViewer().getSelection();
		Iterator iterator = sel.iterator();
		while (iterator.hasNext()) {
			//TODO typesafe?
			OWLOntologyClassWrapper wrapper = (OWLOntologyClassWrapper) iterator.next();
			//TODO here we need to be able to select the rootnode...
			this.selectedClasses.add(wrapper.getWrappedClass());
			
		}
		setReturnCode(OK);
		close();
	}

	public List<OWLClass> getSelectedClasses() {
		return selectedClasses;
	}

	public void setSelectedClasses(List<OWLClass> selectedClasses) {
		this.selectedClasses = selectedClasses;
	}
	

}
