package de.uniwue.mk.kall.ie.ieview.dialog;

import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import org.eclipse.jface.dialogs.Dialog;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Shell;
import org.semanticweb.owlapi.model.OWLObjectProperty;

import de.uniwue.mk.kall.ie.ieview.widget.TreeHierarchyComposite;
import de.uniwue.mk.kall.ie.ieview.widget.TreeRelationComposite;
import de.uniwue.mk.kall.ie.terminology.struct.IEOntology;
import de.uniwue.mk.kall.ie.terminology.struct.OWLOntologyPropertyWrapper;

public class SelectPropertyDialog extends Dialog {

	private IEOntology ontology;
	private TreeRelationComposite treeRelationComposite;

	private List<OWLObjectProperty> selectedProperties;

	public SelectPropertyDialog(Shell parentShell, IEOntology ontology) {
		super(parentShell);

		this.ontology = ontology;
		this.selectedProperties = new LinkedList<>();
	}

	protected Control createDialogArea(Composite parent) {
		treeRelationComposite = new TreeRelationComposite(parent, SWT.BORDER, null);
		treeRelationComposite.setOntology(ontology);
		return parent;
	}

	@Override
	protected Point getInitialSize() {
		return new Point(400, 400);
	}

	@Override
	protected void okPressed() {

		IStructuredSelection sel = (IStructuredSelection) treeRelationComposite.getViewer().getSelection();
		Iterator<?> iterator = sel.iterator();
		while (iterator.hasNext()) {
			//TODO typesafe?
			OWLOntologyPropertyWrapper wrapper = (OWLOntologyPropertyWrapper) iterator.next();
			//TODO here we need to be able to select the rootnode...
			this.selectedProperties.add(wrapper.getWrappedProperty());
			
		}
		setReturnCode(OK);
		close();
	}

	public List<OWLObjectProperty> getSelectedProperties() {
		return selectedProperties;
	}



}
