package de.uniwue.mk.kall.ie.ieview.widget;

import org.eclipse.jface.viewers.ITreeContentProvider;

import de.uniwue.mk.kall.ie.terminology.struct.IEOntology;
import de.uniwue.mk.kall.ie.terminology.struct.OWLOntologyClassWrapper;
import de.uniwue.mk.kall.ie.terminology.struct.OWLOntologyPropertyWrapper;
import de.uniwue.mk.kall.ie.terminology.util.OWLUtil;

public class IEOntologyContentProvider implements ITreeContentProvider {
	
	String content;
	 public IEOntologyContentProvider(String content) {
		 this.content = content;
	}

	@Override
	public Object[] getElements(Object inputElement) {
		if (inputElement instanceof IEOntology && this.content.equals(IProviderConstants.WIDGET_CLASS)) {
			IEOntology ontology = (IEOntology) inputElement;
			return new Object[] { OWLUtil.getRootClass(ontology) };
		}
		
		if (inputElement instanceof IEOntology && this.content.equals(IProviderConstants.WIDGET_PROPERTIES)) {
			IEOntology ontology = (IEOntology) inputElement;
			return new Object[] { OWLUtil.getRootProperty(ontology) };
		}
		
		return null;
	}

	@Override
	public Object[] getChildren(Object parentElement) {
		if (parentElement instanceof OWLOntologyClassWrapper) {
			return ((OWLOntologyClassWrapper) parentElement).getChildren().toArray(new OWLOntologyClassWrapper[0]);
		}
		
		else if (parentElement instanceof OWLOntologyPropertyWrapper) {
			return ((OWLOntologyPropertyWrapper) parentElement).getChildren().toArray(new OWLOntologyPropertyWrapper[0]);
		}
		return null;
	}

	@Override
	public Object getParent(Object element) {

		if (element instanceof OWLOntologyClassWrapper) {
			return ((OWLOntologyClassWrapper) element).getParent();
		}
		
		else if (element instanceof OWLOntologyPropertyWrapper) {
			return ((OWLOntologyPropertyWrapper) element).getParent();
		}
		return null;
	}

	@Override
	public boolean hasChildren(Object element) {

		if (element instanceof OWLOntologyClassWrapper) {
			return ((OWLOntologyClassWrapper) element).getChildren().size() > 0;
		}
		
		else if (element instanceof OWLOntologyPropertyWrapper) {
			return ((OWLOntologyPropertyWrapper)element).getChildren().size()>0;
		}
		return false;
	}

}
