package de.uniwue.mk.kall.ie.ieview.widget;


import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;

import de.uniwue.mk.kall.athen.widget.editor.AnnotationEditorWidget;
import de.uniwue.mk.kall.ie.terminology.struct.IEOntology;

public class IEOntologyTreeComposite extends Composite {
	

	private TreeHierarchyComposite treeHierarchyComposite;
	private TreeRelationComposite treeRelationComposite;
	private AnnotationEditorWidget editor;
	private IEOntology ontology;

	public IEOntologyTreeComposite(Composite parent, int style,AnnotationEditorWidget editor) {
		super(parent, style);
		this.setLayout(new GridLayout(1,false));
		this.editor = editor;
		this.setLayoutData(new GridData(GridData.GRAB_HORIZONTAL|GridData.GRAB_VERTICAL|GridData.FILL_BOTH));
		treeHierarchyComposite = new TreeHierarchyComposite(this, SWT.BORDER,editor);
		treeRelationComposite = new TreeRelationComposite(this, SWT.BORDER,editor);
		
	}
	
	public void setOntology(IEOntology ontology){
		this.ontology = ontology;
		treeHierarchyComposite.setOntology(ontology);
		treeRelationComposite.setOntology(ontology);
		layout();
	}

	public IEOntology getOntology() {
		return ontology;
	}

	//delegate to setOntology to have a synchronized update of both trees
	public void rehreshOntology() {
		setOntology(ontology);
		
	}

	public void setEditorTextSelection(Point selection) {
		treeRelationComposite.setEditorTextSelection(selection);
		
	}
	
	

}
