package de.uniwue.mk.kall.ie.ieview.widget;

import org.eclipse.jface.viewers.Viewer;
import org.eclipse.jface.viewers.ViewerComparator;

import de.uniwue.mk.kall.ie.terminology.struct.OWLOntologyClassWrapper;
import de.uniwue.mk.kall.ie.terminology.struct.OWLOntologyPropertyWrapper;

public class TreeViewerAlphabeticalSorter extends ViewerComparator {

	private String context;

	public TreeViewerAlphabeticalSorter(String context) {
		this.context = context;
	}

	public int compare(Viewer viewer, Object e1, Object e2) {

		if (context.equals(IProviderConstants.WIDGET_CLASS)) {
			OWLOntologyClassWrapper wrapper1 = (OWLOntologyClassWrapper) e1;
			OWLOntologyClassWrapper wrapper2 = (OWLOntologyClassWrapper) e2;
			
			return wrapper1.getWrappedClass().getIRI().getFragment().compareTo(wrapper2.getWrappedClass().getIRI().getFragment());
		}
		
		else if(context.equals(IProviderConstants.WIDGET_PROPERTIES)){
			OWLOntologyPropertyWrapper wrapper1 = (OWLOntologyPropertyWrapper) e1;
			OWLOntologyPropertyWrapper wrapper2 = (OWLOntologyPropertyWrapper) e2;
			
			return wrapper1.getWrappedProperty().getIRI().getFragment().compareTo(wrapper2.getWrappedProperty().getIRI().getFragment());
			
		}
		
		return 0;
	}
}
