package de.uniwue.mk.kall.ie.terminology.struct;

import java.io.File;

import org.semanticweb.owlapi.model.OWLOntology;
import org.semanticweb.owlapi.model.OWLOntologyCreationException;

import de.uniwue.mk.kall.ie.terminology.util.OWLUtil;

public class IEOntology {

	/*
	 * makes use of an owl ontology and serves more as a wrapper
	 */

	// the core of this wrapper class
	OWLOntology ontology;

	// Constructor, just saves the OWLOntology
	public IEOntology(OWLOntology ontologyFromFile) {
		if (ontologyFromFile == null)
			throw new IllegalArgumentException("Please use an existing ontology");
		this.ontology = ontologyFromFile;
	}

	// easy to use IO
	public static IEOntology loadOntologyFromFile(String path) {

		OWLOntology ontologyFromFile = null;
		try {
			ontologyFromFile = OWLUtil.loadOntologyFromFile(new File(path));
		} catch (OWLOntologyCreationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		return new IEOntology(ontologyFromFile);

	}

	// wrapper to UTIL
	public static void saveOntologyToFile(String path, IEOntology ont) {

		OWLUtil.saveOntologyToFile(path, ont.ontology);
	}


	public OWLOntology getOntology() {
		return ontology;
	}

	public void setOntology(OWLOntology ontology) {
		this.ontology = ontology;
	}
	
	

}
