package de.uniwue.mk.kall.ie.terminology.struct;

import java.util.HashSet;
import java.util.Set;

import org.semanticweb.owlapi.model.OWLClass;
import org.semanticweb.owlapi.model.OWLOntology;

public class OWLOntologyClassWrapper {
	
	private OWLOntologyClassWrapper parent;
	
	private Set<OWLOntologyClassWrapper> children;
	
	private OWLClass wrappedClass;
	
	public OWLOntologyClassWrapper(OWLOntology ontology, OWLClass owlClass){
		this.wrappedClass = owlClass;
		children = new HashSet<>();
		
	}

	public OWLOntologyClassWrapper getParent() {
		return parent;
	}

	public void setParent(OWLOntologyClassWrapper parent) {
		this.parent = parent;
	}

	public Set<OWLOntologyClassWrapper> getChildren() {
		return children;
	}

	public void setChildren(Set<OWLOntologyClassWrapper> children) {
		this.children = children;
	}

	public OWLClass getWrappedClass() {
		return wrappedClass;
	}

	public void setWrappedClass(OWLClass wrappedClass) {
		this.wrappedClass = wrappedClass;
	}

	public void addChild(OWLOntologyClassWrapper owlOntologyClassWrapper) {
		this.children.add(owlOntologyClassWrapper);
		owlOntologyClassWrapper.parent = this;
		
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((wrappedClass == null) ? 0 : wrappedClass.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		OWLOntologyClassWrapper other = (OWLOntologyClassWrapper) obj;
		if (wrappedClass == null) {
			if (other.wrappedClass != null)
				return false;
		} else if (!wrappedClass.equals(other.wrappedClass))
			return false;
		return true;
	}
	
	
	

}
