package de.uniwue.mk.kall.ie.terminology.struct;

import java.util.Collection;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.List;
import java.util.Set;

import org.semanticweb.owlapi.model.OWLObjectProperty;
import org.semanticweb.owlapi.model.OWLOntology;

public class OWLOntologyPropertyWrapper {

	private OWLOntologyPropertyWrapper parent;

	private Set<OWLOntologyPropertyWrapper> children;

	private OWLObjectProperty wrappedProperty;

	public OWLOntologyPropertyWrapper(OWLOntology ontology, OWLObjectProperty owlObjectProperty) {
		this.wrappedProperty = owlObjectProperty;
		children = new HashSet<>();

	}

	public OWLOntologyPropertyWrapper getParent() {
		return parent;
	}

	public void setParent(OWLOntologyPropertyWrapper parent) {
		this.parent = parent;
	}

	public Set<OWLOntologyPropertyWrapper> getChildren() {
		return children;
	}

	public void setChildren(Set<OWLOntologyPropertyWrapper> children) {
		this.children = children;
	}

	public OWLObjectProperty getWrappedProperty() {
		return wrappedProperty;
	}

	public void setWrappedProperty(OWLObjectProperty wrappedProperty) {
		this.wrappedProperty = wrappedProperty;
	}

	public void addChild(OWLOntologyPropertyWrapper owlOntologyPropertyWrapper) {
		this.children.add(owlOntologyPropertyWrapper);
		owlOntologyPropertyWrapper.parent = this;
		
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((wrappedProperty == null) ? 0 : wrappedProperty.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		OWLOntologyPropertyWrapper other = (OWLOntologyPropertyWrapper) obj;
		if (wrappedProperty == null) {
			if (other.wrappedProperty != null)
				return false;
		} else if (!wrappedProperty.equals(other.wrappedProperty))
			return false;
		return true;
	}

	public Collection<OWLOntologyPropertyWrapper> getAllSubsumedChildren() {
		List<OWLOntologyPropertyWrapper> allChildren = new LinkedList<>();
		
		for(OWLOntologyPropertyWrapper wrapper : this.children){
			allChildren.add(wrapper);
			allChildren.addAll(wrapper.getAllSubsumedChildren());
		}
		return allChildren;
	}
	
	
	
	

}
