package de.uniwue.mk.kall.lucene;

import org.apache.lucene.analysis.Analyzer;
import org.apache.uima.cas.CAS;
import org.apache.uima.cas.text.AnnotationFS;

public class AthenLuceneAnalyzer extends Analyzer {
	private AnnotationFS documentPart;
	private CAS cas;
	private AthenLuceneTokenizer tokenizer;


	public AthenLuceneAnalyzer(IndexTypeConfiguration configuration) {
		tokenizer = new AthenLuceneTokenizer(configuration);
	}


	public AnnotationFS getDocumentPart() {
		return documentPart;
	}

	public void setDocumentPart(AnnotationFS docPart) {
		documentPart = docPart;
		tokenizer.setDocumentPart(docPart);
	}

	public CAS getCas() {
		return cas;
	}

	public void setCas(CAS cas) {
		this.cas = cas;
		tokenizer.setCas(cas);
	}

	@Override
	protected TokenStreamComponents createComponents(String arg0) {
		return new TokenStreamComponents(tokenizer);
	}

}
