package de.uniwue.mk.kall.lucene.kallimachos.index;

import org.apache.lucene.analysis.Analyzer;
import org.apache.uima.cas.CAS;
import org.apache.uima.cas.text.AnnotationFS;

import de.uniwue.mkrug.kall.typesystemutil.Util_impl;

public class CustomUIMAAnalyzer extends Analyzer {

  private AnnotationFS sentence;

  private CAS cas;

  private Util_impl util;

  private UIMALuceneTokenizer uimaLuceneTokenizer;

  public CustomUIMAAnalyzer() {
    uimaLuceneTokenizer = new UIMALuceneTokenizer();

  }

  public AnnotationFS getSentence() {
    return sentence;
  }

  public void setSentence(AnnotationFS sentence) {
    this.sentence = sentence;
    uimaLuceneTokenizer.setSentence(sentence);
  }

  public CAS getCas() {
    return cas;
  }

  public void setCas(CAS cas) {
    this.cas = cas;
    this.util = new Util_impl(cas);
    uimaLuceneTokenizer.setCas(cas);
  }


  @Override
  protected TokenStreamComponents createComponents(String field) {


    return new TokenStreamComponents(uimaLuceneTokenizer);
  }

}
