package de.uniwue.mk.kall.wsdView;

import java.util.HashMap;

import org.eclipse.jface.dialogs.Dialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

import de.uniwue.mk.kall.athen.appDelegation.hierarchie.IAnnotationEditorDialog;
import de.uniwue.mk.kall.athen.appDelegation.util.ApplicationPreferences;
import de.uniwue.mk.kall.athen.appDelegation.util.ApplicationUtil;

public class WSDPreferencesDialogue extends Dialog implements IAnnotationEditorDialog {

	HashMap<String, String> preferences;

	Label labelWSDType;
	Text textWSDType;
	Label labelCategoryFeature;
	Text textCategoryFeature;

	Label labelCandidatesFeature;
	Text textCandidatesFeature;

	Label labelTypeOverride;
	Text textTypeOverride;

	Label labelPOSType;
	Text textPOSType;

	Button buttonSetBuiltIn;

	public WSDPreferencesDialogue(Shell parentShell) {
		super(parentShell);

		preferences = new HashMap<String, String>();

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * org.eclipse.jface.dialogs.Dialog#createDialogArea(org.eclipse.swt.widgets
	 * .Composite)
	 */
	protected Control createDialogArea(Composite parent) {

		parent.getShell().setText("Specify View Settings");

		GridLayout layout = new GridLayout();

		layout.numColumns = 2;

		parent.setLayout(layout);

		// =======ADD WIDGETS====

		labelWSDType = new Label(parent, SWT.NONE);
		textWSDType = new Text(parent, SWT.None);
		labelCategoryFeature = new Label(parent, SWT.NONE);
		textCategoryFeature = new Text(parent, SWT.None);

		labelTypeOverride = new Label(parent, SWT.NONE);
		textTypeOverride = new Text(parent, SWT.None);

		labelPOSType = new Label(parent, SWT.NONE);
		textPOSType = new Text(parent, SWT.None);

		labelCandidatesFeature = new Label(parent, SWT.NONE);
		textCandidatesFeature = new Text(parent, SWT.None);

		labelWSDType.setText("Enter WSD-Type");
		labelCategoryFeature.setText("Enter WSD-Category Feature");

		labelTypeOverride.setText("Enter WSD-Override Type");
		labelCandidatesFeature.setText("Enter Candidates Feature");

		labelPOSType.setText("Enter POS-Type");

		buttonSetBuiltIn = new Button(parent, SWT.None);

		buttonSetBuiltIn.setText("Use Built-In Configuration");

		buttonSetBuiltIn.addSelectionListener(new SelectionListener() {

			@Override
			public void widgetSelected(SelectionEvent e) {

				// set all preferences
				textWSDType.setText("de.uniwue.kalimachos.coref.type.WSDType");
				textCategoryFeature.setText("Category");
				textPOSType.setText("de.uniwue.kalimachos.coref.type.POS");
				textCandidatesFeature.setText("Candidates");

				textTypeOverride.setText("de.uniwue.kalimachos.coref.type.WSDAlreadyHandled");

			}

			@Override
			public void widgetDefaultSelected(SelectionEvent e) {
				widgetSelected(e);

			}
		});

		textWSDType.setText(ApplicationUtil.getFromPreferences(labelWSDType.getText(), "preference not found"));

		textCategoryFeature.setText(ApplicationUtil.getFromPreferences(labelCategoryFeature.getText(),
				"preference not found"));

		textTypeOverride
				.setText(ApplicationUtil.getFromPreferences(labelTypeOverride.getText(), "preference not found"));

		textPOSType.setText(ApplicationUtil.getFromPreferences(labelPOSType.getText(), "preference not found"));

		textCandidatesFeature.setText(ApplicationUtil.getFromPreferences(labelCandidatesFeature.getText(),
				"preference not found"));

		return parent;
	}

	@Override
	protected void okPressed() {

		// save to the preference map

		// TODO use the string constants instead of the literals
		this.preferences.put(ApplicationPreferences.WSDView_WSD_Type, textWSDType.getText());
		this.preferences.put(ApplicationPreferences.WSDView_WSD_FEATURE, textCategoryFeature.getText());
		this.preferences.put(ApplicationPreferences.WSDView_WSD_OVERRIDE_Type, textTypeOverride.getText());
		this.preferences.put(ApplicationPreferences.WSDView_WSD_POS_Type, textPOSType.getText());
		this.preferences.put(ApplicationPreferences.WSDView_WSD_CANDIDATE_FEATURE, textCandidatesFeature.getText());

		setReturnCode(OK);
		close();
	}

	@Override
	public HashMap<String, String> getPreferences() {

		return this.preferences;
	}

}
