package de.uniwue.mk.medIE.terminology;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class LexikonEntry implements IGotVariations {

	private String name;

	private List<Variation> variations = new ArrayList<Variation>();

	private ELexikonEntryType type;

	public LexikonEntry() {
		super();
	}

	public LexikonEntry(String name, ELexikonEntryType lexikonType, Variation... variations) {

		this.name = name;
		this.variations = new ArrayList<Variation>();
		this.variations.addAll(Arrays.asList(variations));
		this.type = lexikonType;

		for (Variation v : this.variations) {
			v.setLexikon(true);
			v.setEntry(name);
		}

	}
	
	

	public ELexikonEntryType getType() {
		return type;
	}

	public void setType(ELexikonEntryType type) {
		this.type = type;
	}

	public void addEntry(Variation v) {

		this.variations.add(v);
		v.setEntry(name);
		v.setLexikon(true);
	}

	public void removeVariation(Variation v) {
		this.variations.remove(v);

		v.setEntry(null);
		v.setLexikon(true);
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public List<Variation> getVariations() {
		return variations;
	}

	public void setVariations(List<Variation> variations) {
		this.variations = variations;

		for (Variation v : this.variations) {
			v.setLexikon(true);
			v.setEntry(name);
		}
	}

	public List<Variation> getAllVariations() {
		return this.variations;
	}

	public void addVariation(Variation v) {
		v.setLexikon(true);
		addEntry(v);

		v.setEntry(name);

	}

}
