package de.uniwue.mk.medIE.terminology.testMarshal;

import java.io.File;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;

import javax.xml.bind.JAXB;

import de.uniwue.mk.medIE.terminology.Concept;
import de.uniwue.mk.medIE.terminology.MedicalTerminology;

public class MainMarshal {

	public static void main(String[] args) throws Exception {

		MedicalTerminology terminology = new MedicalTerminology(null, "Echo");

		File out = new File("term/terminology.xml");

		// ROOT
		Concept root = new Concept("ROOT", null, null, 0);
		root.setProperty("Synonym", "Wurzel");
		root.setProperty("DATE", Calendar.THURSDAY);
		terminology.setRoot(root);

		// Attribute itself
		List<Concept> attributes = new ArrayList<Concept>();

		for (int i = 0; i < 3; i++) {
			Concept e = new Concept("Brust", root, null, terminology.getNextFreeId());
			attributes.add(e);

		}

		// set children for root
		root.setChildren(attributes);

		JAXB.marshal(terminology, out);

		MedicalTerminology term = JAXB.unmarshal(out, MedicalTerminology.class);

		System.out.println(term.getRoot().getChildren().get(0).getName());

	}
}
