package de.uniwue.mk.medIE.terminologyView;

import org.eclipse.jface.viewers.Viewer;
import org.eclipse.jface.viewers.ViewerFilter;

import de.uniwue.mk.medIE.terminology.Concept;

public class ConceptIdFilter extends ViewerFilter {
	
	private int id;
	
	
	public ConceptIdFilter(int conceptId) {
		id = conceptId;
	}
	

	@Override
	public boolean select(Viewer viewer, Object parentElement, Object element) {
		if (!(element instanceof Concept)) {
			return false;
		}
		Concept concept = (Concept) element;
		// check concept
		if (concept.getId() == id) {
			return true;
		}
		// check predecessors
		Concept parent = concept.getParent();
		while (parent != null) {
			if (parent.getId() == id) {
				return true;
			}
			parent = parent.getParent();
		}
		// check successors
		return concept.getSuccessors().stream().anyMatch(con -> con.getId() == id);
	}

}
