package de.uniwue.mk.medIE.terminologyView;

import java.io.File;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import org.apache.uima.cas.CAS;
import org.eclipse.e4.core.services.events.IEventBroker;
import org.eclipse.jface.dialogs.Dialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Shell;

import de.uniwue.mk.kall.athen.events.IAnnotationEditorEvents;
import de.uniwue.mk.kall.athen.widget.editor.CASEditorInput;
import de.uniwue.mk.medIE.terminologyView.widgets.IBulkTableListener;
import de.uniwue.mk.medIE.terminologyView.widgets.TerminologyApplicationResultComposite;

public class DocumentResultDialog extends Dialog {

	private TerminologyApplicationResultComposite termResult;
	private List<CASEditorInput> list;
	private IEventBroker broker;

	protected DocumentResultDialog(Shell parentShell, Map<File, CAS> workloadMap, IEventBroker broker) {
		super(parentShell);

		list = new ArrayList<CASEditorInput>();
		this.broker = broker;

		for (File f : workloadMap.keySet()) {
			list.add(new CASEditorInput(workloadMap.get(f), f));
		}

	}

	protected Control createDialogArea(Composite parent) {

		parent.getShell().setText("Result of terminology application");

		termResult = new TerminologyApplicationResultComposite(parent, SWT.NONE);
		termResult.setInput(list);

		termResult.addBulkTableListener(new IBulkTableListener() {

			@Override
			public void tableDoubleClicked(CASEditorInput selected) {
				System.out.println("Request document change");
				broker.send(IAnnotationEditorEvents.OPEN_XMI_REQUESTED, selected.getEditorInputFile());
			}
		});

		return parent;

	}

	@Override
	protected void setShellStyle(int newShellStyle) {
		super.setShellStyle(SWT.CLOSE | SWT.MODELESS | SWT.BORDER | SWT.TITLE | SWT.RESIZE);
		setBlockOnOpen(false);
	}

}
