package de.uniwue.mk.medIE.terminologyView;

import org.eclipse.jface.viewers.ITreeContentProvider;
import org.eclipse.jface.viewers.Viewer;

import de.uniwue.mk.medIE.terminology.Concept;
import de.uniwue.mk.medIE.terminology.MedicalTerminology;

public class TerminologyContentProvider implements ITreeContentProvider {

	@Override
	public void dispose() {
		// TODO Auto-generated method stub

	}

	@Override
	public void inputChanged(Viewer viewer, Object oldInput, Object newInput) {
		// TODO Auto-generated method stub

	}

	@Override
	public Object[] getElements(Object inputElement) {

		if (inputElement == null)
			return null;

		if (inputElement instanceof MedicalTerminology) {

			MedicalTerminology term = (MedicalTerminology) inputElement;

			return new Concept[] { term.getRoot() };
		}
		if (inputElement instanceof Concept) {

			Concept concept = (Concept) inputElement;

			if (concept.getChildren() == null || concept.getChildren().size() == 0) {
				return null;
			}

			return new Concept[] { concept.getParent() };
		}

		return null;
	}

	@Override
	public Object[] getChildren(Object parentElement) {

		if (parentElement instanceof Concept) {

			Concept concept = (Concept) parentElement;

			if (concept.getChildren() == null || concept.getChildren().size() == 0)
				return null;

			return concept.getChildren().toArray(new Concept[0]);

		}

		return null;
	}

	@Override
	public Object getParent(Object element) {

		if (element instanceof Concept) {
			return ((Concept) element).getParent();
		}
		return null;
	}

	@Override
	public boolean hasChildren(Object element) {

		if (element instanceof Concept) {

			Concept concept = (Concept) element;

			if (concept.getChildren() == null)
				return false;

			if (concept.getChildren().isEmpty())
				return false;

			return true;

		}

		else {
			return false;
		}
	}
}
