package de.uniwue.mk.medIE.terminologyView;

import org.eclipse.jface.dialogs.Dialog;
import org.eclipse.jface.dialogs.IDialogConstants;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Shell;
import org.osgi.service.event.EventHandler;

import de.uniwue.mk.kall.athen.appDelegation.ui.MasterPart;
import de.uniwue.mk.kall.athen.events.IAnnotationEditorEvents;
import de.uniwue.mk.medIE.terminologyView.widgets.TerminologyTreeView;

public class TerminologyTreeViewDialog extends Dialog {
	private TerminologyView view;
	private int conceptId;
	private EventHandler handler;
	

	public TerminologyTreeViewDialog(Shell parentShell, TerminologyView view, int conceptId) {
		super(parentShell);
		this.view = view;
		this.conceptId = conceptId;
	}

	
	@Override
	protected Control createDialogArea(Composite parent) {
		
		TerminologyTreeView treeView = view.createTerminologyTreeView(parent);
		treeView.filterConceptById(Integer.valueOf(conceptId));
		treeView.getViewer().expandAll();
		
		handler = event -> treeView.reloadTree();
		MasterPart.subscribeForEvent(getClass(), 
				IAnnotationEditorEvents.TERMINOLOGY_NODE_ATTRIBUTE_CHANGED,
				handler);
		
		return parent;
	}
	
	@Override
	protected void createButtonsForButtonBar(Composite parent) {
		Button bt = createButton(parent, IDialogConstants.CLOSE_ID, IDialogConstants.CLOSE_LABEL, true);
		bt.addSelectionListener(new SelectionListener() {

			@Override
			public void widgetSelected(SelectionEvent e) {
				close();
			}

			@Override
			public void widgetDefaultSelected(SelectionEvent e) {
				close();
			}
			
		});
	}
	
	@Override
	public boolean close() {
		MasterPart.unsubscribeFromEvent(getClass(), 
				IAnnotationEditorEvents.TERMINOLOGY_NODE_ATTRIBUTE_CHANGED, 
				handler);
		return super.close();
	}
}
