package de.uniwue.mk.medIE.terminologyView.menu.actions;

import org.eclipse.e4.core.services.events.IEventBroker;
import org.eclipse.jface.action.Action;

import de.uniwue.mk.kall.athen.events.IAnnotationEditorEvents;
import de.uniwue.mk.kall.athen.widget.editor.AnnotationEditorWidget;
import de.uniwue.mk.medIE.terminology.Concept;
import de.uniwue.mk.medIE.terminology.MedicalTerminology;

public class AddNegationAction extends Action {

	IEventBroker broker;
	private Concept concept;
	private AnnotationEditorWidget editor;
	private MedicalTerminology terminology;

	public AddNegationAction(IEventBroker broker, AnnotationEditorWidget editor, Concept selectedConcept,
			MedicalTerminology terminology) {
		super("Add Negation");
		this.broker = broker;
		this.editor = editor;
		this.concept = selectedConcept;
		this.terminology = terminology;
	}

	@Override
	public void run() {

		// apply

		Concept child = new Concept("Kein", concept, null, terminology.getNextFreeId());
		concept.addChild(child);

		// add the negation reference
		child.addReference(terminology.getLexikon().getEntryByLexikonName("Negation"));

		broker.send(IAnnotationEditorEvents.TERMINOLOGY_NODE_ATTRIBUTE_CHANGED, concept);

	}

}
