package de.uniwue.mk.medIE.terminologyView.menu.actions;

import org.eclipse.e4.core.services.events.IEventBroker;
import org.eclipse.jface.action.Action;

import de.uniwue.mk.kall.athen.widget.editor.AnnotationEditorWidget;
import de.uniwue.mk.medIE.terminology.Concept;
import de.uniwue.mk.medIE.terminology.ELexikonEntryType;
import de.uniwue.mk.medIE.terminology.LexikonEntry;
import de.uniwue.mk.medIE.terminology.MedicalTerminology;
import de.uniwue.mk.medIE.terminology.Variation;

public class ConvertConceptToDictionaryAction extends Action {

	IEventBroker broker;
	private Concept concept;
	private AnnotationEditorWidget editor;
	private MedicalTerminology terminology;

	public ConvertConceptToDictionaryAction(IEventBroker broker, AnnotationEditorWidget editor, Concept concept,
			MedicalTerminology terminology) {
		super("Convert To Dictionary");
		this.broker = broker;
		this.editor = editor;
		this.concept = concept;
		this.terminology = terminology;
	}

	@Override
	public void run() {

		LexikonEntry entryByLexikonName = terminology.getLexikon().getEntryByLexikonName(concept.getName());

		if (entryByLexikonName == null) {

			LexikonEntry entry = new LexikonEntry(concept.getName(), ELexikonEntryType.DICTIONARY, concept
					.getAllVariations().toArray(new Variation[0]));
			entry.addEntry(new Variation(concept.getName()));

			terminology.getLexikon().addEntry(entry);

		}

		else {

			for (Variation v : concept.getAllVariations()) {
				entryByLexikonName.addEntry(v);
				entryByLexikonName.addEntry(new Variation(concept.getName()));
			}
		}
	}
}
