package de.uniwue.mk.medIE.terminologyView.menu.actions;

import java.util.ArrayList;
import java.util.List;

import org.apache.uima.cas.Type;
import org.apache.uima.cas.text.AnnotationFS;
import org.eclipse.e4.core.services.events.IEventBroker;
import org.eclipse.jface.action.Action;

import de.uniwue.mk.kall.athen.events.IAnnotationEditorEvents;
import de.uniwue.mk.kall.athen.widget.editor.AnnotationEditorWidget;
import de.uniwue.mk.medIE.terminology.Concept;

public class DeselectConceptAction extends Action {

	IEventBroker broker;
	private Concept concept;
	private AnnotationEditorWidget editor;
	private Type typeTempAttributes;
	private Type typeHighlight;

	public DeselectConceptAction(IEventBroker broker, AnnotationEditorWidget editor, Concept selectedConcept,
			Type typeHighlightAction, Type typeTempAttributes) {
		super("Deselect Segments");
		this.broker = broker;
		this.editor = editor;
		this.concept = selectedConcept;
		this.typeTempAttributes = typeTempAttributes;
		this.typeHighlight = typeHighlightAction;

	}

	@Override
	public void run() {

		deleteTemporaryTypes();
		concept.setProperty("CONCEPT_HIGHLIGHT", "FALSE");

		broker.send(IAnnotationEditorEvents.TERMINOLOGY_NODE_ATTRIBUTE_CHANGED, concept);
	}

	private void deleteTemporaryTypes() {
		// delete quietly

		List<AnnotationFS> toDelete = new ArrayList<AnnotationFS>();

		for (AnnotationFS temp : editor.getCas().getAnnotationIndex(typeHighlight)) {
			toDelete.add(temp);
		}

		for (AnnotationFS temp : editor.getCas().getAnnotationIndex(typeTempAttributes)) {
			toDelete.add(temp);
		}

		for (AnnotationFS del : toDelete)
			editor.getCas().removeFsFromIndexes(del);

		if (!toDelete.isEmpty()) {
			editor.removeAnnotation(toDelete.get(0));
		}

	}

}
