package de.uniwue.mk.medIE.terminologyView.menu.actions;

import org.eclipse.e4.core.services.events.IEventBroker;
import org.eclipse.jface.action.Action;

import de.uniwue.mk.kall.athen.events.IAnnotationEditorEvents;
import de.uniwue.mk.medIE.terminology.Concept;
import de.uniwue.mk.medIE.terminology.MedicalTerminology;

public class DuplicateNodeAction extends Action {

	IEventBroker broker;
	private Concept concept;
	private MedicalTerminology terminology;
	private int nextId;

	public DuplicateNodeAction(IEventBroker broker, Concept selectedConcept, MedicalTerminology terminology) {
		super("Duplicate Node");
		this.broker = broker;
		this.concept = selectedConcept;
		this.terminology = terminology;
	}

	@Override
	public void run() {
		if (concept.getParent() == null) {
			return;
		}
		// use the copy constructor to clone the concept
		Concept clonedConcept = new Concept(concept);
		concept.getParent().addChild(clonedConcept);
		// set IDs (not done in the constructor)
		nextId = terminology.getNextFreeId();
		setIdForConceptAndChildren(clonedConcept);
		// refresh the view
		broker.send(IAnnotationEditorEvents.TERMINOLOGY_NODE_ATTRIBUTE_CHANGED, concept.getParent());
	}

	private void setIdForConceptAndChildren(Concept concept) {
		concept.setId(nextId++);
		concept.getChildren().forEach(child -> setIdForConceptAndChildren(child));
	}
}
