package de.uniwue.mk.medIE.terminologyView.menu.actions;

import org.eclipse.e4.core.services.events.IEventBroker;
import org.eclipse.jface.action.Action;
import org.eclipse.swt.widgets.Tree;

public class TooltipDisplayOptionsAction extends Action {

	private IEventBroker broker;
	private Tree tree;

	public static final String TREE_TOOLTIP_OPTION = "TREE_TOOLTIP_OPTION";
	public static final String TREE_TOOLTIP_FULL = "TREE_TOOLTIP_FULL";
	public static final String TREE_TOOLTIP_FLAT = "TREE_TOOLTIP_FLAT";

	public String treeTooltipOption;

	public TooltipDisplayOptionsAction(IEventBroker broker, Tree tree) {
		this.broker = broker;
		this.tree = tree;

		this.treeTooltipOption = (String) tree.getData(TREE_TOOLTIP_OPTION);

		if (treeTooltipOption.equals(TREE_TOOLTIP_FLAT)) {
			setText("Show full Tooltip");
		}

		else {
			setText("ShowJustConcept");
		}
	}

	@Override
	public void run() {

		if (treeTooltipOption.equals(TREE_TOOLTIP_FLAT)) {
			tree.setData(TREE_TOOLTIP_OPTION, TREE_TOOLTIP_FULL);
		}

		else {
			tree.setData(TREE_TOOLTIP_OPTION, TREE_TOOLTIP_FLAT);
		}
	}
}
