package de.uniwue.mk.medIE.terminologyView.widgets;

import org.eclipse.jface.viewers.CellEditor;
import org.eclipse.jface.viewers.EditingSupport;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.jface.viewers.TextCellEditor;

import de.uniwue.mk.medIE.terminology.Variation;

public class VariationNameEditingSupport extends EditingSupport {

	public VariationNameEditingSupport(final TableViewer viewer) {
		super(viewer);
		this.viewer = viewer;
		this.editor = new TextCellEditor(viewer.getTable());
	}

	private final TableViewer viewer;
	private final CellEditor editor;

	@Override
	protected CellEditor getCellEditor(Object element) {
		return editor;
	}

	@Override
	protected boolean canEdit(Object element) {
		return true;
	}

	@Override
	protected Object getValue(Object element) {
		return ((Variation) element).getSynonym();
	}

	@Override
	protected void setValue(Object element, Object userInputValue) {
		((Variation) element).setSynonym(String.valueOf(userInputValue));
		viewer.update(element, null);
	}

}
