package de.uniwue.mkrug.kallimachos.annotation.editor.ui;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

import javax.annotation.PostConstruct;
import javax.annotation.PreDestroy;
import javax.inject.Inject;

import org.apache.uima.cas.CAS;
import org.apache.uima.cas.CASException;
import org.apache.uima.cas.Feature;
import org.apache.uima.cas.Type;
import org.apache.uima.cas.impl.ArrayFSImpl;
import org.apache.uima.cas.text.AnnotationFS;
import org.apache.uima.cas.text.AnnotationIndex;
import org.eclipse.e4.core.services.events.IEventBroker;
import org.eclipse.e4.ui.di.Focus;
import org.eclipse.e4.ui.di.Persist;
import org.eclipse.e4.ui.model.application.ui.basic.MPart;
import org.eclipse.e4.ui.workbench.modeling.EModelService;
import org.eclipse.e4.ui.workbench.modeling.EPartService;
import org.eclipse.jface.bindings.keys.KeyStroke;
import org.eclipse.jface.fieldassist.ContentProposalAdapter;
import org.eclipse.jface.fieldassist.SimpleContentProposalProvider;
import org.eclipse.jface.fieldassist.TextContentAdapter;
import org.eclipse.jface.viewers.ArrayContentProvider;
import org.eclipse.jface.viewers.ColumnLabelProvider;
import org.eclipse.jface.viewers.ColumnViewerToolTipSupport;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.jface.viewers.TableViewerColumn;
import org.eclipse.jface.viewers.ViewerCell;
import org.eclipse.jface.window.ToolTip;
import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.StyleRange;
import org.eclipse.swt.events.KeyAdapter;
import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.events.KeyListener;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.RGB;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.MenuItem;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.Text;

import de.uniwue.kalimachos.coref.editor.drawingstructure.AnnoStyle;
import de.uniwue.kalimachos.coref.paintingStrategies.BackgroundDrawingStrategy;
import de.uniwue.kalimachos.coref.paintingStrategies.OvalDrawingStrategy;
import de.uniwue.mk.kall.athen.appDelegation.util.ApplicationUtil;
import de.uniwue.mk.kall.athen.attributeAcceptingView.widgets.ColViewerComparatorAttributeView;
import de.uniwue.mk.kall.athen.attributeAcceptingView.widgets.ColViewerComparatorAttributeViewPersonTable;
import de.uniwue.mk.kall.athen.attributeAcceptingView.widgets.FrameFilterAttViewPersonTable;
import de.uniwue.mk.kall.athen.part.editor.NameFilter;
import de.uniwue.mk.kall.athen.part.editor.subordinate.AEditorSubordinateViewPart;
import de.uniwue.mk.kall.athen.widget.editor.AnnotationEditorWidget;
import de.uniwue.mk.kall.editorPainting.paintingstrategies.specialized.NamedEntityDrawingStrategy;

public class DSAnnotatingView extends AEditorSubordinateViewPart {

	static String viewId = "de.uniwue.mkrug.kallimachos.annotation.editor.part.14";

	private static Class<?> CLASS_THIS = DSAnnotatingView.class;

	@Inject
	static EPartService partService;

	// WIDGETS
	private Color black;

	private Color red;

	private Color green;

	private Color white;
	private Color dsOne;
	private Color dsTwo;

	private Color blue;

	// this table displays all persons
	private TableViewer viewer;

	private NameFilter filter;
	private FrameFilterAttViewPersonTable frameFilter;

	private List<AnnotationFS> annoListPersons;

	// last selected Attribute
	private AnnotationFS actualSelected;

	private String tempContextS = "de.uniwue.kalimachos.coref.type.temp2";
	private Type typeTempContextDS;
	private String speaker = "de.uniwue.kalimachos.coref.type.temp3";
	private String spokenTo = "de.uniwue.kalimachos.coref.type.temp6";
	// used for ds
	private String temptypeDSBegEnd = "de.uniwue.kalimachos.coref.type.temp4";
	private String temptypeDSBegEnd2 = "de.uniwue.kalimachos.coref.type.temp5";

	private String type;

	// E4 DI OBJECTS
	@Inject
	static IEventBroker broker;

	@Inject
	EModelService modelService;

	public Button getJumpButton() {
		return jumpButton;
	}

	public void setJumpButton(Button jumpButton) {
		this.jumpButton = jumpButton;
	}

	private Type typOverride;
	private Type neType;
	private Type typ;
	private Type dSBegEndType;

	private Type dsType;

	private Type dSBegEndType2;

	private Type speakerType;
	private Type spokenToType;

	private Type dsContextType;
	private Feature dsContextCategory;
	private Feature dsContextDs;

	private Feature attNEFeature;
	private Feature neId;

	// compounds

	private Text neuEnt;

	// needed to sort the tables
	private ColViewerComparatorAttributeViewPersonTable colViewerComp;
	private ColViewerComparatorAttributeView colViewerAttView;

	private Text oldEnt;

	private Button box;
	private Button buttonNewContext;
	private Button buttondeleteContext;
	private Text textCategoryContext;
	private Button buttonUpdateContextcategory;

	private MPart part;

	Button jumpButton;

	private Point lastClick = null;

	private Button idButton;
	private Label frameFilterLabel;
	private Button frameFilterButton;

	private String text;

	// initial it is selected
	private boolean isPersonTableSelected = false;

	private Point actualTextSelection;
	private List<Point> preceedingTextSelections;

	// Images for buttons
	private Image personImage;
	private Image atributeImage;

	// Eventhandler - so many of them :(

	private Feature speakerFeature;
	private Feature speakerArrayFeature;

	private Feature spokenToFeature;
	private Feature spokenToArrayFeature;

	private boolean controlPressed;

	private Feature dsCategoryfeature;

	private Text textCategory;

	private Feature unknownSpeakerFeature;

	private Feature unknownSpokenToFeature;

	private Button buttonUnknownSpeaker;

	private Button buttonUnknownSpokenTo;

	private Color dsContext;

	@Inject
	public DSAnnotatingView() {
		super();
		super.viewId = viewId;
		super.class_this = CLASS_THIS;
	}

	@PostConstruct
	public void postConstruct(Composite parent) {

		super.overlay = parent;
		super.part = partService.findPart(viewId);
		super.partService = partService;

		// this is important since in the struct the broker is not injected
		// yet!!
		super.setBroker(broker);
	}

	private void copyDatastructures() {

		for (AnnotationFS ds : editor.getCas().getAnnotationIndex(typ)) {

			ArrayFSImpl speakerArray = (ArrayFSImpl) ds.getFeatureValue(speakerArrayFeature);
			ArrayFSImpl spokenToArray = (ArrayFSImpl) ds.getFeatureValue(spokenToArrayFeature);

			if (speakerArray == null || speakerArray.size() == 0) {

				// get the speaker feature and if that one isnt null we can add
				// it to the arrays
				AnnotationFS speaker = (AnnotationFS) ds.getFeatureValue(speakerFeature);

				if (speaker != null) {
					ArrayFSImpl arrayNew = (ArrayFSImpl) editor.getCas().createArrayFS(1);

					arrayNew.set(0, speaker);

					ds.setFeatureValue(speakerArrayFeature, arrayNew);

				}
			}

			if (spokenToArray == null || spokenToArray.size() == 0) {

				// get the speaker feature and if that one isnt null we can add
				// it to the arrays
				AnnotationFS spokenTo = (AnnotationFS) ds.getFeatureValue(spokenToFeature);

				if (spokenTo != null) {
					ArrayFSImpl arrayNew = (ArrayFSImpl) editor.getCas().createArrayFS(1);

					arrayNew.set(0, spokenTo);

					ds.setFeatureValue(spokenToArrayFeature, arrayNew);

				}
			}

		}

	}

	@Override
	public boolean initTypes() {

		black = new Color(overlay.getDisplay(), new RGB(0, 0, 0));
		red = new Color(overlay.getDisplay(), new RGB(255, 0, 0));
		green = new Color(overlay.getDisplay(), new RGB(39, 176, 87));
		white = new Color(overlay.getDisplay(), new RGB(255, 255, 255));
		blue = new Color(overlay.getDisplay(), new RGB(17, 103, 194));
		dsOne = new Color(overlay.getDisplay(), new RGB(209, 205, 212));
		dsTwo = new Color(overlay.getDisplay(), new RGB(178, 174, 181));
		dsContext = new Color(overlay.getDisplay(), new RGB(234, 247, 113));

		// gettypes

		// TODO this whole view has no preferences
		this.typ = editor.getCas().getTypeSystem().getType("de.uniwue.kalimachos.coref.type.DirectSpeech");
		this.neType = editor.getCas().getTypeSystem().getType("de.uniwue.kalimachos.coref.type.NamedEntity");
		this.dSBegEndType = editor.getCas().getTypeSystem().getType(temptypeDSBegEnd);
		this.dSBegEndType2 = editor.getCas().getTypeSystem().getType(temptypeDSBegEnd2);
		this.typeTempContextDS = editor.getCas().getTypeSystem().getType(tempContextS);
		this.speakerType = editor.getCas().getTypeSystem().getType(speaker);
		this.spokenToType = editor.getCas().getTypeSystem().getType(spokenTo);
		this.dsContextType = editor.getCas().getTypeSystem()
				.getType("de.uniwue.kalimachos.coref.type.DirectSpeechContext");

		annotateDstempType();

		this.editor.allStylesInvisible();

		// get Features of NE Type
		neId = neType.getFeatureByBaseName("ID");
		this.speakerFeature = typ.getFeatureByBaseName("Speaker");
		this.spokenToFeature = typ.getFeatureByBaseName("SpokenTo");
		this.spokenToArrayFeature = typ.getFeatureByBaseName("SpokenToArray");
		this.speakerArrayFeature = typ.getFeatureByBaseName("SpeakerArray");
		this.dsCategoryfeature = typ.getFeatureByBaseName("Category");
		this.unknownSpeakerFeature = typ.getFeatureByBaseName("UnknownSpeaker");
		this.unknownSpokenToFeature = typ.getFeatureByBaseName("UnknownSpokenTo");
		this.dsContextCategory = dsContextType.getFeatureByBaseName("Context");
		this.dsContextDs = dsContextType.getFeatureByBaseName("DirectSpeech");

		// Attribute features

		editor.changeVisibility(neType, true);
		editor.changeVisibility(dSBegEndType, true);
		editor.changeVisibility(dSBegEndType2, true);
		editor.changeVisibility(speakerType, true);
		editor.changeVisibility(spokenToType, true);
		editor.changeVisibility(typeTempContextDS, true);

		// layer

		editor.changeLayer(typ, 2);
		editor.changeLayer(dSBegEndType, 2);
		editor.changeLayer(dSBegEndType2, 2);
		editor.changeLayer(neType, 2);
		editor.changeLayer(dsContextType, 1);

		// style of neType
		StyleRange rangeTypNE = new StyleRange();
		rangeTypNE.background = green;
		AnnoStyle styleNE = new AnnoStyle(new NamedEntityDrawingStrategy(rangeTypNE, neId.getShortName(), null, null,
				null, null, null), rangeTypNE);

		StyleRange rangeTyp5 = new StyleRange();
		rangeTyp5.background = dsOne;

		AnnoStyle style5 = new AnnoStyle(new BackgroundDrawingStrategy(rangeTyp5), rangeTyp5);

		StyleRange rangeTyp6 = new StyleRange();
		rangeTyp6.background = dsTwo;

		AnnoStyle style6 = new AnnoStyle(new BackgroundDrawingStrategy(rangeTyp6), rangeTyp6);

		// ds style

		// ds contextype
		StyleRange rangeTypContextType = new StyleRange();
		rangeTypContextType.background = dsContext;

		AnnoStyle stylerangeTypContextType = new AnnoStyle(new BackgroundDrawingStrategy(rangeTypContextType),
				rangeTypContextType);

		// speaker
		StyleRange rangeTypSpeaker = new StyleRange();
		rangeTypSpeaker.background = red;

		AnnoStyle styleSpeaker = new AnnoStyle(new OvalDrawingStrategy(rangeTypSpeaker), rangeTypSpeaker);

		// spokenTo
		StyleRange rangeTypSpokenTo = new StyleRange();
		rangeTypSpokenTo.background = blue;

		AnnoStyle styleSpokenTo = new AnnoStyle(new OvalDrawingStrategy(rangeTypSpokenTo), rangeTypSpokenTo);

		// apply
		editor.changeStyle(neType, styleNE);
		editor.changeStyle(speakerType, styleSpeaker);
		editor.changeStyle(spokenToType, styleSpokenTo);
		editor.changeStyle(dSBegEndType, style5);
		editor.changeStyle(dSBegEndType2, style6);
		editor.changeStyle(typeTempContextDS, stylerangeTypContextType);

		// also change the modus
		editor.setActiveMode(typ);

		return true;

	}

	private void annotateDstempType() {

		if (dSBegEndType == null) {
			return;
		}

		// step 1 delete all old ones

		List<AnnotationFS> toDelete = new ArrayList<AnnotationFS>();

		for (AnnotationFS a : editor.getCas().getAnnotationIndex(dSBegEndType)) {
			toDelete.add(a);
		}

		for (AnnotationFS a : editor.getCas().getAnnotationIndex(dSBegEndType2)) {
			toDelete.add(a);
		}

		for (AnnotationFS a : toDelete) {
			editor.getCas().removeFsFromIndexes(a);
		}

		// step 2 create new ones with the temptypes

		int index = 0;
		for (AnnotationFS a : editor.getCas().getAnnotationIndex(typ)) {

			if (index % 2 == 0) {
				AnnotationFS createAnnotation = editor.getCas()
						.createAnnotation(dSBegEndType, a.getBegin(), a.getEnd());

				editor.getCas().addFsToIndexes(createAnnotation);
			}

			else {

				AnnotationFS createAnnotation = editor.getCas().createAnnotation(dSBegEndType2, a.getBegin(),
						a.getEnd());

				editor.getCas().addFsToIndexes(createAnnotation);
			}

			index++;
		}

	}

	@Override
	protected void initLayout(Composite parent) {
		// this.overlay = new Composite(parent, SWT.NONE);

		GridLayout layout = new GridLayout();
		layout.horizontalSpacing = 5;
		layout.numColumns = 2;
		layout.verticalSpacing = 5;
		layout.marginWidth = 5;
		layout.marginHeight = 5;
		overlay.setLayout(layout);

		// / ==== Buttons + Fields

		Composite comp2 = new Composite(overlay, SWT.BORDER);
		comp2.setVisible(true);
		GridLayout gdd = new GridLayout();
		GridData gridData2 = new GridData();
		gridData2.horizontalSpan = 2;
		gridData2.grabExcessHorizontalSpace = true;
		// gridData2.grabExcessVerticalSpace = true;
		gridData2.horizontalAlignment = GridData.FILL;
		comp2.setLayout(gdd);
		comp2.setLayoutData(gridData2);

		// Label actions = new Label(comp2, SWT.NULL);
		// actions.setText("Actions");
		// Composite comp = new Composite(overlay, SWT.BORDER);
		// comp.setVisible(true);

		GridLayout gridBelow = new GridLayout(2, false);
		comp2.setLayout(gridBelow);
		Button newEntity = new Button(comp2, SWT.NONE);
		newEntity.setText("New Direct Speech:");
		newEntity.addSelectionListener(new SelectionListener() {

			@Override
			public void widgetSelected(SelectionEvent e) {
				// adds an attribute with null NE feature
				AnnotationFS selected = null;
				if (editor.getCurrentSelectionOfType(typ).size() > 0) {
					for (AnnotationFS anno : editor.getCurrentSelectionOfType(typ)) {
						if (anno.getType().equals(typ)) {
							selected = anno;

						}
					}
				}

				// remove vorschlag
				CAS cas = editor.getCas();
				// get the selection

				if (selected == null) {

					Point selection = editor.getActualSelectedText();
					AnnotationFS anno = cas.createAnnotation(typ, selection.x, selection.y);

					addAnnotation(anno);

				}

				else if (selected != null && editor.getActualSelectedText().x <= selected.getBegin()
						&& editor.getActualSelectedText().y >= selected.getEnd()) {
					Point selection = editor.getActualSelectedText();
					AnnotationFS anno = cas.createAnnotation(typ, selection.x, selection.y);

					addAnnotation(anno);
				}

			}

			@Override
			public void widgetDefaultSelected(SelectionEvent e) {

				widgetSelected(e);

			}
		});
		// listener

		this.neuEnt = new Text(comp2, SWT.BORDER);
		neuEnt.setText("Mark some Text and press \"new\"");
		neuEnt.setLayoutData(new GridData(GridData.GRAB_HORIZONTAL | GridData.HORIZONTAL_ALIGN_FILL));

		Button noEntity = new Button(comp2, SWT.NONE);
		noEntity.setText("No Direct Speech");
		noEntity.addSelectionListener(new SelectionListener() {

			@Override
			public void widgetSelected(SelectionEvent e) {

				AnnotationFS selected = null;
				if (editor.getCurrentSelectionOfType(typ).size() > 0) {
					for (AnnotationFS anno : editor.getCurrentSelectionOfType(typ)) {
						if (anno.getType().equals(typ)) {
							selected = anno;

						}
					}
				}

				// get boolean of box
				if (box.getSelection()) {

					// we delete all

				}

				else {
					// we delete only the one
					if (selected != null) {

						deleteAnnotation(selected);

					}
				}

			}

			@Override
			public void widgetDefaultSelected(SelectionEvent e) {

				widgetSelected(e);

			}
		});

		box = new Button(comp2, SWT.CHECK);
		box.setText("Delete All");

		// buttons to delete features
		Button buttonDeleteSpeaker = new Button(comp2, SWT.PUSH);
		buttonDeleteSpeaker.setText("Delete Speaker");

		buttonDeleteSpeaker.addSelectionListener(new SelectionListener() {

			@Override
			public void widgetSelected(SelectionEvent e) {

				AnnotationFS selected = null;
				if (editor.getCurrentSelectionOfType(typ).size() > 0) {
					for (AnnotationFS anno : editor.getCurrentSelectionOfType(typ)) {
						if (anno.getType().equals(typ)) {
							selected = anno;

						}
					}
				}

				if (selected != null) {

					selected.setFeatureValue(speakerArrayFeature, null);
					selected.setFeatureValue(speakerFeature, null);

					editor.changeAnnotation(selected);

				}

			}

			@Override
			public void widgetDefaultSelected(SelectionEvent e) {
				widgetSelected(e);

			}
		});

		Button buttonDeleteSpokenTo = new Button(comp2, SWT.PUSH);
		buttonDeleteSpokenTo.setText("Delete SpokenTo");

		buttonDeleteSpokenTo.addSelectionListener(new SelectionListener() {

			@Override
			public void widgetSelected(SelectionEvent e) {

				AnnotationFS selected = null;
				if (editor.getCurrentSelectionOfType(typ).size() > 0) {
					for (AnnotationFS anno : editor.getCurrentSelectionOfType(typ)) {
						if (anno.getType().equals(typ)) {
							selected = anno;

						}
					}
				}

				if (selected != null) {

					selected.setFeatureValue(spokenToArrayFeature, null);
					selected.setFeatureValue(spokenToFeature, null);
					editor.changeAnnotation(selected);
				}

			}

			@Override
			public void widgetDefaultSelected(SelectionEvent e) {
				widgetSelected(e);

			}
		});

		buttonUnknownSpeaker = new Button(comp2, SWT.CHECK);
		buttonUnknownSpeaker.setText("Unknown Speaker");

		buttonUnknownSpokenTo = new Button(comp2, SWT.CHECK);
		buttonUnknownSpokenTo.setText("Unknown SpokenTo");

		buttonUnknownSpeaker.addSelectionListener(new SelectionListener() {

			@Override
			public void widgetSelected(SelectionEvent e) {
				AnnotationFS selected = null;
				if (editor.getCurrentSelectionOfType(typ).size() > 0) {
					for (AnnotationFS anno : editor.getCurrentSelectionOfType(typ)) {
						if (anno.getType().equals(typ)) {
							selected = anno;

						}
					}
				}

				if (selected != null) {

					if (buttonUnknownSpeaker.getSelection()) {

						selected.setFeatureValueFromString(unknownSpeakerFeature, "true");

					}

					else {
						selected.setFeatureValueFromString(unknownSpeakerFeature, "false");
					}

				}

			}

			@Override
			public void widgetDefaultSelected(SelectionEvent e) {
				widgetSelected(e);

			}
		});

		buttonUnknownSpokenTo.addSelectionListener(new SelectionListener() {

			@Override
			public void widgetSelected(SelectionEvent e) {
				AnnotationFS selected = null;
				if (editor.getCurrentSelectionOfType(typ).size() > 0) {
					for (AnnotationFS anno : editor.getCurrentSelectionOfType(typ)) {
						if (anno.getType().equals(typ)) {
							selected = anno;

						}
					}
				}

				if (selected != null) {

					if (buttonUnknownSpokenTo.getSelection()) {

						selected.setFeatureValueFromString(unknownSpokenToFeature, "true");

					}

					else {
						selected.setFeatureValueFromString(unknownSpokenToFeature, "false");
					}

				}

			}

			@Override
			public void widgetDefaultSelected(SelectionEvent e) {
				widgetSelected(e);

			}
		});

		Composite compTextCat = new Composite(comp2, SWT.BORDER);
		GridData dataTextCat = new GridData(GridData.GRAB_HORIZONTAL | GridData.HORIZONTAL_ALIGN_FILL);
		dataTextCat.horizontalSpan = 2;
		compTextCat.setLayoutData(dataTextCat);

		compTextCat.setLayout(new GridLayout(3, false));

		Label labelCategory = new Label(compTextCat, SWT.NONE);
		labelCategory.setText("Category: ");
		Button buttonUpdateCategory = new Button(compTextCat, SWT.PUSH);
		buttonUpdateCategory.setText("Update");

		buttonUpdateCategory.addSelectionListener(new SelectionListener() {

			@Override
			public void widgetSelected(SelectionEvent e) {

				// update the feature of the selected DS

				AnnotationFS selected = null;
				if (editor.getCurrentSelectionOfType(typ).size() > 0) {
					for (AnnotationFS anno : editor.getCurrentSelectionOfType(typ)) {
						if (anno.getType().equals(typ)) {
							selected = anno;

						}
					}
				}

				if (selected != null) {

					selected.setFeatureValueFromString(dsCategoryfeature, textCategory.getText());
				}

			}

			@Override
			public void widgetDefaultSelected(SelectionEvent e) {
				widgetSelected(e);
			}
		});

		textCategory = new Text(compTextCat, SWT.BORDER);
		textCategory.setLayoutData(new GridData(GridData.GRAB_HORIZONTAL | GridData.HORIZONTAL_ALIGN_FILL));

		textCategory.addKeyListener(new KeyAdapter() {

			private String KEY_PRESS = "Ctrl+Space";

			public void keyReleased(KeyEvent ke) {
				// Method for autocompletion
				setAutoCompletion(textCategory, textCategory.getText());
			}

			private void setAutoCompletion(Text text, String value) {
				try {
					ContentProposalAdapter adapter = null;
					String[] defaultProposals = getAllProposals(value);
					SimpleContentProposalProvider scp = new SimpleContentProposalProvider(defaultProposals);
					scp.setProposals(defaultProposals);
					KeyStroke ks = KeyStroke.getInstance(KEY_PRESS);
					adapter = new ContentProposalAdapter(text, new TextContentAdapter(), scp, ks, null);
					adapter.setProposalAcceptanceStyle(ContentProposalAdapter.PROPOSAL_REPLACE);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}

			private String[] getAllProposals(String text) {
				String[] proposals = new String[5];
				if (text == null || text.length() == 0) {

					Set<String> candidates = new HashSet<String>();

					for (AnnotationFS ds : editor.getCas().getAnnotationIndex(typ)) {

						String dsCat = ds.getFeatureValueAsString(dsCategoryfeature);

						if (dsCat != null)
							candidates.add(dsCat);
					}

					proposals = candidates.toArray(new String[0]);

				}

				else {

					Set<String> candidates = new HashSet<String>();

					for (AnnotationFS ds : editor.getCas().getAnnotationIndex(typ)) {

						String dsCat = ds.getFeatureValueAsString(dsCategoryfeature);

						if (dsCat != null && dsCat.startsWith(text))
							candidates.add(dsCat);
					}

					proposals = candidates.toArray(new String[0]);
				}
				return proposals;
			}

		});

		// contexttype

		Label labelCategoryContext = new Label(compTextCat, SWT.NONE);
		labelCategoryContext.setText("ContextCategory: ");
		buttonUpdateContextcategory = new Button(compTextCat, SWT.PUSH);
		buttonUpdateContextcategory.setText("Update");

		buttonUpdateContextcategory.addSelectionListener(new SelectionListener() {

			@Override
			public void widgetSelected(SelectionEvent e) {

				// update the feature of the selected DS

				AnnotationFS selected = null;

				for (AnnotationFS context : editor.getCas().getAnnotationIndex(dsContextType)) {

					if (context.getBegin() <= editor.getWidget().getSelection().x
							&& context.getEnd() >= editor.getWidget().getSelection().y) {
						selected = context;
						break;
					}
				}
				if (selected != null) {

					selected.setFeatureValueFromString(dsContextCategory, textCategoryContext.getText());
				}

			}

			@Override
			public void widgetDefaultSelected(SelectionEvent e) {
				widgetSelected(e);
			}
		});

		textCategoryContext = new Text(compTextCat, SWT.BORDER);
		textCategoryContext.setLayoutData(new GridData(GridData.GRAB_HORIZONTAL | GridData.HORIZONTAL_ALIGN_FILL));

		textCategoryContext.addKeyListener(new KeyAdapter() {

			private String KEY_PRESS = "Ctrl+Space";

			public void keyReleased(KeyEvent ke) {
				// Method for autocompletion
				setAutoCompletion(textCategoryContext, textCategoryContext.getText());
			}

			private void setAutoCompletion(Text text, String value) {
				try {
					ContentProposalAdapter adapter = null;
					String[] defaultProposals = getAllProposals(value);
					SimpleContentProposalProvider scp = new SimpleContentProposalProvider(defaultProposals);
					scp.setProposals(defaultProposals);
					KeyStroke ks = KeyStroke.getInstance(KEY_PRESS);
					adapter = new ContentProposalAdapter(text, new TextContentAdapter(), scp, ks, null);
					adapter.setProposalAcceptanceStyle(ContentProposalAdapter.PROPOSAL_REPLACE);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}

			private String[] getAllProposals(String text) {
				String[] proposals = new String[5];
				if (text == null || text.length() == 0) {

					Set<String> candidates = new HashSet<String>();

					for (AnnotationFS ds : editor.getCas().getAnnotationIndex(dsContextType)) {

						String dsCat = ds.getFeatureValueAsString(dsContextCategory);

						if (dsCat != null)
							candidates.add(dsCat);
					}

					proposals = candidates.toArray(new String[0]);

				}

				else {

					Set<String> candidates = new HashSet<String>();

					for (AnnotationFS ds : editor.getCas().getAnnotationIndex(typ)) {

						String dsCat = ds.getFeatureValueAsString(dsContextCategory);

						if (dsCat != null && dsCat.startsWith(text))
							candidates.add(dsCat);
					}

					proposals = candidates.toArray(new String[0]);
				}
				return proposals;
			}

		});

		// Context !!!

		buttonNewContext = new Button(comp2, SWT.PUSH);
		buttonNewContext.setText("New Context");
		buttonNewContext.addSelectionListener(new SelectionListener() {

			@Override
			public void widgetSelected(SelectionEvent e) {

				Point selection = editor.getActualSelectedText();

				if (selection == null)
					return;
				else if (selection.y - selection.x == 0)
					return;

				// find the directSpeech anno
				for (AnnotationFS ds : editor.getCas().getAnnotationIndex(typ)) {

					if (selection.y > ds.getBegin() && selection.x < ds.getBegin()) {

						AnnotationFS fs = editor.getCas().createAnnotation(dsContextType, selection.x, ds.getEnd());
						fs.setFeatureValue(dsContextDs, ds);

						editor.addAnnotation(fs);

						break;
					}

					else if (selection.x < ds.getEnd() && selection.y > ds.getEnd()) {

						AnnotationFS fs = editor.getCas().createAnnotation(dsContextType, ds.getBegin(), selection.y);
						fs.setFeatureValue(dsContextDs, ds);
						editor.addAnnotation(fs);

						break;
					}

				}

			}

			@Override
			public void widgetDefaultSelected(SelectionEvent e) {
				widgetSelected(e);

			}
		});

		buttondeleteContext = new Button(comp2, SWT.PUSH);
		buttondeleteContext.setText("Delete Context");
		buttondeleteContext.addSelectionListener(new SelectionListener() {

			@Override
			public void widgetSelected(SelectionEvent e) {

				AnnotationFS selected = null;
				if (editor.getCurrentSelectionOfType(typ).size() > 0) {
					for (AnnotationFS anno : editor.getCurrentSelectionOfType(typ)) {
						if (anno.getType().equals(typ)) {
							selected = anno;

						}
					}
				}

				if (selected != null) {

					for (AnnotationFS context : editor.getCas().getAnnotationIndex(dsContextType)) {

						AnnotationFS featureValue = (AnnotationFS) context.getFeatureValue(dsContextDs);

						if (featureValue != null && featureValue.getBegin() == selected.getBegin()) {
							selected.setFeatureValue(dsContextDs, null);
							editor.removeAnnotation(context);
						}
					}
				}

			}

			@Override
			public void widgetDefaultSelected(SelectionEvent e) {
				widgetSelected(e);

			}
		});

		// // ==== Table
		comp2.setSize(overlay.getSize());

		Composite compp = new Composite(overlay, SWT.NULL);

		compp.setVisible(true);

		GridLayout lay = new GridLayout(2, false);
		compp.setLayout(lay);

		// jumplabel is always visible and only affects the attribute jump
		Label noJumpLabel = new Label(compp, SWT.NONE);
		noJumpLabel.setText("Jump to next?: ");
		jumpButton = new Button(compp, SWT.CHECK);
		jumpButton.setLayoutData(new GridData(GridData.GRAB_HORIZONTAL | GridData.HORIZONTAL_ALIGN_FILL));
		jumpButton.setSelection(true);

		// add togglebuttons

		Composite compp2 = new Composite(compp, SWT.NULL);

		GridData toggleData = new GridData();
		toggleData.horizontalSpan = 2;
		toggleData.horizontalIndent = 0;
		compp2.setLayoutData(toggleData);

		compp2.setVisible(true);

		compp2.setLayout(lay);

		// from here everything is exchangeable

		initPersonTable(compp);

	}

	private Image getPersonImage() {

		if (personImage != null) {
			return personImage;
		}

		else {
			personImage = ApplicationUtil.createImage(ApplicationUtil.WSD_CAT_MENSCH);
		}
		return personImage;
	}

	private Image getAttributeImage() {

		if (atributeImage != null) {
			return atributeImage;
		}

		else {
			atributeImage = ApplicationUtil.createImage(ApplicationUtil.WSD_CAT_ATTRIBUT);
		}
		return atributeImage;
	}

	private void initAttributeTable(Composite compp) {

		Label searchLabel = new Label(compp, SWT.NONE);
		searchLabel.setText("Search: ");
		final Text searchText = new Text(compp, SWT.BORDER | SWT.SEARCH);
		searchText.setLayoutData(new GridData(GridData.GRAB_HORIZONTAL | GridData.HORIZONTAL_ALIGN_FILL));

		// content
		GridData gridData = new GridData(GridData.FILL_VERTICAL);
		gridData.horizontalSpan = 2;
		gridData.grabExcessHorizontalSpace = true;
		gridData.grabExcessVerticalSpace = true;
		gridData.horizontalAlignment = GridData.FILL;
		compp.setLayoutData(gridData);
		// New to support the search

		searchText.addKeyListener(new KeyAdapter() {
			public void keyReleased(KeyEvent ke) {
				filter.setSearchText(searchText.getText());
			}

		});

		// TODO adjust the filter for both tables !!
		// filter
		filter = new NameFilter();

		// id filter

		createTableViewer();

		// this.colViewerAttView = new ColViewerComparatorAttributeView(attId,
		// attPriority, this);
		// attributeTableViewer.setComparator(colViewerAttView);

	}

	private void initPersonTable(Composite compp) {

		frameFilterLabel = new Label(compp, SWT.NONE);
		frameFilterLabel.setText("Frame Filter:");
		frameFilterButton = new Button(compp, SWT.CHECK);
		frameFilterButton.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				try {
					renewPage();
				} catch (CASException e1) {
					e1.printStackTrace();
				}
			}
		});

		// searchLabel
		Label searchLabel = new Label(compp, SWT.NONE);
		searchLabel.setText("Search: ");
		final Text searchText = new Text(compp, SWT.BORDER | SWT.SEARCH);
		searchText.setLayoutData(new GridData(GridData.GRAB_HORIZONTAL | GridData.HORIZONTAL_ALIGN_FILL));

		viewer = new TableViewer(compp, SWT.MULTI | SWT.H_SCROLL | SWT.V_SCROLL | SWT.FULL_SELECTION | SWT.BORDER
				| SWT.FILL);

		createPersonTableColumns(viewer);

		// add Menu
		// MenuListener
		final Menu menu = new Menu(viewer.getControl());
		viewer.getControl().setMenu(menu);

		// GoTo
		MenuItem goTo = new MenuItem(menu, SWT.None);

		goTo.setText("GoTo Selected Annotation");

		goTo.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent event) {

				IStructuredSelection sel = (IStructuredSelection) viewer.getSelection();

				AnnotationFS firstElement = (AnnotationFS) sel.getFirstElement();

				int beg = firstElement.getBegin();

				changeHighlighting(beg, firstElement.getEnd(), true);

			}

		});

		viewer.getTable().addListener(SWT.MouseDoubleClick, new Listener() {

			@Override
			public void handleEvent(Event e) {
				// get the selected item
				String id = null;
				IStructuredSelection sel = (IStructuredSelection) viewer.getSelection();

				AnnotationFS selected = (AnnotationFS) sel.getFirstElement();
				if (selected == null) {
					return;
				}

				id = selected.getFeatureValueAsString(neId);

				ViewerCell cell = viewer.getCell(lastClick);

				if (cell == null)
					return;
				int columnIndex = cell.getColumnIndex();
				Feature selF = null;
				if (columnIndex == 2) {
					selF = speakerFeature;
				}

				if (columnIndex == 3) {
					selF = spokenToFeature;
				}

				if (selF == null)
					return;

				// get the selection in the cas editor

				Point pSelect = editor.getActualSelectedText();

				List<AnnotationFS> actualSelection = editor.getCurrentSelectionOfType(typ);
				if (pSelect.y - pSelect.x == 0) {
					// here we update the Features of the annotation

					System.out.println("NullSpan " + actualSelection.size());
					if (actualSelection != null && actualSelection.size() > 0) {
						AnnotationFS anno = actualSelection.get(0);

						anno.setFeatureValue(selF, selected);

						// still need to differentiate..

						updateSpeakerArrays(selF, anno, selected);

						// hack to reload
						updateAnnotation(selected, neId, id, true);
					}
				}

				else {

					if (actualSelection.size() == 1) {
						// update the Annotation
						AnnotationFS ano = actualSelection.get(0);

						if (ano.getType().getName().equals(typ.getName())) {

							ano.setFeatureValue(selF, selected);
							updateSpeakerArrays(selF, ano, selected);
							// hack to reload
							updateAnnotation(selected, neId, id, true);

						}

					}

				}

				if (actualSelection.size() > 0) {
					editor.changeAnnotation(actualSelection.get(0));
				}

			}

			private void updateSpeakerArrays(Feature selF, AnnotationFS ds, AnnotationFS selected) {

				if (selF.getName().contains("SpokenTo")) {
					ArrayFSImpl spokArray = (ArrayFSImpl) ds.getFeatureValue(spokenToArrayFeature);

					int size = 1;
					if (spokArray != null)
						size = spokArray.size() + 1;

					ArrayFSImpl arrayNew = (ArrayFSImpl) editor.getCas().createArrayFS(size);

					if (spokArray == null) {
						arrayNew.set(0, selected);
					}

					else {

						for (int i = 0; i < spokArray.size(); i++) {
							arrayNew.set(i, spokArray.get(i));
						}
						arrayNew.set(arrayNew.size() - 1, selected);
					}

					ds.setFeatureValue(spokenToArrayFeature, arrayNew);

				}

				// speaker
				else {
					ArrayFSImpl speakerArray = (ArrayFSImpl) ds.getFeatureValue(speakerArrayFeature);

					int size = 1;
					if (speakerArray != null)
						size = speakerArray.size() + 1;

					ArrayFSImpl arrayNew = (ArrayFSImpl) editor.getCas().createArrayFS(size);

					if (speakerArray == null) {
						arrayNew.set(0, selected);
					}

					else {

						for (int i = 0; i < speakerArray.size(); i++) {
							arrayNew.set(i, speakerArray.get(i));
						}
						arrayNew.set(arrayNew.size() - 1, selected);
					}

					ds.setFeatureValue(speakerArrayFeature, arrayNew);
				}
			}

		});

		// add keyListener to detect a ctrl pressed event

		controlPressed = false;
		viewer.getTable().addKeyListener(new KeyListener() {

			@Override
			public void keyReleased(KeyEvent e) {
				if ((e.stateMask & SWT.CTRL) == SWT.CTRL) {

					controlPressed = false;
				}

			}

			@Override
			public void keyPressed(KeyEvent e) {
				if ((e.keyCode & SWT.CTRL) == SWT.CTRL) {

					controlPressed = true;
				}

			}
		});

		viewer.getTable().addListener(SWT.MouseUp, new Listener() {

			@Override
			public void handleEvent(Event event) {

				lastClick = new Point(event.x, event.y);

			}
		});

		// make lines and header visible
		final Table table = viewer.getTable();
		table.setHeaderVisible(true);
		table.setLinesVisible(true);

		// content
		viewer.setContentProvider(ArrayContentProvider.getInstance());
		GridData gridData = new GridData(GridData.FILL_VERTICAL);
		gridData.horizontalSpan = 2;
		gridData.grabExcessHorizontalSpace = true;
		gridData.grabExcessVerticalSpace = true;
		gridData.horizontalAlignment = GridData.FILL;
		viewer.getControl().setLayoutData(gridData);
		compp.setLayoutData(gridData);
		// New to support the search

		searchText.addKeyListener(new KeyAdapter() {
			public void keyReleased(KeyEvent ke) {
				filter.setSearchText(searchText.getText());
				viewer.refresh();
			}

		});

		// filter
		filter = new NameFilter();
		viewer.addFilter(filter);

		// id filter

		// frame filter
		frameFilter = new FrameFilterAttViewPersonTable();
		viewer.addFilter(frameFilter);

		// colViewerComp = new ColViewerComparatorAttributeViewPersonTable(neId,
		// this);
		// viewer.setComparator(colViewerComp);
		createTableViewer();
		// comparator

		// TODO comparator

		ColumnViewerToolTipSupport.enableFor(viewer, ToolTip.NO_RECREATE);
	}

	public void renewPage() throws CASException {

		annoListPersons = new ArrayList<AnnotationFS>();

		for (AnnotationFS person : editor.getCas().getAnnotationIndex(neType)) {
			annoListPersons.add(person);
		}

		// also check the categories of the ds annos if it is null we set to
		// directspeech

		for (AnnotationFS ds : editor.getCas().getAnnotationIndex(typ)) {

			String cat = ds.getFeatureValueAsString(dsCategoryfeature);

			if (cat == null) {
				ds.setFeatureValueFromString(dsCategoryfeature, "directspeech");
			}
		}

		Runnable r = new Runnable() {

			@Override
			public void run() {

				createTableViewer();

			}
		};

		// reload asynchronous
		overlay.getDisplay().asyncExec(r);

	}

	private void createTableViewer() {

		Integer maxId = 0;

		maxId = 0;
		for (AnnotationFS annot : this.annoListPersons) {
			if (annot.getFeatureValueAsString(neId) != null && annot.getFeatureValueAsString(neId) != "") {
				Integer ids = Integer.parseInt(annot.getFeatureValueAsString(neId));
				if (ids > maxId) {
					maxId = ids;
				}
			}
		}

		// set null features of person annotations

		// set input of Tableviewer
		viewer.setInput(annoListPersons.toArray(new AnnotationFS[0]));
		viewer.refresh();
		// ???? why !

	}

	private void createPersonTableColumns(TableViewer viewer) {

		TableViewerColumn colName = createTableViewerColumn(viewer, "Name", 100, 0);
		colName.setLabelProvider(new ColumnLabelProvider() {
			@Override
			public String getText(Object element) {
				AnnotationFS p = (AnnotationFS) element;
				return p.getCoveredText();

			}

		});

		TableViewerColumn colID = createTableViewerColumn(viewer, "ID", 50, 1);
		colID.setLabelProvider(new ColumnLabelProvider() {
			@Override
			public String getText(Object element) {
				AnnotationFS p = (AnnotationFS) element;

				return p.getFeatureValueAsString(neId);
			}
		});

		TableViewerColumn colSpeaker = createTableViewerColumn(viewer, "Speaker", 50, 2);
		colSpeaker.setLabelProvider(new ColumnLabelProvider() {
			@Override
			public String getText(Object element) {

				return "Click";
			}
		});

		TableViewerColumn colSpokenTo = createTableViewerColumn(viewer, "SpokenTo", 50, 3);
		colSpokenTo.setLabelProvider(new ColumnLabelProvider() {
			@Override
			public String getText(Object element) {

				return "Click";
			}
		});

	}

	private TableViewerColumn createTableViewerColumn(TableViewer viewer, String viewer2, int bound, final int colNumber) {
		final TableViewerColumn viewerColumn = new TableViewerColumn(viewer, SWT.NONE);
		final TableColumn column = viewerColumn.getColumn();
		column.setText(viewer2);
		column.setWidth(bound);
		column.setResizable(true);
		column.setMoveable(true);
		column.addSelectionListener(getSelectionAdapter(viewer, column, colNumber));
		return viewerColumn;
	}

	private SelectionAdapter getSelectionAdapter(final TableViewer viewer2, final TableColumn column, final int index) {

		SelectionAdapter selectionAdapter = new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {

				colViewerComp.setColumn(index);
				int dir = colViewerComp.getDirection();
				viewer2.getTable().setSortDirection(dir);
				viewer2.getTable().setSortColumn(column);
				viewer2.refresh();
			}
		};
		return selectionAdapter;
	}

	// Methods to change the CAS
	private void deleteAnnotation(AnnotationFS firstElement) {

		// delete all overrides in that stage

		ArrayList<AnnotationFS> toDelete = new ArrayList<AnnotationFS>();
		AnnotationIndex<AnnotationFS> annotationIndex = editor.getCas().getAnnotationIndex(dSBegEndType);
		for (AnnotationFS anno : annotationIndex) {
			if (anno.getBegin() == firstElement.getBegin() && anno.getEnd() == firstElement.getEnd()) {
				toDelete.add(anno);
				// editor.removeAnnotation(anno);
			}
		}

		AnnotationIndex<AnnotationFS> annotationIndex2 = editor.getCas().getAnnotationIndex(dSBegEndType2);
		for (AnnotationFS anno : annotationIndex2) {
			if (anno.getBegin() == firstElement.getBegin() && anno.getEnd() == firstElement.getEnd()) {
				toDelete.add(anno);
				// editor.removeAnnotation(anno);
			}
		}

		for (AnnotationFS a : toDelete) {
			editor.removeAnnotation(a);
		}

		editor.removeAnnotation(firstElement);

	}

	private void updateAnnotation(AnnotationFS firstElement, Feature feat, String string, boolean reload) {

		// if (feat.getName().equals(idFeat.getName())) {
		// String oldId = firstElement.getFeatureValueAsString(idFeat);
		// ICorefResolvingStrategy naiveResolver = new
		// NaiveResolvingStrategy(typ, typOverride, idFeat, oldId, string);
		// naiveResolver.resolve(editor.getCas(), firstElement);
		// }

		firstElement.setFeatureValueFromString(feat, string);

		// add a true positive - only if none was already on this place - since
		// update is called alot
		// add a false negative

		if (reload) {
			AnnotationFS fss = editor.getCas().createAnnotation(typ, firstElement.getBegin(), firstElement.getEnd());

			this.editor.removeAnnotation(fss);
		}
	}

	// boolean moveCursor
	private void changeHighlighting(int beg, int end, boolean b) {
		editor.highlightRange(beg, end - beg, true);

	}

	private void addAnnotation(AnnotationFS anno) {

		// add Annotation - means we add an Annotation of type NER also an
		// Override Type
		// to display that this annotation was already handled

		this.editor.addAnnotation(anno);

		// add the ds temp
		CAS cas = this.editor.getCas();

		AnnotationFS fs = cas.createAnnotation(dSBegEndType, anno.getBegin(), anno.getEnd());

		this.editor.addAnnotation(fs);

	}

	// boolean moveCursor

	public AnnotationEditorWidget getEditor() {
		return editor;
	}

	public TableViewer getViewer() {
		return viewer;
	}

	public void setViewer(TableViewer viewer) {
		this.viewer = viewer;
	}

	public Text getNeuEnt() {
		return neuEnt;
	}

	public void setNeuEnt(Text neuEnt) {
		this.neuEnt = neuEnt;
	}

	@PreDestroy
	public void preDestroy() {
		// TODO Your code here
	}

	@Focus
	public void onFocus() {

		super.onFocus();

	}

	@Persist
	public void save() {
		black.dispose();
		red.dispose();
		green.dispose();
		white.dispose();
		blue.dispose();
		dsOne.dispose();
		dsTwo.dispose();
		dsContext.dispose();
	}

	@Override
	public void onAnnotationAdded(org.osgi.service.event.Event e) {
		AnnotationFS added = (AnnotationFS) e.getProperty(IEventBroker.DATA);

		try {
			renewPage();
		} catch (CASException ev) {
			ev.printStackTrace();
		}

		if (getJumpButton().getSelection()) {

			// TODO dirty solution
			AnnotationFS toHIghlight = getNextToHighLight(added);

			if (toHIghlight != null) {
				getEditor().highlightRange(toHIghlight.getBegin(), toHIghlight.getEnd() - toHIghlight.getBegin(), true);

				getEditor().setSelection(toHIghlight);
			}

		}

	}

	private AnnotationFS getNextToHighLight(AnnotationFS added) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void onAnnotationRemoved(org.osgi.service.event.Event arg0) {
		AnnotationFS removed = (AnnotationFS) arg0.getProperty(IEventBroker.DATA);
		try {
			renewPage();
		} catch (CASException e) {
			e.printStackTrace();
		}

		if (getJumpButton().getSelection()) {
			AnnotationFS toHIghlight = getNextToHighLight(removed);

			if (toHIghlight != null) {
				getEditor().highlightRange(toHIghlight.getBegin(), toHIghlight.getEnd() - toHIghlight.getBegin(), true);

				getEditor().setSelection(toHIghlight);
			}
		}

	}

	@Override
	public void onAnnotationChanged(org.osgi.service.event.Event arg0) {
		// TODO Auto-generated method stub

	}

	@Override
	public void onAnnotationSelectionChanged(org.osgi.service.event.Event arg0) {
		// TODO Auto-generated method stub

	}

	@Override
	public void onEditorDoubleClicked(org.osgi.service.event.Event arg0) {
		// TODO Auto-generated method stub

	}

	@Override
	public void onEditorWasScrolled(org.osgi.service.event.Event arg0) {
		Point visible = (Point) arg0.getProperty(IEventBroker.DATA);

		// change the annotations of the framefilter

		List<AnnotationFS> visibleList = new ArrayList<AnnotationFS>();
		for (AnnotationFS a : editor.getCas().getAnnotationIndex(neType)) {

			int lineAtOffset = editor.getLineAtOffset(a.getEnd());
			int topLine = visible.y;
			int bottomLine = visible.x;

			if (lineAtOffset >= topLine && lineAtOffset <= bottomLine) {
				visibleList.add(a);
			}
		}

		if (frameFilter != null) {
			frameFilter.setAnnotations(visibleList, frameFilterButton.getSelection());
		}

		try {
			renewPage();
		} catch (CASException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}

	@Override
	public void onEditorCaretChanged(org.osgi.service.event.Event arg0) {
		int caretOffset = (int) arg0.getProperty(IEventBroker.DATA);

		// highlight the according annotation in the table
		AnnotationFS selectedAnno = null;
		for (AnnotationFS neAnno : editor.getCas().getAnnotationIndex(neType)) {

			if (neAnno.getBegin() <= caretOffset && neAnno.getEnd() >= caretOffset) {

				selectedAnno = neAnno;
				break;
			}
		}

		if (selectedAnno != null) {

			// hihglight in table
			IStructuredSelection sel = new StructuredSelection(selectedAnno);
			viewer.setSelection(sel, true);

		}

		// if it is inside a DS annotation we need to attach the
		// temporary types

		// step1 delete speaker and spokenTo and also temporary context
		// types
		ArrayList<AnnotationFS> speakerAnnos = new ArrayList<AnnotationFS>();
		for (AnnotationFS a : editor.getCas().getAnnotationIndex(speakerType)) {
			speakerAnnos.add(a);
		}
		for (AnnotationFS a : editor.getCas().getAnnotationIndex(spokenToType)) {
			speakerAnnos.add(a);
		}

		for (AnnotationFS contextTemp : editor.getCas().getAnnotationIndex(typeTempContextDS)) {
			speakerAnnos.add(contextTemp);
		}

		for (AnnotationFS b : speakerAnnos) {
			editor.removeAnnotation(b);
		}
		// check if a DS is covered - always use the smallest DS
		AnnotationFS coveringDS = null;

		for (AnnotationFS ds : editor.getCas().getAnnotationIndex(typ)) {

			if (ds.getBegin() <= caretOffset && ds.getEnd() >= caretOffset) {
				if (coveringDS == null) {
					coveringDS = ds;
				} else {

					// overwrite with a smaller one
					if (ds.getBegin() >= coveringDS.getBegin() && ds.getEnd() <= coveringDS.getEnd()) {
						coveringDS = ds;
					}
				}
			}

		}

		if (coveringDS != null) {

			// TODO dirty

			// update the category field

			String featureValueAsString = coveringDS.getFeatureValueAsString(dsCategoryfeature);
			if (featureValueAsString == null) {
				coveringDS.setFeatureValueFromString(dsCategoryfeature, "directspeech");
				featureValueAsString = "directspeech";
			}
			textCategory.setText(featureValueAsString);

			// update unknown speaker/spokTo checkboxes

			String unkSpeaker = coveringDS.getFeatureValueAsString(unknownSpeakerFeature);
			String unkSpokenTo = coveringDS.getFeatureValueAsString(unknownSpokenToFeature);

			if (unkSpeaker != null && unkSpeaker.startsWith("t")) {

				buttonUnknownSpeaker.setSelection(true);

			}

			else if (unkSpeaker != null && !unkSpeaker.startsWith("t")) {
				buttonUnknownSpeaker.setSelection(false);

			}

			else {
				buttonUnknownSpeaker.setSelection(false);
			}

			if (unkSpokenTo != null && unkSpokenTo.startsWith("t")) {

				buttonUnknownSpokenTo.setSelection(true);
			}

			else if (unkSpokenTo != null && !unkSpokenTo.startsWith("t")) {

				buttonUnknownSpokenTo.setSelection(false);

			}

			else {
				buttonUnknownSpokenTo.setSelection(false);
			}
			// get the speaker of that anno
			ArrayFSImpl speakerNEArray = (ArrayFSImpl) coveringDS.getFeatureValue(speakerArrayFeature);

			if (speakerNEArray != null) {
				for (int i = 0; i < speakerNEArray.size(); i++) {
					AnnotationFS speakerNE = (AnnotationFS) speakerNEArray.get(i);
					AnnotationFS createAnnotation = editor.getCas().createAnnotation(speakerType, speakerNE.getBegin(),
							speakerNE.getEnd());

					editor.addAnnotation(createAnnotation);
				}
			}
			// also add spokenToAnnotation if possible

			ArrayFSImpl spokenToNEArray = (ArrayFSImpl) coveringDS.getFeatureValue(spokenToArrayFeature);

			if (spokenToNEArray != null) {
				for (int i = 0; i < spokenToNEArray.size(); i++) {
					AnnotationFS spokenTo = (AnnotationFS) spokenToNEArray.get(i);
					AnnotationFS createAnnotationFS = editor.getCas().createAnnotation(spokenToType,
							spokenTo.getBegin(), spokenTo.getEnd());

					editor.addAnnotation(createAnnotationFS);
				}
			}

			// update context if possible !!

			boolean contextFound = false;
			for (AnnotationFS context : editor.getCas().getAnnotationIndex(dsContextType)) {

				AnnotationFS ds = (AnnotationFS) context.getFeatureValue(dsContextDs);

				if (ds.getBegin() == coveringDS.getBegin()) {

					// add the temp types
					AnnotationFS createAnnotation = editor.getCas().createAnnotation(typeTempContextDS,
							context.getBegin(), context.getEnd());
					editor.addAnnotation(createAnnotation);
					contextFound = true;

					String contextValue = context.getFeatureValueAsString(dsContextCategory);
					if (contextValue != null) {
						textCategoryContext.setText(contextValue);
					} else {
						textCategoryContext.setText("null");
					}
				}
			}

			if (!contextFound) {
				textCategoryContext.setText("no Contextfound");
			}
		}

		else {

			// update UI Elements
			buttonUnknownSpeaker.setSelection(false);
			buttonUnknownSpokenTo.setSelection(false);
			textCategory.setText("No Directspeech selected!");

			// update if you find a dscontext
			boolean contextFound = false;
			for (AnnotationFS context : editor.getCas().getAnnotationIndex(dsContextType)) {

				if (context.getBegin() <= caretOffset && context.getEnd() >= caretOffset) {

					// add the temp types
					AnnotationFS createAnnotation = editor.getCas().createAnnotation(typeTempContextDS,
							context.getBegin(), context.getEnd());
					editor.addAnnotation(createAnnotation);

					contextFound = true;
					String contextValue = context.getFeatureValueAsString(dsContextCategory);
					if (contextValue != null) {
						textCategoryContext.setText(contextValue);
					}
				}
			}

			if (!contextFound) {

				textCategoryContext.setText("No Context Selected");
			}

		}
	}

	@Override
	public void onEditorTextSelectionChanged(org.osgi.service.event.Event arg0) {
		Point point = (Point) arg0.getProperty(IEventBroker.DATA);

		// set the Textfield
		getNeuEnt().setText(getEditor().getWidget().getText().substring(point.x, point.y));

		// if we got the span of an annotation also create the selection
		// in the
		// tableviewer

		// update the last selections
		if (Math.abs(point.x - point.y) > 0) {
			actualTextSelection = point;

		}

	}

	@Override
	public void onEditorMouseMoved(org.osgi.service.event.Event e) {
		// TODO Auto-generated method stub

	}

	@Override
	public void initModel() {
		// init AnnoLists

		// copy from old struct to new one
		copyDatastructures();

		annoListPersons = new ArrayList<AnnotationFS>();
		for (AnnotationFS a : editor.getCas().getAnnotationIndex(neType)) {
			annoListPersons.add(a);
		}

	}

}