package de.uniwue.mkrug.kallimachos.annotation.editor.ui;

import javax.annotation.PostConstruct;
import javax.annotation.PreDestroy;
import javax.inject.Inject;

import org.eclipse.e4.ui.di.Focus;
import org.eclipse.e4.ui.di.Persist;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.PaintEvent;
import org.eclipse.swt.events.PaintListener;
import org.eclipse.swt.graphics.GC;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.ImageData;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;

import de.uniwue.mk.kall.athen.appDelegation.util.ApplicationUtil;

public class LetSaulenPart {
	private Image img;

	@Inject
	public LetSaulenPart() {
		// TODO Your code here
	}

	@PostConstruct
	public void postConstruct(Composite parent) {

		System.out.println(parent.getBackground());

		Label l = new Label(parent, SWT.NONE);
		img = ApplicationUtil.createImage("icons/saeule.gif");

		ImageData ideaImageData = img.getImageData();
		int[] lineData = new int[ideaImageData.width];
		for (int y = 0; y < ideaImageData.height; y++) {
			ideaImageData.getPixels(0, y, img.getImageData().width, lineData, 0);
			// Analyze each pixel value in the line
			for (int x = 0; x < lineData.length; x++) {
				// Extract the red, green and blue component
				int pixelValue = lineData[x];
				// the white
				if (pixelValue == 157) {
					// composite background
					ideaImageData.setPixel(x, y, 155);
				}
			}
		}

		img = new Image(Display.getCurrent(), ideaImageData);

		l.addPaintListener(new PaintListener() {

			private int lastWidth = -1;
			private int lastHeight = -1;

			@Override
			public void paintControl(PaintEvent e) {

				int width = parent.getBounds().width;
				int height = parent.getBounds().height;

				if (width == lastWidth && height == lastHeight)
					return;

				Image scaled = new Image(Display.getDefault(), width, height);
				GC g2 = new GC(scaled);
				g2.setAntialias(SWT.ON);
				g2.setInterpolation(SWT.HIGH);

				g2.drawImage(img, 0, 0, img.getBounds().width, img.getBounds().height, 0, 0, width, height);

				lastHeight = height;
				lastWidth = width;
				l.setImage(scaled);
				g2.dispose();

			}
		});
	}

	@PreDestroy
	public void preDestroy() {
		img.dispose();
	}

	@Focus
	public void onFocus() {
		// TODO Your code here
	}

	@Persist
	public void save() {
		// TODO Your code here
	}

}