package de.uniwue.mkrug.kallimachos.annotation.editor.wizard;

import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.nio.file.Files;

import org.eclipse.e4.core.services.events.IEventBroker;
import org.eclipse.jface.wizard.Wizard;
import org.eclipse.swt.widgets.Text;

import de.uniwue.mk.kall.athen.appDelegation.util.ApplicationPreferences;
import de.uniwue.mk.kall.athen.appDelegation.util.ApplicationUtil;
import de.uniwue.mk.kall.athen.events.IAnnotationEditorEvents;
import de.uniwue.mk.kall.athen.projectExplorer.projectDescription.AnnotationProject;
import de.uniwue.mk.kall.athen.projectExplorer.projectDescription.AnnotationProjectDescriptor;
import de.uniwue.mk.kall.athen.projectExplorer.projectDescription.IAnnotationProject;

public class NewProjectWizard extends Wizard {
	private static String fileSeparator = System.getProperty("file.separator");

	// private IEclipseContext eclipseContext;
	//
	// IEventBroker eventBroker = eclipseContext.get(IEventBroker.class);

	IEventBroker eventBroker;

	NewProjectWizardPage page;

	public NewProjectWizard(IEventBroker eventBroker) {
		this.eventBroker = eventBroker;
	}

	public void addPages() {

		page = new NewProjectWizardPage("Project Creation Wizard");
		addPage(page);

	}

	@Override
	public boolean performFinish() {

		// create the project with the set name

		Text projectName = page.getProjectName();

		// TODO CHECK IF THAT PROJECT EXISTS or not ??
		File newProjectRoot = new File(ApplicationUtil.getFromPreferences(ApplicationPreferences.WORKSPACE, "null")
				+ fileSeparator + projectName.getText());

		for (String folder : ProjectNatureDescriptor.MANDATORY_FOLDERS) {
			File child = new File(newProjectRoot.getAbsolutePath() + fileSeparator + folder);

			boolean mkdir = child.mkdirs();

			if (folder.equals(AnnotationProjectDescriptor.DESCRIPTOR_FOLDER)) {
				// add the default typesystem

				InputStream source = ApplicationUtil.getBundleRessourceAsStream("/ressources/CorefTypeSystem.xml");
				File target = new File(child.getAbsolutePath() + fileSeparator + "CorefTypeSystem.xml");
				try {
					Files.copy(source, target.toPath());
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}

		}

		IAnnotationProject proj = new AnnotationProject(newProjectRoot);

		// this event will reload the the projectexplorer
		eventBroker.send(IAnnotationEditorEvents.RELOAD_PROJECTS, proj);

		return true;
	}
}
