package de.uniwue.mkrug.mainMenu.handler;

import javax.inject.Inject;

import org.eclipse.e4.core.di.annotations.CanExecute;
import org.eclipse.e4.core.di.annotations.Execute;
import org.eclipse.e4.core.services.events.IEventBroker;
import org.eclipse.swt.widgets.DirectoryDialog;
import org.eclipse.swt.widgets.Shell;

import de.uniwue.mk.kall.athen.appDelegation.util.ApplicationPreferences;
import de.uniwue.mk.kall.athen.appDelegation.util.ApplicationUtil;
import de.uniwue.mk.kall.athen.events.IAnnotationEditorEvents;

public class ChangeWorkSpaceHandler {

	String APPLICATION_ID = "de.uniwue.mkrug.kallimachos.annotation.editor";

	/*
	 * opens a jFace FileChooser where one can specifiy the workspace
	 */

	@Inject
	IEventBroker broker;

	@Execute
	public void execute(Shell shell, IEventBroker eventBroker) {

		DirectoryDialog dialog = new DirectoryDialog(shell);
		dialog.setMessage("Choose a directory as workspace");
		String selection = dialog.open();

		// Save to preferences

		if (selection != null) {
			ApplicationUtil.saveToPreferences(ApplicationPreferences.WORKSPACE, selection);

			// TODO exception when you cancle the dialogue
			// notifiy the diffrent parts

			eventBroker.send(IAnnotationEditorEvents.WORKSPACE_CHANGED_EVENT, selection);

		}
	}

	@CanExecute
	public boolean canExecute() {
		// TODO Your code goes here
		return true;
	}

}