package de.uniwue.mkrug.mainMenu.handler;

import javax.inject.Inject;

import org.eclipse.e4.core.di.annotations.CanExecute;
import org.eclipse.e4.core.di.annotations.Execute;
import org.eclipse.e4.core.services.events.IEventBroker;
import org.eclipse.jface.wizard.WizardDialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;

import de.uniwue.mk.kall.athen.appDelegation.util.ApplicationPreferences;
import de.uniwue.mk.kall.athen.appDelegation.util.ApplicationUtil;
import de.uniwue.mkrug.kallimachos.annotation.editor.wizard.NewProjectWizard;

public class NewProjectHandler {

	String APPLICATION_ID = "de.uniwue.mkrug.kallimachos.annotation.editor";

	@Inject
	private IEventBroker eventBroker;

	@Execute
	public void execute(Shell shell) {

		String wsPref = ApplicationUtil.getFromPreferences(ApplicationPreferences.WORKSPACE, "nope");

		if (wsPref.equals("nope")) {
			ChangeWorkSpaceHandler handler = new ChangeWorkSpaceHandler();
			handler.execute(Display.getCurrent().getActiveShell(), eventBroker);
		}

		NewProjectWizard wizard = new NewProjectWizard(eventBroker);

		WizardDialog dialog = new WizardDialog(shell, wizard);
		dialog.create();
		int open = dialog.open();

		if (open == 0) {

			if (!dialog.getCurrentPage().getControl().isDisposed()) {
				dialog.close();
			}
		}
		// set initial input - load ws directory from preferences

	}

	@CanExecute
	public boolean canExecute() {
		// TODO Your code goes here
		return true;
	}

}