package de.uniwue.mkrug.mainMenu.handler;

import org.eclipse.e4.core.di.annotations.Execute;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Shell;

import de.uniwue.mk.kall.athen.luceneView.LuceneView;

public class ShowLuceneViewHandler {
	private static Shell shell;


	@Execute
	public void execute(Shell pshell) {
		/*
		 * Open a shell to display the LuceneView. 
		 * If it is already displayed in a shell, bring the shell to the foreground instead. 
		 */
		if (shell == null) {
			shell = new Shell(SWT.CLOSE | SWT.TITLE | SWT.RESIZE | SWT.MAX | 
					SWT.MIN | SWT.MODELESS);
			shell.setText("Lucene View");
			shell.setLayout(new GridLayout());
			new LuceneView(shell, SWT.BORDER);
			shell.addDisposeListener(event -> shell = null);
			shell.pack();
			shell.open();
		} else {
			shell.setActive();
		}
	}
}
