package de.uniwue.mkrug.mainMenu.handler;

import java.util.List;

import javax.inject.Inject;

import org.eclipse.e4.core.di.annotations.Execute;
import org.eclipse.e4.ui.model.application.MApplication;
import org.eclipse.e4.ui.model.application.ui.advanced.MPerspective;
import org.eclipse.e4.ui.model.application.ui.basic.MPart;
import org.eclipse.e4.ui.model.application.ui.basic.MWindow;
import org.eclipse.e4.ui.workbench.modeling.EModelService;
import org.eclipse.e4.ui.workbench.modeling.EPartService;
import org.eclipse.swt.widgets.Shell;

import de.uniwue.mkrug.kallimachos.annotations.editor.dialogues.ViewVisibilityDialog;

public class ViewVisibilityHandler {

	@Inject
	EPartService partService;

	@Inject
	EModelService modelService;

	@Inject
	MApplication app;

	@Execute
	public void execute(Shell shell) {

		// get the active perspective

		// get the window
		List<MWindow> findElements = modelService.findElements(app, null, MWindow.class, null);

		// use the window to find the active perspective

		MPerspective activePerspective = modelService.getActivePerspective(findElements.get(0));

		// get all parts in the active perspective

		List<MPart> activeParts = modelService.findElements(activePerspective, null, MPart.class, null);

		// open the dialog to display the visibility

		ViewVisibilityDialog dialog = new ViewVisibilityDialog(shell, partService, modelService, activeParts);

		dialog.open();

		// since bug in dialog //TODO this causes problems

		for (MPart p : activeParts) {

			if (p.isVisible()) {
				partService.activate(p);
			}
		}

	}
}
